//=============================================================================
// OLBroadcastHandler
//=============================================================================

class OLBroadcastHandler extends BroadcastHandler;

var OLLocalGameStats GS;

var BroadcastHandler oldHandler;

function Broadcast( Actor Sender, coerce string Msg, optional name Type )
{
    local PlayerReplicationInfo PRI;

    // see if allowed (limit to prevent spamming)
    if ( !AllowsBroadcast(Sender, Len(Msg)) )
        return;

    if ( Pawn(Sender) != None )
        PRI = Pawn(Sender).PlayerReplicationInfo;
    else if ( Controller(Sender) != None )
        PRI = Controller(Sender).PlayerReplicationInfo;

    //Send to GameStats
    if (GS != none && Sender != none)
    {
        if ( Sender.IsA('xVotingHandler') )
            GS.LogVoteChat(Msg);
        else
            GS.LogChat(PRI, Msg, "V");
    }

    if (oldHandler != none)
        oldHandler.Broadcast(Sender, Msg, Type);
}

function BroadcastTeam( Controller Sender, coerce string Msg, optional name Type )
{
    local PlayerReplicationInfo PRI;

    // see if allowed (limit to prevent spamming)
    if ( !AllowsBroadcast(Sender, Len(Msg)) )
        return;

    PRI = Sender.PlayerReplicationInfo;
    //Send to GameStats
    if (GS != none)
        GS.LogChat(PRI, Msg, "TV");

    if (oldHandler != none)
        oldHandler.BroadcastTeam(Sender, Msg, Type);
}

function UpdateSentText()
{
    if (oldHandler != none)
        oldHandler.UpdateSentText();
}

function bool AllowsBroadcast( actor Broadcaster, int Len )
{
    if (oldHandler != none)
        return oldHandler.AllowsBroadcast(Broadcaster, Len);
  return false;
}

function BroadcastText( PlayerReplicationInfo SenderPRI, PlayerController Receiver, coerce string Msg, optional name Type )
{
    if (oldHandler != none)
        oldHandler.BroadcastText(SenderPRI, Receiver, Msg, Type);
}

function BroadcastLocalized( Actor Sender, PlayerController Receiver, class<LocalMessage> Message, optional int Switch, optional PlayerReplicationInfo RelatedPRI_1, optional PlayerReplicationInfo RelatedPRI_2, optional Object OptionalObject )
{
    if (oldHandler != none)
        oldHandler.BroadcastLocalized( Sender, Receiver, Message, Switch, RelatedPRI_1, RelatedPRI_2, OptionalObject );
}

event AllowBroadcastLocalized( actor Sender, class<LocalMessage> Message, optional int Switch, optional PlayerReplicationInfo RelatedPRI_1, optional PlayerReplicationInfo RelatedPRI_2, optional Object OptionalObject )
{
    if (oldHandler != none)
        oldHandler.AllowBroadcastLocalized( Sender, Message, Switch, RelatedPRI_1, RelatedPRI_2, OptionalObject );
}

defaultproperties
{
}
