//-----------------------------------------------------------
//
//-----------------------------------------------------------
class OLStatsDataHolder extends Object;

struct GlobalWeaponStats
{
    var string WeaponName;  // Done
    var byte WeaponType;    // Done
    var int PrimaryKills;   // Done
    var int SecondaryKills; // Done
    var int DeathsHolding;  // Done
    var int Suicides;       // Done
    var int DeathsBy;       // Done
    var int Roadkills;      // Done
};

struct AllMatchesStats
{
    var int MatchID;        // DONE
    var string FileName;    // DONE
    var string DateTime;    // DONE
    var string Date;        // DONE
    var int NumPlayers;     // DONE
    var string GameType;    // DONE
    var float MatchTime;    // DONE
    var float PlayerTime;   // DONE
    var int Matches;        // DONE
    var string MapName;     // DONE
};

struct GameTypeTotalsStats
{
    var string GameType;        // DONE
    var string GameTypeClass;   // DONE
    var int Score;              // DONE
    var int Kills;              // DONE
    var int Deaths;             // DONE
    var int Suicides;           // DONE
    var int TeamKills;          // DONE
    var int TeamDeaths;         // DONE
    var float Time;             // DONE
    var float PlayerTime;       // DONE
    var int NumMatches;         // DONE
    var int TotalWins;               // DONE
    var int TotalLosses;             // DONE
};

struct GlobalSpreeStats
{
    var int NumSprees_1;        // DONE
    var int NumSprees_2;        // DONE
    var int NumSprees_3;        // DONE
    var int NumSprees_4;        // DONE
    var int NumSprees_5;        // DONE
    var int NumSprees_6;        // DONE

    var float Time_1;        // DONE
    var float Time_2;        // DONE
    var float Time_3;        // DONE
    var float Time_4;        // DONE
    var float Time_5;        // DONE
    var float Time_6;        // DONE

    var float TotalKills_1;        // DONE
    var float TotalKills_2;        // DONE
    var float TotalKills_3;        // DONE
    var float TotalKills_4;        // DONE
    var float TotalKills_5;        // DONE
    var float TotalKills_6;        // DONE
};

struct TotalsStats
{
    var int Score;                  // DONE
    var int Kills;                  // DONE
    var int Deaths;                 // DONE
    var int Suicides;               // DONE
    var int TeamKills;              // DONE
    var int Headshots;              // DONE
    var float Time;                 // DONE
    var float PlayerTime;           // DONE
    var int Roadkills;              // DONE
    var int failedtransloc;         // DONE
    var int multikill_1;            // DONE
    var int multikill_2;            // DONE
    var int multikill_3;            // DONE
    var int multikill_4;            // DONE
    var int multikill_5;            // DONE
    var int multikill_6;            // DONE
    var int multikill_7;            // DONE
    var int carjackings;            // DONE
    var array<GlobalWeaponStats> Weapons;         // DONE
    var GlobalSpreeStats Sprees;        // DONE
    var int HeadHunter;             // DONE
    var int FlakMonkey;             // DONE
    var int ComboWhore;             // DONE
    var int RoadRampage;             // DONE
    var int NumMatches;             // DONE
};

struct GlobalTotalsStats
{
    var array<GameTypeTotalsStats> GameTypes;   // DONE
    var TotalsStats TotalStats;                 // DONE
};

struct GlobalPlayerStats
{
    var int PlayerID;                   // DONE
    var bool bBot;                      // Done
    var string PlayerHash;              // Done
    var string PlayerName;              // DONE
    var int Score;                      // DONE
    var int Kills;                      // DONE
    var int Deaths;                     // DONE
    var int Suicides;                   // DONE
    var int TeamKills;                  // Done
    var int TeamDeaths;                 // Done
    var GlobalSpreeStats Sprees;        // DONE
//    var array<PickupStats> Pickups; // TODO
    var int Headshots;                  // DONE
    var int Roadkills;                  // DONE
    var int Carjackings;                // DONE
    var array<GlobalWeaponStats> Weapons;     // DONE
    var int multikill_1;                // DONE
    var int multikill_2;                // DONE
    var int multikill_3;                // DONE
    var int multikill_4;                // DONE
    var int multikill_5;                // DONE
    var int multikill_6;                // DONE
    var int multikill_7;                // DONE
    var int failedtransloc;             // DONE
    var float Time;                     // DONE
    var array<GameTypeTotalsStats> GameTypes;       // DONE
    var int NumMatches;                 // DONE
    var int FirstBloods;                // DONE
    var int HeadHunter;                 // DONE
    var int FlakMonkey;                 // DONE
    var int ComboWhore;                 // DONE
    var int RoadRampage;                // DONE
    var int TotalWins;                  // DONE
    var int Wins;                       // DONE
    var int TeamWins;                   // DONE
    var int TotalLosses;                // DONE
//    var array<RecentMatchesStats> RecentMatches; // TODO
};

struct CareerHighWeaponRecord
{
    var string WeaponName;
    var int Player;
    var int Score;
};

struct CareerHighRecord
{
    var int Player;
    var int Score;
};

struct CareerHighRecordFloat
{
    var int Player;
    var float Score;
};

struct CareerHighsStats
{
    var CareerHighRecord MostFrags;
    var CareerHighRecord MostKills;
    var CareerHighRecord MostDeaths;
    var CareerHighRecord MostSuicides;
    var CareerHighRecord MostWins;
    var CareerHighRecord MostTeamWins;
    var CareerHighRecord MostHeadshots;
    var CareerHighRecordFloat HighestSPH;
    var CareerHighRecord MostFirstBlood;
    var CareerHighRecord MostCarjackings;
    var CareerHighRecord MostRoadkills;

    var CareerHighRecord MostHeadhunter;
    var CareerHighRecord MostFlakMonkey;
    var CareerHighRecord MostComboWhore;
    var CareerHighRecord MostRoadRampage;

    var CareerHighRecord MostMultikill_1;
    var CareerHighRecord MostMultikill_2;
    var CareerHighRecord MostMultikill_3;
    var CareerHighRecord MostMultikill_4;
    var CareerHighRecord MostMultikill_5;
    var CareerHighRecord MostMultikill_6;
    var CareerHighRecord MostMultikill_7;

    var CareerHighRecord MostKillingSpree_1;
    var CareerHighRecord MostKillingSpree_2;
    var CareerHighRecord MostKillingSpree_3;
    var CareerHighRecord MostKillingSpree_4;
    var CareerHighRecord MostKillingSpree_5;
    var CareerHighRecord MostKillingSpree_6;

    var array<CareerHighWeaponRecord> MostWeaponKills;
};

struct MatchHighWeaponRecord
{
    var string WeaponName;
    var int Player;
    var int Score;
    var int MatchID;
};

struct MatchHighRecord
{
    var int Player;
    var int Score;
    var int MatchID;
};

struct MatchHighsStats
{
    var MatchHighRecord MostFrags;      // done
    var MatchHighRecord MostKills;      // Done
    var MatchHighRecord MostDeaths;     // Done
    var MatchHighRecord MostSuicides;   // Done

    var array<MatchHighWeaponRecord> MostWeaponKills;
};

// Global stat logging holders
var array<AllMatchesStats> Matches;
var int LastMatchID;
var GlobalTotalsStats Totals;
var array<GlobalPlayerStats> Players;
var int LastPlayerID;
var CareerHighsStats CareerHighs;
var MatchHighsStats MatchHighs;

DefaultProperties
{
    LastMatchID = -1;
    LastPlayerID = -1;
}
