//-----------------------------------------------------------
//
//-----------------------------------------------------------
class OLStatsRPGHelper extends OLStatsHelpers;

struct MyPRIStruct
{
    var Controller Controller;
    var class<Weapon> LastPawnWeapon;
};

var array<MyPRIStruct> MyPRIArray;
var class<RPGWeapon> UnusedWeapon; // UDE Hack

function Weapon RPGGetRealWeapon(Weapon TheWeapon)
{
    if (RPGWeapon(TheWeapon) != none)
        return RPGWeapon(TheWeapon).ModifiedWeapon;
    else if ( RPGLinkGun(TheWeapon) != none)
        return RPGLinkGun(TheWeapon);
    else
        return TheWeapon;
}

function string RPGGetRealPickup(Pickup RPGPickup)
{
    if( RPGPickup.IsA('RPGWeaponPickup') )
        return string(RPGPickup.InventoryType.Default.PickupClass);

    if( RPGPickup.IsA('RPGWeaponLocker') )
        return "XWeapons.WeaponLocker";

    return string(RPGPickup.class);
}

function Tick(float Delta)
{
    local GameReplicationInfo GRI;
    local int i,x;

    GRI = Level.Game.GameReplicationInfo;

    if(GRI.PRIArray.Length != MyPRIArray.Length)
    {
        MyPRIArray.Length = 0;
        for(i=0;i<GRI.PRIArray.Length;i++)
        {
            x = MyPRIArray.Length;
            MyPRIArray.Length = x + 1;
            MyPRIArray[x].Controller = Controller(GRI.PRIArray[i].Owner);
        }
    }

    for(i=0;i<MyPRIArray.Length;i++)
    {
        if (MyPRIArray[i].Controller != none
            && MyPRIArray[i].Controller.Pawn != none
            && RPGWeapon(MyPRIArray[i].Controller.Pawn.Weapon) != none
            && RPGWeapon(MyPRIArray[i].Controller.Pawn.Weapon).ModifiedWeapon.Class != MyPRIArray[i].LastPawnWeapon)
        {
            MyPRIArray[i].LastPawnWeapon = RPGWeapon(MyPRIArray[i].Controller.Pawn.Weapon).ModifiedWeapon.Class;
        }
    }
}

function class<Weapon> RPGGetLastWeapon(Controller Other)
{
    local int i;

    for(i=0;i<MyPRIArray.Length;i++)
    {
        if (MyPRIArray[i].Controller == Other)
            return MyPRIArray[i].LastPawnWeapon;
    }

    return Other.LastPawnWeapon;
}

DefaultProperties
{

}
