//-----------------------------------------------------------
//
//-----------------------------------------------------------
class OLStatsHTMLLogger extends Info config(OLStatsDB) DependsOn(OLStatsDataHolder);

// Used when returning an array of all the players in a team.
// Need to return both the player's pointer, and the ITS pointer.
struct PlayerTeamRecord
{
    var int Player;     // Done
    var int Team;       // Done
};

struct SpreeLinker
{
    var int Player;     // Done
    var int Spree;      // Done
};

struct SpreeStats
{
    var int SpreeLevel;         // Done
    var int KillsInSpree;       // Done
    var float TimeSpreeStarted; // Done
    var float TimeSpreeEnded;   // Done
    var int KillerID;           // Done
    var string KillerDamType;   // Done
    var bool bInSpree;          // Done
    var string SpreeEndReason;  // Done
    var float TimeInSpree;      // Done
};

struct PickupStats
{
    var string ItemClass;   // Done
    var int NumPickups;     // Done
};

struct KillStats
{
    var int KilledID;       // Done
    var int NumKills;       // Done
};

struct WeaponStats
{
    var string WeaponName;  // Done
    var byte WeaponType;    // Done
    var int PrimaryKills;   // Done
    var int SecondaryKills; // Done
    var int DeathsHolding;  // Done
    var int Suicides;       // Done
    var int DeathsBy;       // Done
    var int Roadkills;      // Done
};

struct MutatorStats
{
    var string MutatorName;
    var string MutatorDescription;
};

struct CTFStats
{
    var int FlagCaptures;   // Done
    var int FlagAssists;    // Done
    var int FlagKills;      // Done
    var int FlagSaves;      // Done
    var int FlagPickups;    // Done
    var int FlagDrops;      // Done
    var int CarryTime;
};

struct ONSStats
{
    var int PowerNodesConstructed;      // Done
    var int PowerNodesDestroyed;        // Done
    var int ConstructingNodesDestroyed; // Done
    var int PowerCoresDestroyed;        // Done
};

struct IndividualTeamStats
{
    var int TeamID;             // Done
    var int Score;              // Done
    var int TeamScore;          // Done
    var int Kills;              // Done
    var int Deaths;             // Done
    var int Suicides;           // Done
    var int TeamKills;          // Done
    var int TeamDeaths;         // Done
    var array<SpreeLinker> Sprees;  // Done
    var CTFStats CTF;           // Done
    var ONSStats ONS;           // Done
    var float Time;             // Done
    var float SPH;              // Done
    var float Eff;              // Done
    var float TTL;              // Done
    var float TimeConnected;    // Done
    var float JoinTime;         // Done
    var int NumPlayers;         // Done
};

struct PlayerStats
{
    var int TeamID;             // Done
    var bool bBot;              // Done
    var string PlayerHash;      // Done
    var string PlayerName;      // Done
    var float JoinTime;         // Done
    var float QuitTime;         // Done
    var int Score;              // Done
    var int Kills;              // Done
    var int Deaths;             // Done
    var int Suicides;           // Done
    var int TeamKills;          // Done
    var int TeamDeaths;         // Done
    var array<IndividualTeamStats> ITS;     // Done
    var array<SpreeStats> Sprees;           // Done
    var array<PickupStats> Pickups;         // Done
    var int Headshots;                  // Done
    var int Roadkills;                  // Done
    var int Carjackings;                // Done
    var array<KillStats> PlayerKills;   // Done
    var array<WeaponStats> Weapons;     // Done
//    var array<VehicleStats> Vehicles;   // Done
    var float TimeConnected;            // Done
    var int SpreeKills;                 // Done
    var int Rank;                       // Done
    var int multikill_1;                // Done
    var int multikill_2;                // Done
    var int multikill_3;                // Done
    var int multikill_4;                // Done
    var int multikill_5;                // Done
    var int multikill_6;                // Done
    var int multikill_7;                // Done
    var int failedtransloc;             // Done
    var float Time;                     // Done
    var float SPH;                      // Done
    var float Eff;                      // Done
    var float TTL;                      // Done
    var int HeadHunter;
    var int FlakMonkey;
    var int ComboWhore;
    var int RoadRampage;

    var int HeadKills;
    var int FlakKills;
    var int ComboKills;

    var int RecentMatches[10];

    var int GlobalPlayerPointer;

    // 0 = Draw
    // 1 = Win
    // 2 = Lose
    var byte WinState;
};

struct MatchStats
{
    var int FirstBloodID;                   // Done
    var array<PickupStats> TotalPickups;    // Done
    var int Headshots;                  // Done
    var int Roadkills;                  // Done
    var int Carjackings;                // Done
    var array<WeaponStats> Weapons;     // Done
//    var array<VehicleStats> Vehicles;   // Done
    var int Score;              // Done
    var int TeamScore;          // Done
    var int Kills;              // Done
    var int Deaths;             // Done
    var int Suicides;           // Done
    var int TeamKills;          // Done
    var string ServerName;      // Done
    var string MapName;         // Done
    var string GameType;        // Done
    var byte GameTypeID;        // Done
    var string GameTypeClass;   // Done
    var bool bTeamGame;         // Done
    var array<MutatorStats> Mutators;       // Done
    var array<IndividualTeamStats> Teams;   // Done
    var array<SpreeLinker> Sprees;          // Done
    var int multikill_1;                // Done
    var int multikill_2;                // Done
    var int multikill_3;                // Done
    var int multikill_4;                // Done
    var int multikill_5;                // Done
    var int multikill_6;                // Done
    var int multikill_7;                // Done
    var int failedtransloc;             // Done
    var string AdminName;               // Done
    var string AdminEmail;              // Done
    var int GameSpeed;                  // Done
    var int GoalScore;                  // Done
    var int TimeLimit;                  // Done
    var int GameDifficulty;             // Done
    var float AvgTime;                  // Done
    var float AvgSPH;                   // Done
    var float AvgEff;                   // Done
    var float AvgTTL;                   // Done
    var string DateTime;                // Done
    var string Date;
    var float MatchTime;                // Done
    var int HeadHunter;
    var int FlakMonkey;
    var int ComboWhore;
    var int RoadRampage;
};

struct PlayerIDLinker
{
    var int PlayerID;       // Done
    var string PlayerHash;  // Done
};

var MatchStats MatchInfo;               // Done
var array<PlayerStats> PlayerInfo;      // Done
var array<PlayerIDLinker> PlayerIDs;    // Done

/*
var localized string locGeneratedBy; // "This page was generated by OLStats v"
var localized string
var localized string
var localized string
var localized string
var localized string
*/

// **************
// *GLOBAL STATS*
// **************
// These are all the variables that need to be loaded from disk
// and saved when done. They hold player career totals and stuff
// like that.  Pretty much everything except for individual match
// data.
var array<OLStatsDataHolder.AllMatchesStats> Matches;      // Done
var int LastMatchID;                     // Done
var OLStatsDataHolder.GlobalTotalsStats Totals;            // Done
var array<OLStatsDataHolder.GlobalPlayerStats> Players;    // Done
var int LastPlayerID;                    // DONE
var OLStatsDataHolder.CareerHighsStats CareerHighs;        // Done
var OLStatsDataHolder.MatchHighsStats MatchHighs;



// *******************
// *GENERAL VARIABLES*
// *******************

var float TimeMatchStarted;     // Done
var bool bFirstBlood;           // Done
var GameReplicationInfo GRI;    // Done
var FileLog TempLog;            // Done
var OLLocalGameStats GS;
var bool bMatchStarted;

var OLStatsDataHolder Data;


// ******************
// *CONFIG VARIABLES*
// ******************
// These are variables that are stored in OLStatsDB.ini - they hold the details
// on all the types of weapons. If you want to run OLStats with a mod that
// has custom weapons, you'll want to add the weapons to OLStatsDB.ini

// For WeaponType:
// 0 = Weapon
// 1 = Vehicle
// 2 = Turret
// 3 = Monster
//
// For Secondary
// 0 = Primary Fire
// 1 = Secondary Fire
// 2 = Special (like Shock Combo)
// 4 = Roadkill
struct WeaponDetails
{
    var string DamType;
    var string WeaponName;
    var byte Secondary;
    var byte WeaponType;
    var bool bIsHeadshot;
};
var config array<WeaponDetails> Weapons;

// GameType:
// 0 = Unknown
// 1 = Deathmatch
// 2 = CTF
// 3 = Bombing Run
// 4 = TDM
// 5 = Assault
// 6 = Onslaught
// 7 = Double Domination
// 8 = Mutant
// 9 = Invasion
// 10 = Last Man Standing
// 11 = Slave Master
// 12 = Jailbreak
// 13 = CTF4
// 14 = TDM4
struct GameTypeDetails
{
    var string GameTypeClass;
    var string GameName;
    var bool bTeamGame;
    var byte GameType;
};
var config array<GameTypeDetails> GameTypes;


function float GetTime()
{
    if (bMatchStarted)
        return Level.TimeSeconds - TimeMatchStarted;
    else
        return 0;
}

function int GetPlayerByHash(string Hash)
{
    local int i;

    for(i=0;i<PlayerInfo.Length;i++)
    {
        if(PlayerInfo[i].PlayerHash == Hash)
            return i;
    }

    return -1;
}

function int GetPlayerByID(int PlayerID)
{
    local int i;

    for(i=0;i<PlayerIDs.length;i++)
    {
        if(PlayerIDs[i].PlayerID == PlayerID)
            return GetPlayerByHash(PlayerIDs[i].PlayerHash);
    }

    return -1;
}

function int GetIndividualTeamStatsByID(int Player, int TeamID)
{
    local int i;

    for(i=0;i<PlayerInfo[Player].ITS.length;i++)
    {
        if(PlayerInfo[Player].ITS[i].TeamID == TeamID)
            return i;
    }

    return -1;
}

function int GetTeamStatsByID(int TeamID)
{
    local int i;

    for(i=0;i<MatchInfo.teams.length;i++)
    {
        if(MatchInfo.teams[i].TeamID == TeamID)
            return i;
    }

    return -1;
}

function int GetPickupFromArray(array<PickupStats> Pickups, string PickupName)
{
    local int i;

    for(i=0;i<Pickups.length;i++)
    {
        if(Pickups[i].ItemClass == PickupName)
            return i;
    }

    return -1;
}

function string GetPlayerHash(PlayerReplicationInfo Who)
{
    local string hash;

    if (Who.bBot)
        return Who.PlayerName;
    else
    {
        hash = GS.GetStatsIdentifier(Controller(Who.Owner));
        ReplaceChar(hash,Chr(9),"");
        Replacechar(hash," ","");
        return hash;
    }
}

function int GetPlayerWeaponRecord(int Player, string WeaponName, byte WeaponType)
{
    local int i;

    for(i=0;i<PlayerInfo[Player].Weapons.Length;i++)
    {
        if(PlayerInfo[Player].Weapons[i].WeaponName == WeaponName)
        {
            return i;
        }
    }

    i = PlayerInfo[Player].Weapons.Length;
    PlayerInfo[Player].Weapons.Length = i + 1;
    PlayerInfo[Player].Weapons[i].WeaponName = WeaponName;
    PlayerInfo[Player].Weapons[i].WeaponType = WeaponType;

    return i;
}

function int GetWeaponRecord(string WeaponName, byte WeaponType)
{
    local int i;

    for(i=0;i<MatchInfo.Weapons.Length;i++)
    {
        if(MatchInfo.Weapons[i].WeaponName == WeaponName)
            return i;
    }

    i = MatchInfo.Weapons.Length;
    MatchInfo.Weapons.Length = i + 1;
    MatchInfo.Weapons[i].WeaponName = WeaponName;
    MatchInfo.Weapons[i].WeaponType = WeaponType;

    return i;
}

function WeaponDetails GetWeaponDetails(string Weapon)
{
    local int i;
    local string DamageName;
    local WeaponDetails WD;

    DamageName = Weapon;

    for(i=0;i<Weapons.Length;i++)
    {
        if(Weapons[i].DamType ~= DamageName)
            return Weapons[i];
    }

    // If we can't find the weapon, we make our own entry using the DamType for
    // the name.

    WD.DamType = DamageName;
    WD.WeaponName = DamageName;
    WD.Secondary = 0;
    WD.WeaponType = 0;
    WD.bIsHeadshot = false;

    return WD;
}

function GameTypeDetails GetGameTypeDetails(string GameClass)
{
    local int i;
    local GameTypeDetails GT;

    for(i=0;i<GameTypes.Length;i++)
    {
        if(GameTypes[i].GameTypeClass ~= GameClass)
            return GameTypes[i];
    }

    // If we can't find the weapon, we make our own entry using the GameClass for
    // the name.

    GT.GameTypeClass = GameClass;
    GT.GameName = "";
    GT.GameType = 0;

    return GT;
}

function MarkWinner()
{
    local int i;
    local int winner;

    if (GRI.Winner == none)
    {
        for(i=0;i<PlayerInfo.Length;i++)
            PlayerInfo[i].WinState = 0;
    }
    else if( UnrealTeamInfo(GRI.Winner) != none )
    { // The winner was a team
        for(i=0;i<PlayerInfo.Length;i++)
            if (PlayerInfo[i].QuitTime == 0 && PlayerInfo[i].TeamID == UnrealTeamInfo(GRI.Winner).TeamIndex)
                PlayerInfo[i].WinState = 1;
            else
                PlayerInfo[i].WinState = 2;
    }
    else if ( PlayerReplicationInfo(GRI.Winner) != none )
    { // The winner was a player
        winner = GetPlayerByHash(GetPlayerHash(PlayerReplicationInfo(GRI.Winner)));
        if (winner != -1)
            PlayerInfo[winner].WinState = 1;

        for(i=0;i<PlayerInfo.Length;i++)
            if (i!=winner)
                PlayerInfo[i].WinState = 2;
    }
}

/*************************************
 Main functions
*************************************/

function NewGame()
{
    local Mutator MutatorHook;
//    local string GameTypeName;
    local GameTypeDetails GameTypeDetails;

    GRI = Level.Game.GameReplicationInfo;
    MatchInfo.ServerName = GRI.ServerName;
    MatchInfo.GameType = Level.Game.GameName;
    MatchInfo.bTeamGame = Level.Game.bTeamGame;
    MatchInfo.AdminName = GRI.AdminName;
    MatchInfo.AdminEmail = GRI.AdminEmail;
    MatchInfo.GameSpeed = Level.Game.GameSpeed * 100;
    MatchInfo.GameDifficulty = int(Level.Game.GameDifficulty);
    MatchInfo.GoalScore = Level.Game.GoalScore;
    MatchInfo.TimeLimit = Level.Game.TimeLimit;
    MatchInfo.DateTime = GetDateTimeString();
    MatchInfo.Date = GetDateString();

    GameTypeDetails = GetGameTypeDetails(GetItemName(string(Level.Game)));
    if(GameTypeDetails.GameName == "")
        MatchInfo.GameType = Level.Game.GameName;
    else
        MatchInfo.GameType = GameTypeDetails.GameName;

    MatchInfo.GameTypeClass = GetItemName(string(Level.Game));

    MatchInfo.GameTypeID = GameTypeDetails.GameType;

    foreach AllActors(class'Mutator',MutatorHook)
    {
        // TODO
//        AddMutator(MutatorHook);
    }
}

function MapName(string MapName)
{
    MatchInfo.MapName = MapName;
}

function GameEvent(PlayerReplicationInfo Who, string GEvent, string desc)
{
    switch(GEvent)
    {
        case "NameChange":
            NameChange(Who,desc);
            break;
        case "TeamChange":
            TeamChange(Who,int(desc));
            break;
        case "carjack":
            CarJack(Who, desc);
            break;

        // CTF Events
        case "flag_captured":
        case "flag_returned":
        case "flag_dropped":
        case "flag_taken":
        case "flag_pickup":
            FlagEvent(Who,desc);
            break;
        case "flag_returned_timeout":
            break;

        // ONS Events
        // There are none! They're all score events.

    }
}

function FlagEvent(PlayerReplicationInfo Who, string desc)
{
    local int Player, Team, ITS;

    Player = GetPlayerByHash(GetPlayerHash(Who));
    ITS = GetIndividualTeamStatsByID(Player, PlayerInfo[Player].TeamID);
    Team = GetTeamStatsByID(PlayerInfo[Player].TeamID);

    switch(desc)
    {
        case "flag_captured":
            PlayerInfo[Player].ITS[ITS].CTF.FlagCaptures++;
            MatchInfo.Teams[Team].CTF.FlagCaptures++;
            break;
        case "flag_returned":
            PlayerInfo[Player].ITS[ITS].CTF.FlagSaves++;
            MatchInfo.Teams[Team].CTF.FlagSaves++;
            break;
        case "flag_dropped":
            PlayerInfo[Player].ITS[ITS].CTF.FlagDrops++;
            MatchInfo.Teams[Team].CTF.FlagDrops++;
            break;
        case "flag_taken":
        case "flag_pickup":
            PlayerInfo[Player].ITS[ITS].CTF.FlagPickups++;
            MatchInfo.Teams[Team].CTF.FlagPickups++;
            break;
        case "flag_cap_assist":
            PlayerInfo[Player].ITS[ITS].CTF.FlagAssists++;
            MatchInfo.Teams[Team].CTF.FlagAssists++;
            break;
    }
}

function ONSEvent(PlayerReplicationInfo Who, string desc)
{
    local int Player, Team, ITS;

    Player = GetPlayerByHash(GetPlayerHash(Who));
    ITS = GetIndividualTeamStatsByID(Player, PlayerInfo[Player].TeamID);
    Team = GetTeamStatsByID(PlayerInfo[Player].TeamID);

    switch(desc)
    {
        case "blue_powernode_constructed":
        case "red_powernode_constructed":
            PlayerInfo[Player].ITS[ITS].ONS.PowerNodesConstructed++;
            MatchInfo.Teams[Team].ONS.PowerNodesConstructed++;
            break;
        case "red_constructing_powernode_destroyed":
        case "blue_constructing_powernode_destroyed":
            PlayerInfo[Player].ITS[ITS].ONS.ConstructingNodesDestroyed++;
            MatchInfo.Teams[Team].ONS.ConstructingNodesDestroyed++;
            break;
        case "red_powernode_destroyed":
        case "blue_powernode_destroyed":
            PlayerInfo[Player].ITS[ITS].ONS.PowerNodesDestroyed++;
            MatchInfo.Teams[Team].ONS.PowerNodesDestroyed++;
            break;
        case "red_powercore_destroyed":
        case "blue_powercore_destroyed":
            PlayerInfo[Player].ITS[ITS].ONS.PowerCoresDestroyed++;
            MatchInfo.Teams[Team].ONS.PowerCoresDestroyed++;
            break;
    }
}

function CarJack(PlayerReplicationInfo Who, string desc)
{
    local int Player;

    Player = GetPlayerByHash(GetPlayerHash(Who));

    PlayerInfo[Player].Carjackings++;
    MatchInfo.Carjackings++;
}

function StartMatch()
{
    bMatchStarted = true;
    TimeMatchStarted = Level.TimeSeconds;
}

function ScoreEvent(PlayerReplicationInfo Who, float Points, string Desc)
{
    local int Player, ITS, Team;

    Player = GetPlayerByHash(GetPlayerHash(Who));
    if(Player==-1) return;

    PlayerInfo[Player].Score += Points;
    MatchInfo.Score += Points;

    if(MatchInfo.bTeamGame)
    {
        ITS = GetIndividualTeamStatsByID(Player,Who.Team.TeamIndex);
        Team = GetTeamStatsByID(Who.Team.TeamIndex);

        PlayerInfo[Player].ITS[ITS].Score += Points;
        MatchInfo.Teams[Team].Score += Points;
    }

    switch(Desc)
    {
        // CTF Events
        case "flag_cap_assist":
            FlagEvent(Who, Desc);
            break;

        // ONS Events
        case "blue_powernode_constructed":
        case "red_powernode_constructed":
        case "red_constructing_powernode_destroyed":
        case "blue_constructing_powernode_destroyed":
        case "red_powernode_destroyed":
        case "blue_powernode_destroyed":
        case "red_powercore_destroyed":
        case "blue_powercore_destroyed":
            ONSEvent(Who, Desc);
            break;
    }
}

function TeamScoreEvent(int TeamID, float Points, string Desc)
{
    local int Team;

    Team = GetTeamStatsByID(TeamID);
    MatchInfo.Teams[Team].TeamScore += Points;
    MatchInfo.TeamScore += Points;
}

function SpecialEvent(PlayerReplicationInfo Who, string Desc)
{
    switch(Desc)
    {
        case "multikill_1":
        case "multikill_2":
        case "multikill_3":
        case "multikill_4":
        case "multikill_5":
        case "multikill_6":
        case "multikill_7":
            MultiKill(Who, Desc);
            break;

        case "translocate_gib":
            FailedTransloc(Who);
            break;
    }
}

function FailedTransloc(PlayerReplicationInfo Who)
{
    local int Player;

    Player = GetPlayerByHash(GetPlayerHash(Who));

    PlayerInfo[Player].failedtransloc++;
    MatchInfo.failedtransloc++;
}

function MultiKill(PlayerReplicationInfo Who, string Desc)
{
    local int Player;

    Player = GetPlayerByHash(GetPlayerHash(Who));

    switch(Desc)
    {
        case "multikill_1":
            PlayerInfo[Player].multikill_1++;
            MatchInfo.multikill_1++;
            break;
        case "multikill_2":
            PlayerInfo[Player].multikill_2++;
            MatchInfo.multikill_2++;
            PlayerInfo[Player].multikill_1--;
            MatchInfo.multikill_1--;
            break;
        case "multikill_3":
            PlayerInfo[Player].multikill_3++;
            MatchInfo.multikill_3++;
            PlayerInfo[Player].multikill_2--;
            MatchInfo.multikill_2--;
            break;
        case "multikill_4":
            PlayerInfo[Player].multikill_4++;
            MatchInfo.multikill_4++;
            PlayerInfo[Player].multikill_3--;
            MatchInfo.multikill_3--;
            break;
        case "multikill_5":
            PlayerInfo[Player].multikill_5++;
            MatchInfo.multikill_5++;
            PlayerInfo[Player].multikill_4--;
            MatchInfo.multikill_4--;
            break;
        case "multikill_6":
            PlayerInfo[Player].multikill_6++;
            MatchInfo.multikill_6++;
            PlayerInfo[Player].multikill_5--;
            MatchInfo.multikill_5--;
            break;
        case "multikill_7":
            PlayerInfo[Player].multikill_7++;
            MatchInfo.multikill_7++;
            PlayerInfo[Player].multikill_6--;
            MatchInfo.multikill_6--;
            break;
        default:
            break;
    }
}

function PlayerConnected(PlayerReplicationInfo Who, bool bBot)
{
    local int Player;
    local int i;

    Player = GetPlayerByHash(GetPlayerHash(Who));
    if (Player == -1)
    {
        i = PlayerInfo.length;
        PlayerInfo.length = i + 1;
        PlayerInfo[i].JoinTime = GetTime();
        PlayerInfo[i].QuitTime = 0;
        PlayerInfo[i].PlayerHash = GetPlayerHash(Who);
        PlayerInfo[i].TeamID = 255;
        PlayerInfo[i].bBot = bBot;
        PlayerInfo[i].SpreeKills = 0;
    } else {
        PlayerInfo[Player].SpreeKills = 0;
    }

    Player = GetPlayerByID(Who.PlayerID);
    if (Player == -1)
    {
        i = PlayerIDs.Length;
        PlayerIDs.length = i + 1;
        PlayerIDs[i].PlayerID = Who.PlayerID;
        PlayerIDs[i].PlayerHash = GetPlayerHash(Who);
    }
}

function Disconnect(PlayerReplicationInfo Who)
{
    local int Player;
    local int Team;

    Player = GetPlayerByHash(GetPlayerHash(Who));
    if (Player == -1) return;

    PlayerInfo[Player].QuitTime = GetTime();

    ZeroOutSprees(Player,-1,"");

    // Add to the cummilative time connected var, so that if the player
    // reconnects, his time played is still accurate.
    PlayerInfo[Player].TimeConnected += PlayerInfo[Player].QuitTime - PlayerInfo[Player].JoinTime;

    if(MatchInfo.bTeamGame)
    {
        Team = GetIndividualTeamStatsbyId(Player, PlayerInfo[Player].TeamID);

        if(Team != -1)
            PlayerInfo[Player].ITS[Team].TimeConnected += PlayerInfo[Player].QuitTime - PlayerInfo[Player].ITS[Team].JoinTime;
    }
}

function NameChange(PlayerReplicationInfo Who, string NewName)
{
    local int Player;

    // Strip [BOT] from the name
    if(Mid(NewName,0,5)=="[BOT]")
        NewName = Mid(NewName,5);

    Player = GetPlayerByHash(GetPlayerHash(Who));
    PlayerInfo[Player].PlayerName = NewName;
}

function TeamChange(PlayerReplicationInfo Who, int TeamID)
{
    local int i;
    local int Player;
    local int PlayerTeam, GlobalTeam;
    local int OldTeam;
    local float Now;

    Player = GetPlayerByHash(GetPlayerHash(Who));
    Now = GetTime();

    // If the player is actually switching teams (as opposed to the TeamChange
    // event that happens to everyone on connect) then update the timeconnected
    // for that team.
    OldTeam = GetIndividualTeamStatsByID(Player, PlayerInfo[Player].TeamID);
    if(OldTeam != -1)
    {
        PlayerInfo[Player].ITS[OldTeam].TimeConnected += Now - PlayerInfo[Player].ITS[OldTeam].JoinTime;
    }

    PlayerInfo[Player].TeamID = TeamID;

    // Set up the player's team stats if they haven't been already
    PlayerTeam = GetIndividualTeamStatsByID(Player, TeamID);
    if(PlayerTeam == -1)
    {
        i = PlayerInfo[Player].ITS.length;
        PlayerInfo[Player].ITS.length = i + 1;
        PlayerInfo[Player].ITS[i].TeamID = TeamID;
        PlayerInfo[Player].ITS[i].JoinTime = Now;
    }

    // Set up the match's total team stats if they haven't been already
    GlobalTeam = GetTeamStatsByID(TeamID);
    if(GlobalTeam == -1)
    {
        i = MatchInfo.Teams.Length;
        MatchInfo.Teams.Length = i + 1;
        MatchInfo.Teams[i].TeamID = TeamID;
    }
}

function PickupItem(PlayerReplicationInfo Who, Pickup Item)
{
    local int Player;
    local int ItemStats;
    local int i;
    local string ItemClass;

    Player = GetPlayerByHash(GetPlayerHash(Who));

    ItemClass = GetItemName(string(Item.Name));
    ItemStats = GetPickupFromArray(PlayerInfo[Player].Pickups, ItemClass);
    if (ItemStats == -1)
    {
        i = PlayerInfo[Player].Pickups.Length;
        PlayerInfo[Player].Pickups.Length = i + 1;
        PlayerInfo[Player].Pickups[i].ItemClass = ItemClass;
        PlayerInfo[Player].Pickups[i].NumPickups = 1;
    } else {
        PlayerInfo[Player].Pickups[ItemStats].NumPickups++;
    }

    ItemStats = GetPickupFromArray(MatchInfo.TotalPickups, ItemClass);
    if (ItemStats == -1)
    {
        i = MatchInfo.TotalPickups.Length;
        MatchInfo.TotalPickups.Length = i + 1;
        MatchInfo.TotalPickups[i].ItemClass = ItemClass;
        MatchInfo.TotalPickups[i].NumPickups = 1;
    } else {
        MatchInfo.TotalPickups[ItemStats].NumPickups++;
    }
}

function PlayerKilledPlayer(PlayerReplicationInfo KillerPRI, PlayerReplicationInfo KilledPRI, string DamageName, string HeldWeapon)
{
    local int Killer, Killed;
    local int KillerITS, KilledITS, KillerTeamStats, KilledTeamStats;
    local int PlayerKillRecord;
    local int i;
    local bool bSuicide;

    Killed = GetPlayerByHash(GetPlayerHash(KilledPRI));
    if (Killed == -1) return;

    if (KillerPRI == none || KillerPRI == KilledPRI)
    { // suicide
        bSuicide = true;

        if (MatchInfo.bTeamGame)
        {
            KilledITS = GetIndividualTeamStatsByID(Killed, KilledPRI.Team.TeamIndex);
            PlayerInfo[Killed].ITS[KilledITS].Suicides++;
            //PlayerInfo[Killed].ITS[KilledITS].Deaths++;

            KilledTeamStats = GetTeamStatsByID(KilledPRI.Team.TeamIndex);
            MatchInfo.Teams[KilledTeamStats].Suicides++;
            //MatchInfo.Teams[KilledTeamStats].Deaths++;
        }

        PlayerInfo[Killed].Suicides++;
        //PlayerInfo[Killed].Deaths++;
        MatchInfo.Suicides++;
        //MatchInfo.Deaths++;
        RegisterKillersWeapon(Killed, DamageName, true);
        ZeroOutSprees(Killed,Killed,DamageName);

        PlayerKillRecord = GetPlayerKillRecord(Killed,Killed);
        if(PlayerKillRecord == -1)
        {
            i = PlayerInfo[Killed].PlayerKills.Length;
            PlayerInfo[Killed].PlayerKills.Length = i + 1;
            PlayerInfo[Killed].PlayerKills[i].KilledID = Killed;
            PlayerKillRecord = i;
        }
        PlayerInfo[Killed].PlayerKills[PlayerKillRecord].NumKills++;

    } else {
        bSuicide = false;

        Killer = GetPlayerByHash(GetPlayerHash(KillerPRI));
        if (Killer == -1) return;

        if(MatchInfo.bTeamGame && KillerPRI.Team.TeamIndex == KilledPRI.Team.TeamIndex)
        { // same team
            KillerITS = GetIndividualTeamStatsByID(Killer, KillerPRI.Team.TeamIndex);
            KilledITS = GetIndividualTeamStatsByID(Killed, KilledPRI.Team.TeamIndex);

            PlayerInfo[Killer].ITS[KillerITS].TeamKills++;
            PlayerInfo[Killed].ITS[KilledITS].TeamDeaths++;

            PlayerInfo[Killer].TeamKills++;
            PlayerInfo[Killed].TeamDeaths++;

            KilledTeamStats = GetTeamStatsByID(KilledPRI.Team.TeamIndex);
            MatchInfo.Teams[KilledTeamStats].TeamDeaths++;
            MatchInfo.Teams[KilledTeamStats].TeamKills++;

            MatchInfo.TeamKills++;
        } else { // Different teams
            if (MatchInfo.bTeamGame)
            {
                KillerITS = GetIndividualTeamStatsByID(Killer, KillerPRI.Team.TeamIndex);
                KilledITS = GetIndividualTeamStatsByID(Killed, KilledPRI.Team.TeamIndex);

                PlayerInfo[Killer].ITS[KillerITS].Kills++;
                PlayerInfo[Killed].ITS[KilledITS].Deaths++;

                KillerTeamStats = GetTeamStatsByID(KillerPRI.Team.TeamIndex);
                KilledTeamStats = GetTeamStatsByID(KilledPRI.Team.TeamIndex);
                MatchInfo.Teams[KillerTeamStats].Kills++;
                MatchInfo.Teams[KilledTeamStats].Deaths++;
            }

            PlayerInfo[Killer].Kills++;
            PlayerInfo[Killed].Deaths++;
            MatchInfo.Kills++;
            MatchInfo.Deaths++;

            // Register Killer's weapon
            RegisterKillersWeapon(Killer, DamageName, false);

            AddSpreeKill(Killer);

            if (!bFirstBlood)
            {
                bFirstBlood = true;
                MatchInfo.FirstBloodID = Killer;
            }
        } // END if different teams
        ZeroOutSprees(Killed, Killer, DamageName);

        PlayerKillRecord = GetPlayerKillRecord(Killer,Killed);
        if(PlayerKillRecord == -1)
        {
            i = PlayerInfo[Killer].PlayerKills.Length;
            PlayerInfo[Killer].PlayerKills.Length = i + 1;
            PlayerInfo[Killer].PlayerKills[i].KilledID = Killed;
            PlayerKillRecord = i;
        }
        PlayerInfo[Killer].PlayerKills[PlayerKillRecord].NumKills++;

        // Register Victim's held weapon
        RegisterVictimsWeapon(Killed, HeldWeapon);
    } // END if not suicide

    // Register Victim's killed by weapon
    RegisterVictimsDeathWeapon(Killed, DamageName);
}

function int GetPlayerKillRecord(int Killer, int Killed)
{
    local int i;

    for(i=0;i<PlayerInfo[Killer].PlayerKills.Length;i++)
    {
        if(PlayerInfo[Killer].PlayerKills[i].KilledID == Killed)
            return i;
    }

    return -1;
}

function int GetNumKills(int Killer,int Killed)
{
    local int PlayerKillRecord;

    PlayerKillRecord = GetPlayerKillRecord(Killer,Killed);
    if(PlayerKillRecord != -1)
        return PlayerInfo[Killer].PlayerKills[PlayerKillRecord].NumKills;
    else
        return 0;
}

function array<int> GetKilledPlayersByNumKills(int Killer)
{
    local int i, j;
    local array<int> KillsArray;
    local int temp, ifrags, jfrags;

    for(i=0;i<PlayerInfo.Length;i++)
    {
        if(i != Killer && (GetNumKills(Killer, i) > 0 || GetNumKills(i, Killer) > 0))
            KillsArray[KillsArray.Length] = i;
    }

    for(i=0;i<KillsArray.Length-1;i++)
    {
        for(j=i+1;j<KillsArray.Length;j++)
        {
            ifrags = GetNumKills(Killer, i);
            jfrags = GetNumKills(Killer, j);
            if( ifrags < jfrags )
            {
                temp = KillsArray[j];
                KillsArray[j] = KillsArray[i];
                KillsArray[i] = temp;
            }
        }
    }

    return KillsArray;
}

function ZeroOutSprees(int Player, int Killer, string DamageName)
{
    local int Spree;
    local WeaponDetails Weapon;

    Spree = FindPlayerActiveSpree(Player);

    Weapon = GetWeaponDetails(DamageName);

    if (Spree != -1)
    {
        PlayerInfo[Player].Sprees[Spree].TimeSpreeEnded = GetTime();
        PlayerInfo[Player].Sprees[Spree].bInSpree = false;
        PlayerInfo[Player].Sprees[Spree].KillerID = Killer;
        PlayerInfo[Player].Sprees[Spree].KillerDamType = Weapon.WeaponName;
    }

    PlayerInfo[Player].SpreeKills = 0;
}

function AddSpreeKill(int Player)
{
    local int Spree;
    local int i;
    local int SpreeLevel;
    local int TeamID;

    PlayerInfo[Player].SpreeKills++;

    if(PlayerInfo[Player].SpreeKills > 4)
    {
        Spree = FindPlayerActiveSpree(Player);
        if (Spree == -1)
        {
            i = PlayerInfo[Player].Sprees.Length;
            PlayerInfo[Player].Sprees.Length = i + 1;
            PlayerInfo[Player].Sprees[i].bInSpree = true;
            PlayerInfo[Player].Sprees[i].TimeSpreeStarted = GetTime();
            Spree = i;

            if (MatchInfo.bTeamGame)
            {
                TeamID = GetIndividualTeamStatsByID(Player,PlayerInfo[Player].TeamID);
                i = PlayerInfo[Player].ITS[TeamID].Sprees.Length;
                PlayerInfo[Player].ITS[TeamID].Sprees.Length = i + 1;
                PlayerInfo[Player].ITS[TeamID].Sprees[i].Player = Player;
                PlayerInfo[Player].ITS[TeamID].Sprees[i].Spree = Spree;
            }

            i = MatchInfo.Sprees.Length;
            MatchInfo.Sprees.Length = i + 1;
            MatchInfo.Sprees[i].Player = Player;
            MatchInfo.Sprees[i].Spree = Spree;
        }

        PlayerInfo[Player].Sprees[Spree].KillsInSpree = PlayerInfo[Player].SpreeKills;

        SpreeLevel = min((PlayerInfo[Player].SpreeKills - (PlayerInfo[Player].SpreeKills % 5)) / 5,6);
        PlayerInfo[Player].Sprees[Spree].SpreeLevel = SpreeLevel;
    }
}

function array<int> GetSpreesByTime()
{
    local int i,j;
    local array<int> SpreeArray;
    local int temp;
    local int itime, jtime;

    for(i=0;i<MatchInfo.Sprees.Length;i++)
    {
        SpreeArray[SpreeArray.Length] = i;
    }

    for(i=0;i<MatchInfo.Sprees.Length-1;i++)
    {
        for(j=i+1;j<MatchInfo.Sprees.Length;j++)
        {
            itime = PlayerInfo[MatchInfo.Sprees[SpreeArray[i]].Player].Sprees[MatchInfo.Sprees[SpreeArray[i]].Spree].TimeSpreeStarted;
            jtime = PlayerInfo[MatchInfo.Sprees[SpreeArray[j]].Player].Sprees[MatchInfo.Sprees[SpreeArray[j]].Spree].TimeSpreeStarted;
            if (itime > jtime)
            {
                temp = SpreeArray[j];
                SpreeArray[j] = SpreeArray[i];
                SpreeArray[i] = temp;
            }
        }
    }

    return SpreeArray;
}

function int GetPlayerNumberSprees(int Player, int SpreeLevel)
{
    local int i;
    local int total;

    total = 0;
    for(i=0;i<PlayerInfo[Player].Sprees.Length;i++)
    {
        if(PlayerInfo[Player].Sprees[i].SpreeLevel == SpreeLevel)
            total++;
    }

    return total;
}

function int GetTeamPlayerNumberSprees(int Player, int SpreeLevel, int Team)
{
    local int i;
    local int total;

    total = 0;
    for(i=0;i<PlayerInfo[Player].ITS[Team].Sprees.Length;i++)
    {
        if(PlayerInfo[Player].Sprees[PlayerInfo[Player].ITS[Team].Sprees[i].Spree].SpreeLevel == SpreeLevel)
            total++;
    }

    return total;
}

function int GetNumberSprees(int SpreeLevel)
{
    local int i;
    local int total;

    total=0;
    for(i=0;i<MatchInfo.Sprees.Length;i++)
    {
        if(PlayerInfo[MatchInfo.Sprees[i].Player].Sprees[MatchInfo.Sprees[i].Spree].SpreeLevel == SpreeLevel)
            total++;
    }

    return total;
}

function int GetTeamNumberSprees(int TeamID, int SpreeLevel)
{
    local array<PlayerTeamRecord> TeamArray;
    local int i;
    local int total;

    TeamArray = GetTeamArray(TeamID);

    total = 0;
    for(i=0;i<TeamArray.Length;i++)
    {
        total += GetTeamPlayerNumberSprees(TeamArray[i].Player,SpreeLevel,TeamArray[i].Team);
    }

    return total;
}

function int FindPlayerActiveSpree(int Player)
{
    local int i;

    for(i=0;i<PlayerInfo[Player].Sprees.Length;i++)
    {
        if(PlayerInfo[Player].Sprees[i].bInSpree)
            return i;
    }

    return -1;
}


function RegisterKillersWeapon(int Player, string DamageName, bool bSuicide)
{
    local int WeaponRecord, PlayerWeaponRecord;
    local WeaponDetails Weapon;

    Weapon = GetWeaponDetails(DamageName);

    if(Weapon.WeaponType == 0 || Weapon.WeaponType == 1 || Weapon.WeaponType == 2)
    {
        PlayerWeaponRecord = GetPlayerWeaponRecord(Player, Weapon.WeaponName, Weapon.WeaponType);
        WeaponRecord = GetWeaponRecord(Weapon.WeaponName, Weapon.WeaponType);

        if(!bSuicide)
        {
            If (Weapon.Secondary == 0)
            {
                PlayerInfo[Player].Weapons[PlayerWeaponRecord].PrimaryKills++;
                MatchInfo.Weapons[WeaponRecord].PrimaryKills++;
            }
            else if (Weapon.Secondary == 1 || Weapon.Secondary == 2)
            {
                PlayerInfo[Player].Weapons[PlayerWeaponRecord].SecondaryKills++;
                MatchInfo.Weapons[WeaponRecord].SecondaryKills++;
            }
            else if (Weapon.Secondary == 4)
            {
                PlayerInfo[Player].Weapons[PlayerWeaponRecord].Roadkills++;
                MatchInfo.Weapons[WeaponRecord].Roadkills++;

                PlayerInfo[Player].Roadkills++;
            }
            if (Weapon.bIsHeadshot)
            {
                PlayerInfo[Player].Headshots++;
                MatchInfo.Headshots++;
            }

            if(Weapon.DamType ~= "DamTypeSniperHeadShot" || Weapon.DamType ~= "DamTypeClassicHeadshot")
            {
                PlayerInfo[Player].HeadKills++;
                if(PlayerInfo[Player].HeadKills >= 15 && PlayerInfo[Player].Headhunter == 0)
                {
                    PlayerInfo[Player].Headhunter = 1;
                    MatchInfo.Headhunter++;
                }
            }
            if(Weapon.DamType ~= "DamTypeFlakChunk" || Weapon.DamType ~= "DamTypeFlakShell")
            {
                PlayerInfo[Player].FlakKills++;
                if(PlayerInfo[Player].FlakKills >= 15 && PlayerInfo[Player].FlakMonkey == 0)
                {
                    PlayerInfo[Player].FlakMonkey = 1;
                    MatchInfo.FlakMonkey++;
                }
            }
            if(Weapon.DamType ~= "DamTypeShockCombo")
            {
                PlayerInfo[Player].ComboKills++;
                if(PlayerInfo[Player].ComboKills >= 15 && PlayerInfo[Player].ComboWhore == 0)
                {
                    PlayerInfo[Player].ComboWhore = 1;
                    MatchInfo.ComboWhore++;
                }
            }
            if(PlayerInfo[Player].Roadkills >= 15 && PlayerInfo[Player].RoadRampage == 0)
            {
                PlayerInfo[Player].RoadRampage = 1;
                MatchInfo.RoadRampage++;
            }

        } else {
            PlayerInfo[Player].Weapons[PlayerWeaponRecord].Suicides++;
            MatchInfo.Weapons[WeaponRecord].Suicides++;
        }
    }
}

function RegisterVictimsWeapon(int Player, string HeldWeapon)
{
    local int WeaponRecord, PlayerWeaponRecord;
    local WeaponDetails Weapon;

    if (HeldWeapon == "")
        return;
    Weapon = GetWeaponDetails(HeldWeapon);

    if(Weapon.WeaponType == 0 || Weapon.WeaponType == 1 || Weapon.WeaponType == 2)
    {
        PlayerWeaponRecord = GetPlayerWeaponRecord(Player, Weapon.WeaponName, Weapon.WeaponType);
        WeaponRecord = GetWeaponRecord(Weapon.WeaponName, Weapon.WeaponType);

        PlayerInfo[Player].Weapons[PlayerWeaponRecord].DeathsHolding++;
        MatchInfo.Weapons[WeaponRecord].DeathsHolding++;

    } /* else if (Weapon.WeaponType == 1 || Weapon.WeaponType == 2) {
        // If it's a vehicle

        WeaponRecord = GetPlayerVehicleRecord(Player, Weapon.WeaponName);
        if (WeaponRecord == -1)
        {
            i = PlayerInfo[Player].Vehicles.Length;
            PlayerInfo[Player].Vehicles.Length = i + 1;
            PlayerInfo[Player].Vehicles[i].VehicleName = Weapon.WeaponName;
            WeaponRecord = i;
        }
        PlayerInfo[Player].Vehicles[WeaponRecord].DeathsIn++;

        WeaponRecord = GetVehicleRecord(Weapon.WeaponName);
        if (WeaponRecord == -1)
        {
            i = MatchInfo.Vehicles.Length;
            MatchInfo.Vehicles.Length = i + 1;
            MatchInfo.Vehicles[i].VehicleName = Weapon.WeaponName;
            WeaponRecord = i;
        }
        MatchInfo.Vehicles[WeaponRecord].DeathsIn++;
    }
    */
}

function RegisterVictimsDeathWeapon(int Player, string DamageName)
{
    local int WeaponRecord, PlayerWeaponRecord;
    local WeaponDetails Weapon;

    Weapon = GetWeaponDetails(DamageName);

    if(Weapon.WeaponType == 0 || Weapon.WeaponType == 1 || Weapon.WeaponType == 2)
    {
        PlayerWeaponRecord = GetPlayerWeaponRecord(Player, Weapon.WeaponName, Weapon.WeaponType);
        WeaponRecord = GetWeaponRecord(Weapon.WeaponName, Weapon.WeaponType);

        PlayerInfo[Player].Weapons[PlayerWeaponRecord].DeathsBy++;
        MatchInfo.Weapons[WeaponRecord].DeathsBy++;

    } /*else if (Weapon.WeaponType == 1 || Weapon.WeaponType == 2) {
        // If it's a vehicle

        WeaponRecord = GetPlayerVehicleRecord(Player, Weapon.WeaponName);
        if (WeaponRecord == -1)
        {
            i = PlayerInfo[Player].Vehicles.Length;
            PlayerInfo[Player].Vehicles.Length = i + 1;
            PlayerInfo[Player].Vehicles[i].VehicleName = Weapon.WeaponName;
            WeaponRecord = i;
        }
        PlayerInfo[Player].Vehicles[WeaponRecord].DeathsBy++;

        WeaponRecord = GetVehicleRecord(Weapon.WeaponName);
        if (WeaponRecord == -1)
        {
            i = MatchInfo.Vehicles.Length;
            MatchInfo.Vehicles.Length = i + 1;
            MatchInfo.Vehicles[i].VehicleName = Weapon.WeaponName;
            WeaponRecord = i;
        }
        MatchInfo.Vehicles[WeaponRecord].DeathsBy++;
    }
    */
}

function EndGame(string Reason, string TheLogName)
{
    GenerateHTMLPage(TheLogName);
}








function string FloatToStringRound(float Number, int Decimals)
{
    local string leftpart, rightpart, temp;

    // Adjust number so it is "Rounded" correctly
    Number += (0.1f^Decimals/2);

    temp = string(Number);
    Divide(temp,".",leftpart,rightpart);
    if(Decimals > 0)
    {
        temp = leftpart$"."$left(rightpart,Decimals);
    } else {
        temp = leftpart;
    }

    return temp;
}


/***********************
    THE BIG ONE!
This is the function that
generates the entire HTML
page from the information
gathered.
************************/
function GenerateHTMLPage(string TheLogName)
{
    local string HTML;
    local int i;
    local int NumHumans;

    for(i=0;i<PlayerInfo.Length;i++)
        if(!PlayerInfo[i].bBot)
            NumHumans++;

    if(PlayerInfo.Length < class'MutOLGameStats'.default.MinPlayers || NumHumans < class'MutOLGameStats'.default.MinHumans)
    {
        Log("Not enough players. HTML logging for this match canceled.",'OLStats');
        return;
    }

    TempLog = spawn(class'FileLog');
    if (TempLog == none)
    {
        warn("Could not create HTML filelog!");
        return;
    }
    TempLog.OpenLog(TheLogName,"html",true);

    CalcSpecialValues();
    MarkWinner();

    LogHeader(MatchInfo.GameType@"in"@MatchInfo.MapName);

    // MAIN PAGE CONTENT
    HTML = "            <input type=\"hidden\" name=\"MainPage\" value=\"";
    Logf(HTML);
    MainPage();
    HTML = "\">";
    Logf(HTML);
    // !MAIN PAGE CONTENT



    // INDIVIDUAL PLAYER CONTENT
    for(i=0;i<PlayerInfo.length;i++)
    {
        HTML = "            <input type=\"hidden\" name=\"PlayerStats"$i$"\" value=\"";
        Logf(HTML);
        PlayerPage(i);
        HTML = "\">";
        Logf(HTML);
    }
    // !INDIVIDUAL PLAYER CONTENT

    LogFooter();

    TempLog.CloseLog();

    CalcAndLogGlobals(TheLogName);
}

function CalcSpecialValues()
{
    local int i, j;
    local int Team;
    local int SpreePlayer, SpreeID;

    local float Time, AvgTime;
    local float SPH, AvgSPH;
    local float Eff, AvgEff;
    local float TTL, AvgTTL;

    local string SpreeEndReason;

    MatchInfo.MatchTime = GetTime();

    AvgTime = 0;
    AvgSPH = 0;
    AvgTTL = 0;
    AvgEff = 0;

    for(i=0;i<PlayerInfo.length;i++)
    {
        Time = PlayerInfo[i].TimeConnected;
        if (PlayerInfo[i].QuitTime == 0)
            Time += GetTime() - PlayerInfo[i].JoinTime;

        SPH = PlayerInfo[i].Score / (Time * 3600);
        TTL = Time / (PlayerInfo[i].Deaths + PlayerInfo[i].Suicides + 1);

        // Eff: Kills / (Kills + Deaths + Suicides)
        if (PlayerInfo[i].Kills + PlayerInfo[i].Deaths + PlayerInfo[i].Suicides == 0)
            Eff = 0.0;
        else
            Eff = 1.f * PlayerInfo[i].Kills / (PlayerInfo[i].Kills + PlayerInfo[i].Deaths + PlayerInfo[i].Suicides) * 100;

        PlayerInfo[i].Time = Time;
        PlayerInfo[i].SPH = SPH;
        PlayerInfo[i].TTL = TTL;
        PlayerInfo[i].Eff = Eff;

        AvgTime += Time;
        AvgSPH += SPH;
        AvgTTL += TTL;
        AvgEff += Eff;

        // For each team the player has been on...
        for(j=0;j<PlayerInfo[i].ITS.length;j++)
        {
            Time = PlayerInfo[i].ITS[j].TimeConnected;
            if (PlayerInfo[i].QuitTime == 0 && PlayerInfo[i].TeamID == PlayerInfo[i].ITS[j].TeamID)
                Time += GetTime() - PlayerInfo[i].ITS[j].JoinTime;

            SPH = PlayerInfo[i].ITS[j].Score / (Time * 3600);
            TTL = Time / (PlayerInfo[i].ITS[j].Deaths + PlayerInfo[i].ITS[j].Suicides + 1);

            // Eff: Kills / (Kills + Deaths + Suicides)
            if (PlayerInfo[i].ITS[j].Kills + PlayerInfo[i].ITS[j].Deaths + PlayerInfo[i].ITS[j].Suicides == 0)
                Eff = 0.0;
            else
                Eff = 1.f * PlayerInfo[i].ITS[j].Kills / (PlayerInfo[i].ITS[j].Kills + PlayerInfo[i].ITS[j].Deaths + PlayerInfo[i].ITS[j].Suicides) * 100;

            PlayerInfo[i].ITS[j].Time = Time;
            PlayerInfo[i].ITS[j].SPH = SPH;
            PlayerInfo[i].ITS[j].TTL = TTL;
            PlayerInfo[i].ITS[j].Eff = Eff;

            Team = GetTeamStatsByID(PlayerInfo[i].ITS[j].TeamID);
            MatchInfo.Teams[Team].Time += Time;
            MatchInfo.Teams[Team].SPH += SPH;
            MatchInfo.Teams[Team].TTL += TTL;
            MatchInfo.Teams[Team].Eff += Eff;

            MatchInfo.Teams[Team].NumPlayers++;
        }
    }

    AvgTime /= PlayerInfo.Length;
    AvgSPH /= PlayerInfo.Length;
    AvgTTL /= PlayerInfo.Length;
    AvgEff /= PlayerInfo.Length;

    MatchInfo.AvgTime = AvgTime;
    MatchInfo.AvgSPH = AvgSPH;
    MatchInfo.AvgTTL = AvgTTL;
    MatchInfo.AvgEff = AvgEff;

    for(i=0;i<MatchInfo.Teams.length;i++)
    {
        MatchInfo.Teams[i].Time /= MatchInfo.Teams[i].NumPlayers;
        MatchInfo.Teams[i].SPH /= MatchInfo.Teams[i].NumPlayers;
        MatchInfo.Teams[i].TTL /= MatchInfo.Teams[i].NumPlayers;
        MatchInfo.Teams[i].Eff /= MatchInfo.Teams[i].NumPlayers;
    }

    for(i=0;i<MatchInfo.Sprees.Length;i++)
    {
        SpreePlayer = MatchInfo.Sprees[i].Player;
        SpreeID = MatchInfo.Sprees[i].Spree;

        if(PlayerInfo[SpreePlayer].Sprees[SpreeID].bInSpree)
        { // At end of game, player was still in spree (or quit)
            if (PlayerInfo[SpreePlayer].QuitTime == 0)
            { // Player was still in game at end
                Time = GetTime() - PlayerInfo[SpreePlayer].Sprees[SpreeID].TimeSpreeStarted;
                SpreeEndReason = "Game Ended";
            } else { // Player quit early, and ended spree
                Time = PlayerInfo[SpreePlayer].QuitTime - PlayerInfo[SpreePlayer].Sprees[SpreeID].TimeSpreeStarted;
                SpreeEndReason = "Player Quit";
            }
        } else { // Spree ended normally
            Time = PlayerInfo[SpreePlayer].Sprees[SpreeID].TimeSpreeEnded - PlayerInfo[SpreePlayer].Sprees[SpreeID].TimeSpreeStarted;
            if (PlayerInfo[SpreePlayer].Sprees[SpreeID].KillerID == -1)
            {
                SpreeEndReason = "Player Quit";
            } else if (PlayerInfo[SpreePlayer].Sprees[SpreeID].KillerID == SpreePlayer) {
                SpreeEndReason = "Suicided with a"@PlayerInfo[SpreePlayer].Sprees[SpreeID].KillerDamType;
            } else {
                SpreeEndReason = "Killed by"@PlayerInfo[PlayerInfo[SpreePlayer].Sprees[SpreeID].KillerID].PlayerName@"with a"@PlayerInfo[SpreePlayer].Sprees[SpreeID].KillerDamType;
            }
        }

        PlayerInfo[SpreePlayer].Sprees[SpreeID].SpreeEndReason = SpreeEndReason;
        PlayerInfo[SpreePlayer].Sprees[SpreeID].TimeInSpree = Time;
    }
}

function LogHeader(string Title)
{
    local string HTML;

    HTML = "<!doctype html public \"-//W3C//DTD HTML 4.01 Transitional//EN\">";
    Logf(HTML);

    HTML = "<html>";
    Logf(HTML);

    // HEAD
    HTML = "    <head>";
    Logf(HTML);
    HTML = "        <title>"$Title$"</title>";
    Logf(HTML);
    HTML = "        <meta http-equiv=\"Content-Type\" content=\"text/html; CHARSET=iso-8859-1\">";
    Logf(HTML);
    HTML = "        <link rel=\"icon\" href=\"resource/uicon.png\" type=\"image/png\">";
    Logf(HTML);
    HTML = "        <link rel=\"stylesheet\" href=\"resource/style2.css\">";
    Logf(HTML);


    // JAVASCRIPT
    HTML = "        <script language='Javascript'>";
    Logf(HTML);
    HTML = "        function setcontent()";
    Logf(HTML);
    HTML = "        {";
    Logf(HTML);
    HTML = "            func = getVar('func');";
    Logf(HTML);
    HTML = "            id = getVar('id');";
    Logf(HTML);
    HTML = "            if(func == '')";
    Logf(HTML);
    HTML = "                func = 'MainPage';";
    Logf(HTML);
    HTML = "            d = document.getElementById('TheContent');";
    Logf(HTML);
    HTML = "            theForm = document.contentForm;";
    Logf(HTML);
    HTML = "            eval('PageContent = theForm.'+func+id+'.value');";
    Logf(HTML);
    HTML = "            d.innerHTML = PageContent;";
    Logf(HTML);
    HTML = "        }";
    Logf(HTML);
    HTML = "        function getVar(name)";
    Logf(HTML);
    HTML = "                 {";
    Logf(HTML);
    HTML = "                 get_string = document.location.search;         ";
    Logf(HTML);
    HTML = "                 return_value = '';";
    Logf(HTML);
    HTML = "                 do { //This loop is made to catch all instances of any get variable.";
    Logf(HTML);
    HTML = "                    name_index = get_string.indexOf(name + '=');";
    Logf(HTML);
    HTML = "                    if(name_index != -1)";
    Logf(HTML);
    HTML = "                      {";
    Logf(HTML);
    HTML = "                      get_string = get_string.substr(name_index + name.length + 1, get_string.length - name_index);";
    Logf(HTML);
    HTML = "                      end_of_value = get_string.indexOf('&');";
    Logf(HTML);
    HTML = "                      if(end_of_value != -1)                ";
    Logf(HTML);
    HTML = "                        value = get_string.substr(0, end_of_value);                ";
    Logf(HTML);
    HTML = "                      else                ";
    Logf(HTML);
    HTML = "                        value = get_string;                ";
    Logf(HTML);
    HTML = "                      if(return_value == '' || value == '')";
    Logf(HTML);
    HTML = "                         return_value += value;";
    Logf(HTML);
    HTML = "                      else";
    Logf(HTML);
    HTML = "                         return_value += ', ' + value;";
    Logf(HTML);
    HTML = "                      }";
    Logf(HTML);
    HTML = "                    } while(name_index != -1)";
    Logf(HTML);
    HTML = "                 //Restores all the blank spaces.";
    Logf(HTML);
    HTML = "                 space = return_value.indexOf('+');";
    Logf(HTML);
    HTML = "                 while(space != -1)";
    Logf(HTML);
    HTML = "                      { ";
    Logf(HTML);
    HTML = "                      return_value = return_value.substr(0, space) + ' ' + ";
    Logf(HTML);
    HTML = "                      return_value.substr(space + 1, return_value.length);";
    Logf(HTML);
    HTML = "                      space = return_value.indexOf('+');";
    Logf(HTML);
    HTML = "                      }";
    Logf(HTML);
    HTML = "                 return(return_value);        ";
    Logf(HTML);
    HTML = "                 }";
    Logf(HTML);
    HTML = "        </script>";
    Logf(HTML);
    // !JAVASCRIPT

    HTML = "        <form name=contentForm>";
    Logf(HTML);
}

function LogFooter()
{
    local string HTML;

    HTML = "        </form>";
    Logf(HTML);

    HTML = "    </head>";
    Logf(HTML);
    // !HEAD

    // BODY
    HTML = "    <body onLoad=\"setcontent()\">";
    Logf(HTML);
    HTML = "       ";
    Logf(HTML);
    HTML = "       <table cellpadding=\"0\" cellspacing=\"0\" border=\"0\" width=\"880\"><tr>";
    Logf(HTML);

    // SIDEBAR
    HTML = "        <td width=\"159\" class=\"sidebar\" valign=\"top\">";
    Logf(HTML);
    HTML = "          <a href=\"http://www.unrealtournament.com\"><img SRC=\"resource/ut2k3logo2.gif\" border=\"0\" alt=\"Unreal Tournament Logo\"></a>";
    Logf(HTML);
    HTML = "          <br>";
    Logf(HTML);
    HTML = "               <p>&nbsp;<a class=\"sidebar\" href=\"OLStatsIndex.html?func=MainPage\">Main</a></p>";
    Logf(HTML);
    HTML = "               <p>&nbsp;<a class=\"sidebar\" href=\"OLStatsIndex.html?func=Matches\">Matches</a></p>";
    Logf(HTML);
    HTML = "               <p>&nbsp;<a class=\"sidebar\" href=\"OLStatsIndex.html?func=Players\">Players</a></p>";
    Logf(HTML);
    HTML = "               <p>&nbsp;<a class=\"sidebar\" href=\"OLStatsIndex.html?func=Totals\">Totals</a></p>";
    Logf(HTML);
    HTML = "               <p>&nbsp;<a class=\"sidebar\" href=\"OLStatsIndex.html?func=CareerHighs\">Career Highs</a></p>";
    Logf(HTML);
    HTML = "               <p>&nbsp;<a class=\"sidebar\" href=\"OLStatsIndex.html?func=MatchHighs\">Match Highs</a></p>";
    Logf(HTML);
    HTML = "               <p>&nbsp;<a class=\"sidebar\" href=\"OLStatsIndex.html?func=Help\">Help</a></p>";
    Logf(HTML);
    HTML = "        </td>";
    Logf(HTML);
    // !SIDEBAR

    HTML = "           <td width=\"720\" valign=\"top\" align=\"center\">";
    Logf(HTML);

    // HEADER IMAGE
    HTML = "               <table cellpadding=\"0\" cellspacing=\"0\" border=\"0\" width=\"100%\" align=\"center\">";
    Logf(HTML);
    HTML = "                   <tr>";
    Logf(HTML);
    HTML = "                       <td align=center>";
    Logf(HTML);
    HTML = "                           <a href=\"http://www.apartment167.com/olstats\"><img SRC=\"resource/olstatslogo2.gif\" border=\"0\" ALT=\"OLStats Logo\"></a>";
    Logf(HTML);
    HTML = "                       </td>";
    Logf(HTML);
    HTML = "                   </tr>";
    Logf(HTML);
    HTML = "               </table>";
    Logf(HTML);
    // !HEADER IMAGE

    HTML = "               <center>";
    LogContent(HTML);
    HTML = "               <font size=\"1\"><br /></font>";
    Logf(HTML);
    HTML = "               <div id=\"TheContent\">";
    Logf(HTML);
    HTML = "               </div>";
    Logf(HTML);

    // FOOTER MESSAGE
    HTML = "           <font size=\"1\"><br /></font>";
    Logf(HTML);
    HTML = "           <table cellpadding=\"1\" cellspacing=\"2\" border=\"0\" width=\"600\">";
    Logf(HTML);
    HTML = "             <tr>";
    Logf(HTML);
    HTML = "               <td colspan=\"10\" align=\"center\" class=\"titlemsg\">";
    Logf(HTML);
    HTML = "This page was generated by OLStats v"$class'OLLocalGameStats'.default.version;
    Logf(HTML);
    HTML = "               </td>";
    Logf(HTML);
    HTML = "             </tr>";
    Logf(HTML);
    HTML = "           </table>";
    Logf(HTML);
    // !FOOTER MESSAGE


    HTML = "              </td></tr>";
    Logf(HTML);
    HTML = "           </table>";
    Logf(HTML);
    HTML = "        </body>";
    Logf(HTML);
    HTML = "     </html>";
    Logf(HTML);
}

function CalcAndLogGlobals(string TheLogName)
{
    local int i, j, k;
    local string HTML;
    local int Pointer, GameTypePointer, WeaponPointer, HighPointer;

    LoadGlobalDataFromDisk();

    LastMatchID += 1;

    // First add this latest match to the matches array
    i = Matches.Length;
    Matches.Length = i + 1;
    Matches[i].MatchID = LastMatchID;
    Matches[i].DateTime = MatchInfo.DateTime;
    Matches[i].Date = MatchInfo.Date;
    Matches[i].FileName = TheLogName$".html";
    Matches[i].GameType = MatchInfo.GameType;
    Matches[i].MatchTime = MatchInfo.MatchTime;
    Matches[i].NumPlayers = PlayerInfo.Length;
    Matches[i].MapName = MatchInfo.MapName;

    // UPDATE ALL TOTALS
    Totals.TotalStats.Score += MatchInfo.Score;
    Totals.TotalStats.Kills += MatchInfo.Kills;
    Totals.TotalStats.Deaths += MatchInfo.Deaths;
    Totals.TotalStats.Suicides += MatchInfo.Suicides;
    Totals.TotalStats.TeamKills += MatchInfo.TeamKills;
    Totals.TotalStats.Time += MatchInfo.MatchTime;
    Totals.TotalStats.PlayerTime += (MatchInfo.AvgTime * PlayerInfo.Length);

    Totals.TotalStats.Headshots += MatchInfo.Headshots;
    Totals.TotalStats.carjackings += MatchInfo.Carjackings;
    Totals.TotalStats.failedtransloc += MatchInfo.failedtransloc;
    Totals.TotalStats.multikill_1 += MatchInfo.multikill_1;
    Totals.TotalStats.multikill_2 += MatchInfo.multikill_2;
    Totals.TotalStats.multikill_3 += MatchInfo.multikill_3;
    Totals.TotalStats.multikill_4 += MatchInfo.multikill_4;
    Totals.TotalStats.multikill_5 += MatchInfo.multikill_5;
    Totals.TotalStats.multikill_6 += MatchInfo.multikill_6;
    Totals.TotalStats.multikill_7 += MatchInfo.multikill_7;
    Totals.TotalStats.Roadkills += MatchInfo.Roadkills;

    Totals.TotalStats.FlakMonkey += MatchInfo.FlakMonkey;
    Totals.TotalStats.ComboWhore += MatchInfo.ComboWhore;
    Totals.TotalStats.RoadRampage += MatchInfo.RoadRampage;
    Totals.TotalStats.HeadHunter += MatchInfo.HeadHunter;

    Totals.TotalStats.NumMatches++;

    // WEAPONS
    for(i=0;i<MatchInfo.Weapons.Length;i++)
    {
        Pointer = -1;
        for(j=0;j<Totals.TotalStats.Weapons.Length;j++)
        {
            if(Totals.TotalStats.Weapons[j].WeaponName == MatchInfo.Weapons[i].WeaponName)
            {
                Pointer = j;
                break;
            }
        }

        if (Pointer == -1)
        {
            Pointer = Totals.TotalStats.Weapons.Length;
            Totals.TotalStats.Weapons.Length = Pointer + 1;
            Totals.TotalStats.Weapons[Pointer].WeaponName = MatchInfo.Weapons[i].WeaponName;
        }

        Totals.TotalStats.Weapons[Pointer].PrimaryKills += MatchInfo.Weapons[i].PrimaryKills;
        Totals.TotalStats.Weapons[Pointer].SecondaryKills += MatchInfo.Weapons[i].SecondaryKills;
        Totals.TotalStats.Weapons[Pointer].Suicides += MatchInfo.Weapons[i].Suicides;
        Totals.TotalStats.Weapons[Pointer].DeathsHolding += MatchInfo.Weapons[i].DeathsHolding;
        Totals.TotalStats.Weapons[Pointer].Roadkills += MatchInfo.Weapons[i].Roadkills;
    }

    // GAME TYPE
    Pointer = -1;
    for(i=0;i<Totals.GameTypes.Length;i++)
    {
        if(Totals.GameTypes[i].GameTypeClass == MatchInfo.GameTypeClass)
        {
            Pointer = i;
            break;
        }
    }

    if (Pointer == -1)
    {
        Pointer = Totals.GameTypes.Length;
        Totals.GameTypes.Length = Pointer + 1;
        Totals.GameTypes[Pointer].GameTypeClass = MatchInfo.GameTypeClass;
        Totals.GameTypes[Pointer].GameType = MatchInfo.GameType;
    }

    Totals.GameTypes[Pointer].Score += MatchInfo.Score;
    Totals.GameTypes[Pointer].Kills += MatchInfo.Kills;
    Totals.GameTypes[Pointer].Deaths += MatchInfo.Deaths;
    Totals.GameTypes[Pointer].Suicides += MatchInfo.Suicides;
    Totals.GameTypes[Pointer].TeamKills += MatchInfo.TeamKills;
    Totals.GameTypes[Pointer].Time += MatchInfo.MatchTime;
    Totals.GameTypes[Pointer].PlayerTime += (MatchInfo.AvgTime * PlayerInfo.Length);
    Totals.GameTypes[Pointer].NumMatches++;


    // PLAYERS

    for(i=0;i<PlayerInfo.Length;i++)
    {
        // Bots do not get career records
        if(!class'MutOLGameStats'.default.KeepBotRecords && PlayerInfo[i].bBot)
            continue;

        Pointer = -1;
        for(j=0;j<Players.Length;j++)
            if(Players[j].PlayerHash == PlayerInfo[i].PlayerHash)
            {
                Pointer = j;
                break;
            }

        if (Pointer == -1)
        {
            LastPlayerID += 1;
            Pointer = Players.Length;
            Players.Length = Pointer + 1;
            Players[Pointer].PlayerHash = PlayerInfo[i].PlayerHash;
            Players[Pointer].PlayerID = LastPlayerID;
            Players[Pointer].bBot = PlayerInfo[i].bBot;
        }

        PlayerInfo[i].GlobalPlayerPointer = Pointer;

        GameTypePointer = -1;
        for(j=0;j<Players[Pointer].GameTypes.Length;j++)
        {
            if(Players[Pointer].GameTypes[j].GameTypeClass == MatchInfo.GameTypeClass)
            {
                GameTypePointer = j;
                break;
            }
        }

        if(GameTypePointer == -1)
        {
            GameTypePointer = Players[Pointer].GameTypes.Length;
            Players[Pointer].GameTypes.Length = GameTypePointer + 1;

            Players[Pointer].GameTypes[GameTypePointer].GameTypeClass = MatchInfo.GameTypeClass;
            Players[Pointer].GameTypes[GameTypePointer].GameType = MatchInfo.GameType;
        }

        Players[Pointer].PlayerName = PlayerInfo[i].PlayerName;
        Players[Pointer].Score += PlayerInfo[i].Score;
        Players[Pointer].Kills += PlayerInfo[i].Kills;
        Players[Pointer].Deaths += PlayerInfo[i].Deaths;
        Players[Pointer].Suicides += PlayerInfo[i].Suicides;
        Players[Pointer].TeamKills += PlayerInfo[i].TeamKills;
        Players[Pointer].TeamDeaths += PlayerInfo[i].TeamDeaths;
        Players[Pointer].Headshots += PlayerInfo[i].Headshots;
        Players[Pointer].Roadkills += PlayerInfo[i].Roadkills;
        Players[Pointer].Carjackings += PlayerInfo[i].Carjackings;
        Players[Pointer].multikill_1 += PlayerInfo[i].multikill_1;
        Players[Pointer].multikill_2 += PlayerInfo[i].multikill_2;
        Players[Pointer].multikill_3 += PlayerInfo[i].multikill_3;
        Players[Pointer].multikill_4 += PlayerInfo[i].multikill_4;
        Players[Pointer].multikill_5 += PlayerInfo[i].multikill_5;
        Players[Pointer].multikill_6 += PlayerInfo[i].multikill_6;
        Players[Pointer].multikill_7 += PlayerInfo[i].multikill_7;
        Players[Pointer].failedtransloc += PlayerInfo[i].failedtransloc;
        Players[Pointer].Time += PlayerInfo[i].Time;
        Players[Pointer].HeadHunter += PlayerInfo[i].HeadHunter;
        Players[Pointer].FlakMonkey += PlayerInfo[i].FlakMonkey;
        Players[Pointer].ComboWhore += PlayerInfo[i].ComboWhore;
        Players[Pointer].RoadRampage += PlayerInfo[i].RoadRampage;
        Players[Pointer].NumMatches++;
        if (bFirstBlood && MatchInfo.FirstBloodID == i) Players[Pointer].FirstBloods++;
        if (PlayerInfo[i].Winstate == 1)
        {
            Players[Pointer].TotalWins++;
            if (MatchInfo.bTeamGame)
                Players[Pointer].TeamWins++;
            else
                Players[Pointer].Wins++;
        }
        else if (PlayerInfo[i].Winstate == 2)
            Players[Pointer].TotalLosses++;

        Players[Pointer].GameTypes[GameTypePointer].Score += PlayerInfo[i].Score;
        Players[Pointer].GameTypes[GameTypePointer].Kills += PlayerInfo[i].Kills;
        Players[Pointer].GameTypes[GameTypePointer].Deaths += PlayerInfo[i].Deaths;
        Players[Pointer].GameTypes[GameTypePointer].Suicides += PlayerInfo[i].Suicides;
        Players[Pointer].GameTypes[GameTypePointer].TeamKills += PlayerInfo[i].TeamKills;
        Players[Pointer].GameTypes[GameTypePointer].TeamDeaths += PlayerInfo[i].TeamDeaths;
        Players[Pointer].GameTypes[GameTypePointer].Time += PlayerInfo[i].Time;
        Players[Pointer].GameTypes[GameTypePointer].NumMatches++;

        if (PlayerInfo[i].Winstate == 1)
            Players[Pointer].GameTypes[GameTypePointer].TotalWins++;
        else if (PlayerInfo[i].Winstate == 2)
            Players[Pointer].GameTypes[GameTypePointer].TotalLosses++;

        // MATCH HIGHS
        if(PlayerInfo[i].Kills - PlayerInfo[i].Suicides > MatchHighs.MostFrags.Score)
        {
            MatchHighs.MostFrags.Player = Players[Pointer].PlayerID;
            MatchHighs.MostFrags.Score = PlayerInfo[i].Kills - PlayerInfo[i].Suicides;
            MatchHighs.MostFrags.MatchID = LastMatchID;
        }
        if(PlayerInfo[i].Kills > MatchHighs.MostKills.Score)
        {
            MatchHighs.MostKills.Player = Players[Pointer].PlayerID;
            MatchHighs.MostKills.Score = PlayerInfo[i].Kills;
            MatchHighs.MostKills.MatchID = LastMatchID;
        }
        if(PlayerInfo[i].Deaths > MatchHighs.MostDeaths.Score)
        {
            MatchHighs.MostDeaths.Player = Players[Pointer].PlayerID;
            MatchHighs.MostDeaths.Score = PlayerInfo[i].Deaths;
            MatchHighs.MostDeaths.MatchID = LastMatchID;
        }
        if(PlayerInfo[i].Suicides > MatchHighs.MostSuicides.Score)
        {
            MatchHighs.MostSuicides.Player = Players[Pointer].PlayerID;
            MatchHighs.MostSuicides.Score = PlayerInfo[i].Suicides;
            MatchHighs.MostSuicides.MatchID = LastMatchID;
        }


        // SPREES FOR PLAYER AND TOTALS
        for(j=0;j<PlayerInfo[i].Sprees.Length;j++)
        {
            switch(PlayerInfo[i].Sprees[j].SpreeLevel)
            {
                case 1:
                    Players[Pointer].Sprees.NumSprees_1++;
                    Players[Pointer].Sprees.Time_1 += PlayerInfo[i].Sprees[j].TimeInSpree;
                    Players[Pointer].Sprees.TotalKills_1 += PlayerInfo[i].Sprees[j].KillsInSpree;
                    Totals.TotalStats.Sprees.NumSprees_1++;
                    Totals.TotalStats.Sprees.Time_1 += PlayerInfo[i].Sprees[j].TimeInSpree;
                    Totals.TotalStats.Sprees.TotalKills_1 += PlayerInfo[i].Sprees[j].KillsInSpree;
                break;

                case 2:
                    Players[Pointer].Sprees.NumSprees_2++;
                    Players[Pointer].Sprees.Time_2 += PlayerInfo[i].Sprees[j].TimeInSpree;
                    Players[Pointer].Sprees.TotalKills_2 += PlayerInfo[i].Sprees[j].KillsInSpree;
                    Totals.TotalStats.Sprees.NumSprees_2++;
                    Totals.TotalStats.Sprees.Time_2 += PlayerInfo[i].Sprees[j].TimeInSpree;
                    Totals.TotalStats.Sprees.TotalKills_2 += PlayerInfo[i].Sprees[j].KillsInSpree;
                break;

                case 3:
                    Players[Pointer].Sprees.NumSprees_3++;
                    Players[Pointer].Sprees.Time_3 += PlayerInfo[i].Sprees[j].TimeInSpree;
                    Players[Pointer].Sprees.TotalKills_3 += PlayerInfo[i].Sprees[j].KillsInSpree;
                    Totals.TotalStats.Sprees.NumSprees_3++;
                    Totals.TotalStats.Sprees.Time_3 += PlayerInfo[i].Sprees[j].TimeInSpree;
                    Totals.TotalStats.Sprees.TotalKills_3 += PlayerInfo[i].Sprees[j].KillsInSpree;
                break;

                case 4:
                    Players[Pointer].Sprees.NumSprees_4++;
                    Players[Pointer].Sprees.Time_4 += PlayerInfo[i].Sprees[j].TimeInSpree;
                    Players[Pointer].Sprees.TotalKills_4 += PlayerInfo[i].Sprees[j].KillsInSpree;
                    Totals.TotalStats.Sprees.NumSprees_4++;
                    Totals.TotalStats.Sprees.Time_4 += PlayerInfo[i].Sprees[j].TimeInSpree;
                    Totals.TotalStats.Sprees.TotalKills_4 += PlayerInfo[i].Sprees[j].KillsInSpree;
                break;

                case 5:
                    Players[Pointer].Sprees.NumSprees_5++;
                    Players[Pointer].Sprees.Time_5 += PlayerInfo[i].Sprees[j].TimeInSpree;
                    Players[Pointer].Sprees.TotalKills_5 += PlayerInfo[i].Sprees[j].KillsInSpree;
                    Totals.TotalStats.Sprees.NumSprees_5++;
                    Totals.TotalStats.Sprees.Time_5 += PlayerInfo[i].Sprees[j].TimeInSpree;
                    Totals.TotalStats.Sprees.TotalKills_5 += PlayerInfo[i].Sprees[j].KillsInSpree;
                break;

                case 6:
                default:
                    Players[Pointer].Sprees.NumSprees_6++;
                    Players[Pointer].Sprees.Time_6 += PlayerInfo[i].Sprees[j].TimeInSpree;
                    Players[Pointer].Sprees.TotalKills_6 += PlayerInfo[i].Sprees[j].KillsInSpree;
                    Totals.TotalStats.Sprees.NumSprees_6++;
                    Totals.TotalStats.Sprees.Time_6 += PlayerInfo[i].Sprees[j].TimeInSpree;
                    Totals.TotalStats.Sprees.TotalKills_6 += PlayerInfo[i].Sprees[j].KillsInSpree;
                break;
            }
        } // End for each spree

        for(j=0;j<PlayerInfo[i].Weapons.Length;j++)
        {
            WeaponPointer = -1;
            for(k=0;k<Players[Pointer].Weapons.Length;k++)
            {
                if(Players[Pointer].Weapons[k].WeaponName == PlayerInfo[i].Weapons[j].WeaponName)
                {
                    WeaponPointer = k;
                    break;
                }
            }

            if(WeaponPointer == -1)
            {
                WeaponPointer = Players[Pointer].Weapons.Length;
                Players[Pointer].Weapons.Length = WeaponPointer + 1;
                Players[Pointer].Weapons[WeaponPointer].WeaponName = PlayerInfo[i].Weapons[j].WeaponName;
                Players[Pointer].Weapons[WeaponPointer].WeaponType = PlayerInfo[i].Weapons[j].WeaponType;
            }

            Players[Pointer].Weapons[WeaponPointer].PrimaryKills += PlayerInfo[i].Weapons[j].PrimaryKills;
            Players[Pointer].Weapons[WeaponPointer].SecondaryKills += PlayerInfo[i].Weapons[j].SecondaryKills;
            Players[Pointer].Weapons[WeaponPointer].Roadkills += PlayerInfo[i].Weapons[j].Roadkills;
            Players[Pointer].Weapons[WeaponPointer].DeathsHolding += PlayerInfo[i].Weapons[j].DeathsHolding;
            Players[Pointer].Weapons[WeaponPointer].DeathsBy += PlayerInfo[i].Weapons[j].DeathsBy;
            Players[Pointer].Weapons[WeaponPointer].Suicides += PlayerInfo[i].Weapons[j].Suicides;



            if(Players[Pointer].Weapons[WeaponPointer].PrimaryKills + Players[Pointer].Weapons[WeaponPointer].SecondaryKills + Players[Pointer].Weapons[WeaponPointer].Roadkills > 0)
            {
                HighPointer = -1;
                for(k=0;k<CareerHighs.MostWeaponKills.Length;k++)
                {
                    if(CareerHighs.MostWeaponKills[k].WeaponName == Players[Pointer].Weapons[WeaponPointer].WeaponName)
                    {
                        HighPointer = k;
                        break;
                    }
                }

                if(HighPointer == -1)
                {
                    HighPointer = CareerHighs.MostWeaponKills.Length;
                    CareerHighs.MostWeaponKills.Length = HighPointer + 1;
                    CareerHighs.MostWeaponKills[HighPointer].WeaponName = Players[Pointer].Weapons[WeaponPointer].WeaponName;
                }

                if(CareerHighs.MostWeaponKills[HighPointer].Score < Players[Pointer].Weapons[WeaponPointer].PrimaryKills + Players[Pointer].Weapons[WeaponPointer].SecondaryKills + Players[Pointer].Weapons[WeaponPointer].Roadkills)
                {
                    CareerHighs.MostWeaponKills[HighPointer].Score = Players[Pointer].Weapons[WeaponPointer].PrimaryKills + Players[Pointer].Weapons[WeaponPointer].SecondaryKills + Players[Pointer].Weapons[WeaponPointer].Roadkills;
                    CareerHighs.MostWeaponKills[HighPointer].Player = Players[Pointer].PlayerID;
                }
            }

            if(PlayerInfo[i].Weapons[j].PrimaryKills + PlayerInfo[i].Weapons[j].SecondaryKills + PlayerInfo[i].Weapons[j].Roadkills > 0)
            {
                HighPointer = -1;
                for(k=0;k<MatchHighs.MostWeaponKills.Length;k++)
                {
                    if(MatchHighs.MostWeaponKills[k].WeaponName == PlayerInfo[i].Weapons[j].WeaponName)
                    {
                        HighPointer = k;
                        break;
                    }
                }

                if(HighPointer == -1)
                {
                    HighPointer = MatchHighs.MostWeaponKills.Length;
                    MatchHighs.MostWeaponKills.Length = HighPointer + 1;
                    MatchHighs.MostWeaponKills[HighPointer].WeaponName = PlayerInfo[i].Weapons[j].WeaponName;
                }

                if(MatchHighs.MostWeaponKills[HighPointer].Score < PlayerInfo[i].Weapons[j].PrimaryKills + PlayerInfo[i].Weapons[j].SecondaryKills + PlayerInfo[i].Weapons[j].Roadkills)
                {
                    MatchHighs.MostWeaponKills[HighPointer].Score = PlayerInfo[i].Weapons[j].PrimaryKills + PlayerInfo[i].Weapons[j].SecondaryKills + PlayerInfo[i].Weapons[j].Roadkills;
                    MatchHighs.MostWeaponKills[HighPointer].Player = Players[Pointer].PlayerID;
                    MatchHighs.MostWeaponKills[HighPointer].MatchID = LastMatchID;
                }
            }
        } // End for each weapon

        // CAREER HIGHS
        if(Players[Pointer].Kills - Players[Pointer].Suicides > CareerHighs.MostFrags.Score)
        {
            CareerHighs.MostFrags.Player = Players[Pointer].PlayerID;
            CareerHighs.MostFrags.Score = Players[Pointer].Kills - Players[Pointer].Suicides;
        }
        if(Players[Pointer].Kills > CareerHighs.MostKills.Score)
        {
            CareerHighs.MostKills.Player = Players[Pointer].PlayerID;
            CareerHighs.MostKills.Score = Players[Pointer].Kills;
        }
        if(Players[Pointer].Deaths > CareerHighs.MostDeaths.Score)
        {
            CareerHighs.MostDeaths.Player = Players[Pointer].PlayerID;
            CareerHighs.MostDeaths.Score = Players[Pointer].Deaths;
        }
        if(Players[Pointer].Suicides > CareerHighs.MostSuicides.Score)
        {
            CareerHighs.MostSuicides.Player = Players[Pointer].PlayerID;
            CareerHighs.MostSuicides.Score = Players[Pointer].Suicides;
        }

        if(Players[Pointer].Wins > CareerHighs.MostWins.Score)
        {
            CareerHighs.MostWins.Player = Players[Pointer].PlayerID;
            CareerHighs.MostWins.Score = Players[Pointer].Wins;
        }
        if(Players[Pointer].TeamWins > CareerHighs.MostTeamWins.Score)
        {
            CareerHighs.MostTeamWins.Player = Players[Pointer].PlayerID;
            CareerHighs.MostTeamWins.Score = Players[Pointer].TeamWins;
        }

        if(Players[Pointer].Headshots > CareerHighs.MostHeadshots.Score)
        {
            CareerHighs.MostHeadshots.Player = Players[Pointer].PlayerID;
            CareerHighs.MostHeadshots.Score = Players[Pointer].Headshots;
        }
        if(1.f * Players[Pointer].Score / (Players[Pointer].Time / 3600) > CareerHighs.HighestSPH.Score)
        {
            CareerHighs.HighestSPH.Player = Players[Pointer].PlayerID;
            CareerHighs.HighestSPH.Score = 1.f * Players[Pointer].Score / (Players[Pointer].Time / 3600);
        }
        if(Players[Pointer].FirstBloods > CareerHighs.MostFirstBlood.Score)
        {
            CareerHighs.MostFirstBlood.Player = Players[Pointer].PlayerID;
            CareerHighs.MostFirstBlood.Score = Players[Pointer].FirstBloods;
        }
        if(Players[Pointer].Carjackings > CareerHighs.MostCarjackings.Score)
        {
            CareerHighs.MostCarjackings.Player = Players[Pointer].PlayerID;
            CareerHighs.MostCarjackings.Score = Players[Pointer].Carjackings;
        }
        if(Players[Pointer].Roadkills > CareerHighs.MostRoadkills.Score)
        {
            CareerHighs.MostRoadkills.Player = Players[Pointer].PlayerID;
            CareerHighs.MostRoadkills.Score = Players[Pointer].Roadkills;
        }

        if(Players[Pointer].HeadHunter > CareerHighs.MostHeadhunter.Score)
        {
            CareerHighs.MostHeadhunter.Player = Players[Pointer].PlayerID;
            CareerHighs.MostHeadhunter.Score = Players[Pointer].HeadHunter;
        }
        if(Players[Pointer].FlakMonkey > CareerHighs.MostFlakMonkey.Score)
        {
            CareerHighs.MostFlakMonkey.Player = Players[Pointer].PlayerID;
            CareerHighs.MostFlakMonkey.Score = Players[Pointer].FlakMonkey;
        }
        if(Players[Pointer].ComboWhore > CareerHighs.MostComboWhore.Score)
        {
            CareerHighs.MostComboWhore.Player = Players[Pointer].PlayerID;
            CareerHighs.MostComboWhore.Score = Players[Pointer].ComboWhore;
        }
        if(Players[Pointer].RoadRampage > CareerHighs.MostRoadRampage.Score)
        {
            CareerHighs.MostRoadRampage.Player = Players[Pointer].PlayerID;
            CareerHighs.MostRoadRampage.Score = Players[Pointer].RoadRampage;
        }

        if(Players[Pointer].multikill_1 > CareerHighs.MostMultikill_1.Score)
        {
            CareerHighs.MostMultikill_1.Player = Players[Pointer].PlayerID;
            CareerHighs.MostMultikill_1.Score = Players[Pointer].multikill_1;
        }
        if(Players[Pointer].multikill_2 > CareerHighs.MostMultikill_2.Score)
        {
            CareerHighs.MostMultikill_2.Player = Players[Pointer].PlayerID;
            CareerHighs.MostMultikill_2.Score = Players[Pointer].multikill_2;
        }
        if(Players[Pointer].multikill_3 > CareerHighs.MostMultikill_3.Score)
        {
            CareerHighs.MostMultikill_3.Player = Players[Pointer].PlayerID;
            CareerHighs.MostMultikill_3.Score = Players[Pointer].multikill_3;
        }
        if(Players[Pointer].multikill_4 > CareerHighs.MostMultikill_4.Score)
        {
            CareerHighs.MostMultikill_4.Player = Players[Pointer].PlayerID;
            CareerHighs.MostMultikill_4.Score = Players[Pointer].multikill_4;
        }
        if(Players[Pointer].multikill_5 > CareerHighs.MostMultikill_5.Score)
        {
            CareerHighs.MostMultikill_5.Player = Players[Pointer].PlayerID;
            CareerHighs.MostMultikill_5.Score = Players[Pointer].multikill_5;
        }
        if(Players[Pointer].multikill_6 > CareerHighs.MostMultikill_6.Score)
        {
            CareerHighs.MostMultikill_6.Player = Players[Pointer].PlayerID;
            CareerHighs.MostMultikill_6.Score = Players[Pointer].multikill_6;
        }
        if(Players[Pointer].multikill_7 > CareerHighs.MostMultikill_7.Score)
        {
            CareerHighs.MostMultikill_7.Player = Players[Pointer].PlayerID;
            CareerHighs.MostMultikill_7.Score = Players[Pointer].multikill_7;
        }

        if(Players[Pointer].Sprees.NumSprees_1 > CareerHighs.MostKillingSpree_1.Score)
        {
            CareerHighs.MostKillingSpree_1.Player = Players[Pointer].PlayerID;
            CareerHighs.MostKillingSpree_1.Score = Players[Pointer].Sprees.NumSprees_1;
        }
        if(Players[Pointer].Sprees.NumSprees_2 > CareerHighs.MostKillingSpree_2.Score)
        {
            CareerHighs.MostKillingSpree_2.Player = Players[Pointer].PlayerID;
            CareerHighs.MostKillingSpree_2.Score = Players[Pointer].Sprees.NumSprees_2;
        }
        if(Players[Pointer].Sprees.NumSprees_3 > CareerHighs.MostKillingSpree_3.Score)
        {
            CareerHighs.MostKillingSpree_3.Player = Players[Pointer].PlayerID;
            CareerHighs.MostKillingSpree_3.Score = Players[Pointer].Sprees.NumSprees_3;
        }
        if(Players[Pointer].Sprees.NumSprees_4 > CareerHighs.MostKillingSpree_4.Score)
        {
            CareerHighs.MostKillingSpree_4.Player = Players[Pointer].PlayerID;
            CareerHighs.MostKillingSpree_4.Score = Players[Pointer].Sprees.NumSprees_4;
        }
        if(Players[Pointer].Sprees.NumSprees_5 > CareerHighs.MostKillingSpree_5.Score)
        {
            CareerHighs.MostKillingSpree_5.Player = Players[Pointer].PlayerID;
            CareerHighs.MostKillingSpree_5.Score = Players[Pointer].Sprees.NumSprees_5;
        }
        if(Players[Pointer].Sprees.NumSprees_6 > CareerHighs.MostKillingSpree_6.Score)
        {
            CareerHighs.MostKillingSpree_6.Player = Players[Pointer].PlayerID;
            CareerHighs.MostKillingSpree_6.Score = Players[Pointer].Sprees.NumSprees_6;
        }

    } // End for each player in this match




    // CREATE THE OLSTATS INDEX PAGE
    TempLog = spawn(class'FileLog');
    if (TempLog == none)
    {
        warn("Could not create HTML filelog!");
        return;
    }
    TempLog.OpenLog("OLStatsIndex","html",true);

    LogHeader("Local OLStats Database v"$class'OLLocalGameStats'.default.version);

    // FRONT PAGE CONTENT
    HTML = "            <input type=\"hidden\" name=\"MainPage\" value=\"";
    Logf(HTML);
    GlobalsFrontPage();
    HTML = "\">";
    Logf(HTML);
    // !FRONT PAGE CONTENT

    // MATCHES PAGE CONTENT
    HTML = "            <input type=\"hidden\" name=\"Matches\" value=\"";
    Logf(HTML);
    GlobalsMatchesPage();
    HTML = "\">";
    Logf(HTML);
    // !MATCHES PAGE CONTENT

    // PLAYERS PAGE
    HTML = "            <input type=\"hidden\" name=\"Players\" value=\"";
    Logf(HTML);
    GlobalsPlayersIndexPage();
    HTML = "\">";
    Logf(HTML);
    // !PLAYERS PAGE

    // TOTALS PAGE CONTENT
    HTML = "            <input type=\"hidden\" name=\"Totals\" value=\"";
    Logf(HTML);
    GlobalsTotalsPage();
    HTML = "\">";
    Logf(HTML);
    // !TOTALS PAGE CONTENT

    // CAREER HIGHS CONTENT
    HTML = "            <input type=\"hidden\" name=\"CareerHighs\" value=\"";
    Logf(HTML);
    CareerHighsPage();
    HTML = "\">";
    Logf(HTML);
    // !CAREER HIGHS CONTENT

    // MATCH HIGHS CONTENT
    HTML = "            <input type=\"hidden\" name=\"MatchHighs\" value=\"";
    Logf(HTML);
    MatchHighsPage();
    HTML = "\">";
    Logf(HTML);
    // !MATCH HIGHS CONTENT

    // HELP PAGE
    HTML = "            <input type=\"hidden\" name=\"Help\" value=\"";
    Logf(HTML);
    GlobalsHelpPage();
    HTML = "\">";
    Logf(HTML);
    // !HELP PAGE

/*
    // PLAYERS
    for(i=0;i<Players.Length;i++)
    {
        HTML = "            <input type=\"hidden\" name=\"PlayerStats"$Players[i].PlayerID$"\" value=\"";
        Logf(HTML);
        GlobalsPlayerPage(i);
        HTML = "\">";
        Logf(HTML);
    }
    // !PLAYERS
*/

    LogFooter();
    TempLog.CloseLog();


    // Each player gets his own html document
    // Originally all the player pages were stored inside the index page,
    // but as more and more new players appeared, it would take longer and
    // longer to generate that page.
    // This way the only pages that need to be recreated are for the players
    // that were actually in this match.  (Usually not more than 32)
    for(i=0;i<PlayerInfo.Length;i++)
    {
        // Bots do not get career records
        if(!class'MutOLGameStats'.default.KeepBotRecords && PlayerInfo[i].bBot)
            continue;

        Pointer = PlayerInfo[i].GlobalPlayerPointer;

        TempLog = spawn(class'FileLog');
        if (TempLog == none)
        {
            warn("Could not create HTML filelog!");
            continue;
        }
        TempLog.OpenLog("OLStatsPlayer"$Players[Pointer].PlayerID,"html",true);

        LogHeader("Career stats for"@Players[Pointer].PlayerName@"["$Players[Pointer].PlayerID$"]");
        // CONTENT
        HTML = "            <input type=\"hidden\" name=\"MainPage\" value=\"";
        Logf(HTML);
        GlobalsPlayerPage(Pointer);
        HTML = "\">";
        Logf(HTML);
        // !CONTENT
        LogFooter();

        TempLog.CloseLog();
    }

    SaveGlobalDataToDisk();
}

function LoadGlobalDataFromDisk()
{
    local OLStatsVersionHolder Version;

    Data = Level.Game.LoadDataObject(class'OLStatsDataHolder', "OLStatsDB", "OLStatsDB");
    if (Data == None)
    {
        Data = Level.Game.CreateDataObject(class'OLStatsDataHolder', "OLStatsDB", "OLStatsDB");
        Log("No OLStats Database was found. Creating a new one.",'OLStats');
        Version = Level.Game.CreateDataObject(class'OLStatsVersionHolder', "Version", "OLStatsDB");
        Version.Version = class'OLLocalGameStats'.default.version;
    } else {
        Version = Level.Game.LoadDataObject(class'OLStatsVersionHolder', "Version", "OLStatsDB");
        if (Version == None)
        {
            Log("For some reason, no version data was found in the database. Probably from a beta version.",'OLStats');
            Log("Assuming database is version 3.00...",'OLStats');
            Version = Level.Game.CreateDataObject(class'OLStatsVersionHolder', "Version", "OLStatsDB");
            Version.Version = "3.00";
        }

        CheckDatabaseUpdate(Version.Version);
    }

    Matches = Data.Matches;
    LastMatchID = Data.LastMatchID;
    Totals = Data.Totals;
    Players = Data.Players;
    LastPlayerID = Data.LastPlayerID;
    CareerHighs = Data.CareerHighs;
    MatchHighs = Data.MatchHighs;
}

function SaveGlobalDataToDisk()
{
    Data.Matches = Matches;
    Data.LastMatchID = LastMatchID;
    Data.Totals = Totals;
    Data.Players = Players;
    Data.LastPlayerID = LastPlayerID;
    Data.CareerHighs = CareerHighs;
    Data.MatchHighs = MatchHighs;

    Level.Game.SavePackage("OLStatsDB");
}

// In the future, this will be used when a new version is released with an updated
// OLStatsDataHolder class.
function CheckDatabaseUpdate(string Version)
{
    return;
}

function GlobalsFrontPage()
{
    local string HTML;


    HTML = "               <table cellpadding=\"1\" cellspacing=\"2\" border=\"0\" width=\"500\" class=\"box\">";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"heading\" colspan=\"9\" align=\"center\">Local OLStats Database v"$class'OLLocalGameStats'.default.version$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Total Score</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Total Frags</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Total Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Team Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Total Headshots</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Matches Logged</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Player Hours</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.TotalStats.Score$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.TotalStats.Kills-Totals.TotalStats.Suicides$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.TotalStats.Kills$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.TotalStats.TeamKills$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.TotalStats.Headshots$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.TotalStats.NumMatches$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Totals.TotalStats.PlayerTime / 3600,1)$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "               </table>";
    LogContent(HTML);
    HTML = "               <br />";
    LogContent(HTML);
    HTML = "               <table cellpadding=\"1\" cellspacing=\"0\" border=\"0\" width=\"350\" class=\"box\">";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"lglheading\" align=\"center\"><b>Last Match Logged</b></td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"heading\" align=\"center\">";
    LogContent(HTML);
    HTML = "                     <a class=\"lglheading\" href=\""$Matches[Matches.Length-1].FileName$"\"><b>"$Matches[Matches.Length-1].MapName$"</b><br>";
    LogContent(HTML);
    HTML = "                     <b>"$Matches[Matches.Length-1].DateTime$"</b></a>";
    LogContent(HTML);
    HTML = "                   </td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "               </table>";
    LogContent(HTML);
}

function GlobalsMatchesPage()
{
    local string HTML;
    local int i;

    HTML = "               <table cellpadding=\"1\" cellspacing=\"2 border=\"0 class=\"box\">";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"heading\" colspan=\"5\" align=\"center\">Unreal Tournament Match List</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"220\">Date</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"160\">Match Type</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"200\">Map</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"50\">Players</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"40\">Time</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);

    for(i=Matches.length-1;i>=0;i--)
    {
        HTML = "                 <tr>";
        LogContent(HTML);
        HTML = "                   <td class=\"dark\" align=\"center\"><a class=\"dark\" href=\""$Matches[i].FileName$"\">"$Matches[i].DateTime$"</a></td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Matches[i].GameType$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Matches[i].MapName$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Matches[i].NumPlayers$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Matches[i].MatchTime / 60,1)$"</td>";
        LogContent(HTML);
        HTML = "                 </tr>";
        LogContent(HTML);
    }


    HTML = "               </table>";
    LogContent(HTML);
}

function GlobalsTotalsPage()
{
    local string HTML;
    local int i;
    local float SPH, Eff, TTL;
    local array<int> WeaponArray;

    HTML = "               <table cellpadding=\"1\" cellspacing=\"2\" border=\"0\" class=\"box\">";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"medheading\" align=\"center\" colspan=\"12\">Summary</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"150\">Game Type</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"45\">Score</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"35\">F</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"35\">K</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"35\">D</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"35\">S</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"35\">TK</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"45\">Eff.</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"40\">Avg SPH</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"40\">Avg TTL</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"50\">Matches</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"45\">Hours</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);

    for(i=0;i<Totals.GameTypes.Length;i++)
    {
        SPH = Totals.GameTypes[i].Score / Totals.GameTypes[i].PlayerTime * 3600;
        TTL = Totals.GameTypes[i].PlayerTime / (Totals.GameTypes[i].Deaths + Totals.GameTypes[i].Suicides + 1);

        // Eff: Kills / (Kills + Deaths + Suicides)
        if (Totals.GameTypes[i].Kills + Totals.GameTypes[i].Deaths + Totals.GameTypes[i].Suicides == 0)
            Eff = 0.0;
        else
            Eff = 1.f * Totals.GameTypes[i].Kills / (Totals.GameTypes[i].Kills + Totals.GameTypes[i].Deaths + Totals.GameTypes[i].Suicides) * 100;

        HTML = "                 <tr>";
        LogContent(HTML);
        HTML = "                   <td class=\"dark\" align=\"center\">"$Totals.GameTypes[i].GameType$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.GameTypes[i].Score$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.GameTypes[i].Kills-Totals.GameTypes[i].Suicides$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.GameTypes[i].Kills$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.GameTypes[i].Deaths$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.GameTypes[i].Suicides$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.GameTypes[i].TeamKills$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Eff,1)$"%</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(SPH,1)$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(TTL,1)$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.GameTypes[i].NumMatches$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Totals.GameTypes[i].Time / 3600,1)$"</td>";
        LogContent(HTML);
        HTML = "                 </tr>";
        LogContent(HTML);
    }

    SPH = Totals.TotalStats.Score / Totals.TotalStats.PlayerTime * 3600;
    TTL = Totals.TotalStats.PlayerTime / (Totals.TotalStats.Deaths + Totals.TotalStats.Suicides + 1);

    // Eff: Kills / (Kills + Deaths + Suicides)
    if (Totals.TotalStats.Kills + Totals.TotalStats.Deaths + Totals.TotalStats.Suicides == 0)
        Eff = 0.0;
    else
        Eff = 1.f * Totals.TotalStats.Kills / (Totals.TotalStats.Kills + Totals.TotalStats.Deaths + Totals.TotalStats.Suicides) * 100;

    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Totals</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"darkgrey\" align=\"center\">"$Totals.TotalStats.Score$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"darkgrey\" align=\"center\">"$Totals.TotalStats.Kills-Totals.TotalStats.Suicides$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"darkgrey\" align=\"center\">"$Totals.TotalStats.Kills$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"darkgrey\" align=\"center\">"$Totals.TotalStats.Deaths$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"darkgrey\" align=\"center\">"$Totals.TotalStats.Suicides$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"darkgrey\" align=\"center\">"$Totals.TotalStats.TeamKills$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"darkgrey\" align=\"center\">"$FloatToStringRound(Eff,1)$"%</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"darkgrey\" align=\"center\">"$FloatToStringRound(SPH,1)$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"darkgrey\" align=\"center\">"$FloatToStringRound(TTL,1)$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"darkgrey\" align=\"center\">"$Totals.TotalStats.NumMatches$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"darkgrey\" align=\"center\">"$FloatToStringRound(Totals.TotalStats.Time / 3600,1)$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "               </table>";
    LogContent(HTML);





    HTML = "               <font size=\"1\"><br /></font>";
    LogContent(HTML);
    HTML = "               <table cellpadding=\"1\" cellspacing=\"2\" border=\"0\" class=\"box\">";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"medheading\" align=\"center\" colspan=\"6\">Special Events</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\" width=\"100\">Headshots</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\" width=\"45\">"$Totals.TotalStats.Headshots$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\" width=\"105\">Failed Transloc</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\" width=\"45\">"$Totals.TotalStats.failedtransloc$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\" width=\"95\">Double Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\" width=\"45\">"$Totals.TotalStats.multikill_1$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Multi Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.TotalStats.multikill_2$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Mega Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.TotalStats.multikill_3$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Ultra Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.TotalStats.multikill_4$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Monster Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.TotalStats.multikill_5$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Ludicrous Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.TotalStats.multikill_6$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Holy Shit Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.TotalStats.multikill_7$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Headhunter</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.TotalStats.HeadHunter$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Flak Monkey</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.TotalStats.FlakMonkey$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Combo Whore</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.TotalStats.ComboWhore$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Road Rampage</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.TotalStats.RoadRampage$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Roadkills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.TotalStats.Roadkills$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Carjackings</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.TotalStats.carjackings$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "               </table>";
    LogContent(HTML);

    // WEAPON STATS
    HTML = "               <font size=\"1\"><br /></font>";
    LogContent(HTML);
    HTML = "               <table cellpadding=\"1\" cellspacing=\"2\" border=\"0\" width=\"590\" class=\"box\">";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"heading\" colspan=\"8\" align=\"center\">Weapon Specific Totals</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Weapon</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"55\">Frags</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"55\">Primary Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"70\">Secondary Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"55\">Deaths Holding</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"55\">Suicides</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"55\">Eff.</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);

    WeaponArray = GetTotalsWeaponArrayByFrags(false);
    for (i=0;i<WeaponArray.Length;i++)
    {
        // Eff: Kills / (Kills + Deaths + Suicides)
        if (Totals.TotalStats.Weapons[WeaponArray[i]].PrimaryKills + Totals.TotalStats.Weapons[WeaponArray[i]].SecondaryKills + Totals.TotalStats.Weapons[WeaponArray[i]].Roadkills + Totals.TotalStats.Weapons[WeaponArray[i]].DeathsHolding + Totals.TotalStats.Weapons[WeaponArray[i]].Suicides == 0)
            Eff = 0.0;
        else
            Eff = 1.f * (Totals.TotalStats.Weapons[WeaponArray[i]].PrimaryKills + Totals.TotalStats.Weapons[WeaponArray[i]].SecondaryKills + Totals.TotalStats.Weapons[WeaponArray[i]].Roadkills) / (Totals.TotalStats.Weapons[WeaponArray[i]].PrimaryKills + Totals.TotalStats.Weapons[WeaponArray[i]].SecondaryKills + Totals.TotalStats.Weapons[WeaponArray[i]].Roadkills + Totals.TotalStats.Weapons[WeaponArray[i]].DeathsHolding + Totals.TotalStats.Weapons[WeaponArray[i]].Suicides) * 100;

        HTML = "                 <tr>";
        LogContent(HTML);
        HTML = "                   <td class=\"dark\" align=\"center\">"$Totals.TotalStats.Weapons[WeaponArray[i]].WeaponName$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.TotalStats.Weapons[WeaponArray[i]].PrimaryKills + Totals.TotalStats.Weapons[WeaponArray[i]].SecondaryKills + Totals.TotalStats.Weapons[WeaponArray[i]].Roadkills - Totals.TotalStats.Weapons[WeaponArray[i]].Suicides$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.TotalStats.Weapons[WeaponArray[i]].PrimaryKills$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.TotalStats.Weapons[WeaponArray[i]].SecondaryKills$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.TotalStats.Weapons[WeaponArray[i]].DeathsHolding$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.TotalStats.Weapons[WeaponArray[i]].Suicides$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Eff,1)$"%</td>";
        LogContent(HTML);
        HTML = "                 </tr>";
        LogContent(HTML);
    }

    HTML = "               </table>";
    LogContent(HTML);
    // !WEAPON STATS


    // VEHICLE STATS
    HTML = "               <font size=\"1\"><br /></font>";
    LogContent(HTML);
    HTML = "               <table cellpadding=\"1\" cellspacing=\"2\" border=\"0\" width=\"660\" class=\"box\">";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"heading\" colspan=\"8\" align=\"center\">Vehicle and Turret Specific Totals</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Vehicle/Turret</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"55\">Frags</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"70\">Primary Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"70\">Secondary Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"55\">Road Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"55\">Deaths In</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"55\">Suicides</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"60\">Eff.</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);

    WeaponArray = GetTotalsWeaponArrayByFrags(true);
    for (i=0;i<WeaponArray.Length;i++)
    {
        // Eff: Kills / (Kills + Deaths + Suicides)
        if (Totals.TotalStats.Weapons[WeaponArray[i]].PrimaryKills + Totals.TotalStats.Weapons[WeaponArray[i]].SecondaryKills + Totals.TotalStats.Weapons[WeaponArray[i]].Roadkills + Totals.TotalStats.Weapons[WeaponArray[i]].DeathsHolding + Totals.TotalStats.Weapons[WeaponArray[i]].Suicides == 0)
            Eff = 0.0;
        else
            Eff = 1.f * (Totals.TotalStats.Weapons[WeaponArray[i]].PrimaryKills + Totals.TotalStats.Weapons[WeaponArray[i]].SecondaryKills + Totals.TotalStats.Weapons[WeaponArray[i]].Roadkills) / (Totals.TotalStats.Weapons[WeaponArray[i]].PrimaryKills + Totals.TotalStats.Weapons[WeaponArray[i]].SecondaryKills + Totals.TotalStats.Weapons[WeaponArray[i]].Roadkills + Totals.TotalStats.Weapons[WeaponArray[i]].DeathsHolding + Totals.TotalStats.Weapons[WeaponArray[i]].Suicides) * 100;

        HTML = "                 <tr>";
        LogContent(HTML);
        HTML = "                   <td class=\"dark\" align=\"center\">"$Totals.TotalStats.Weapons[WeaponArray[i]].WeaponName$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.TotalStats.Weapons[WeaponArray[i]].PrimaryKills + Totals.TotalStats.Weapons[WeaponArray[i]].SecondaryKills + Totals.TotalStats.Weapons[WeaponArray[i]].Roadkills - Totals.TotalStats.Weapons[WeaponArray[i]].Suicides$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.TotalStats.Weapons[WeaponArray[i]].PrimaryKills$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.TotalStats.Weapons[WeaponArray[i]].SecondaryKills$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.TotalStats.Weapons[WeaponArray[i]].Roadkills$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.TotalStats.Weapons[WeaponArray[i]].DeathsHolding$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.TotalStats.Weapons[WeaponArray[i]].Suicides$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Eff,1)$"%</td>";
        LogContent(HTML);
        HTML = "                 </tr>";
        LogContent(HTML);
    }

    HTML = "               </table>";
    LogContent(HTML);
    // !VEHICLE STATS
}

function CareerHighsPage()
{
    local string HTML;
    local int i;
    local string PlayerString, ClassName, WeaponName;
    local int Score;
    local int NumMatches;
    local float Hours;
    local float ScoreFloat;
    local array<int> WeaponArray;


    HTML = "               <table cellpadding=\"1\" cellspacing=\"2\" border=\"0\" class=\"box\">";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"heading\" align=\"center\" colspan=\"7\">Totals Logged</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"60\">Frags</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"60\">Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"60\">Deaths</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"60\">Suicides</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"55\">Matches</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"85\">Game Hours</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"85\">Player Hours</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.TotalStats.Kills - Totals.TotalStats.Suicides$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.TotalStats.Kills$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.TotalStats.Deaths$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.TotalStats.Suicides$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.TotalStats.NumMatches$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Totals.TotalStats.Time/3600,1)$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Totals.TotalStats.PlayerTime/3600,1)$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "               </table>";
    LogContent(HTML);
    HTML = "               <font size=\"1\"><br /></font>";
    LogContent(HTML);
    HTML = "               <table cellpadding=\"1\" cellspacing=\"2\" border=\"0\" class=\"box\">";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"heading\" colspan=\"4\" align=\"center\">Total Matches Played by Type</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"165\">Game (Type)</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"60\">Number</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"85\">Game Hours</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"85\">Player Hours</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);

    for(i=0;i<Totals.GameTypes.Length;i++)
    {
        HTML = "                 <tr>";
        LogContent(HTML);
        HTML = "                   <td class=\"dark\" align=\"center\">"$Totals.GameTypes[i].GameType$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.GameTypes[i].NumMatches$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Totals.GameTypes[i].Time/3600,1)$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Totals.GameTypes[i].PlayerTime/3600,1)$"</td>";
        LogContent(HTML);
        HTML = "                 </tr>";
        LogContent(HTML);
    }

    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Totals</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"darkgrey\" align=\"center\">"$Totals.TotalStats.NumMatches$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"darkgrey\" align=\"center\">"$FloatToStringRound(Totals.TotalStats.Time/3600,1)$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"darkgrey\" align=\"center\">"$FloatToStringRound(Totals.TotalStats.PlayerTime/3600,1)$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "               </table>";
    LogContent(HTML);
    HTML = "               <font size=\"1\"><br /></font>";
    LogContent(HTML);
    HTML = "               <table cellpadding=\"1\" cellspacing=\"2\" border=\"0\" width=\"580\" class=\"box\">";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"heading\" colspan=\"5\" align=\"center\">Career Highs</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"220\">Category</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Player</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"60\">Score</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"60\">Matches</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"60\">Hours</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);

    GetCareerHighsRecord(CareerHighs.MostFrags, PlayerString, ClassName, Score, NumMatches, Hours);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Most Frags</td>";
    LogContent(HTML);
    HTML = "                   <td class=\""$ClassName$"\" align=\"center\">"$PlayerString$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Score$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$NumMatches$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Hours,1)$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    GetCareerHighsRecord(CareerHighs.MostKills, PlayerString, ClassName, Score, NumMatches, Hours);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Most Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\""$ClassName$"\" align=\"center\">"$PlayerString$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Score$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$NumMatches$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Hours,1)$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    GetCareerHighsRecord(CareerHighs.MostDeaths, PlayerString, ClassName, Score, NumMatches, Hours);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Most Deaths</td>";
    LogContent(HTML);
    HTML = "                   <td class=\""$ClassName$"\" align=\"center\">"$PlayerString$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Score$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$NumMatches$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Hours,1)$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    GetCareerHighsRecord(CareerHighs.MostSuicides, PlayerString, ClassName, Score, NumMatches, Hours);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Most Suicides</td>";
    LogContent(HTML);
    HTML = "                   <td class=\""$ClassName$"\" align=\"center\">"$PlayerString$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Score$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$NumMatches$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Hours,1)$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    GetCareerHighsRecord(CareerHighs.MostWins, PlayerString, ClassName, Score, NumMatches, Hours);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Most Wins</td>";
    LogContent(HTML);
    HTML = "                   <td class=\""$ClassName$"\" align=\"center\">"$PlayerString$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Score$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$NumMatches$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Hours,1)$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    GetCareerHighsRecord(CareerHighs.MostTeamWins, PlayerString, ClassName, Score, NumMatches, Hours);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Most Team Wins</td>";
    LogContent(HTML);
    HTML = "                   <td class=\""$ClassName$"\" align=\"center\">"$PlayerString$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Score$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$NumMatches$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Hours,1)$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    GetCareerHighsRecord(CareerHighs.MostHeadshots, PlayerString, ClassName, Score, NumMatches, Hours);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Most Head Shots</td>";
    LogContent(HTML);
    HTML = "                   <td class=\""$ClassName$"\" align=\"center\">"$PlayerString$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Score$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$NumMatches$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Hours,1)$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    GetCareerHighsRecordFloat(CareerHighs.HighestSPH, PlayerString, ClassName, ScoreFloat, NumMatches, Hours);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Highest SPH</td>";
    LogContent(HTML);
    HTML = "                   <td class=\""$ClassName$"\" align=\"center\">"$PlayerString$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(ScoreFloat,1)$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$NumMatches$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Hours,1)$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    GetCareerHighsRecord(CareerHighs.MostFirstBlood, PlayerString, ClassName, Score, NumMatches, Hours);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Most First Blood</td>";
    LogContent(HTML);
    HTML = "                   <td class=\""$ClassName$"\" align=\"center\">"$PlayerString$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Score$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$NumMatches$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Hours,1)$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    GetCareerHighsRecord(CareerHighs.MostCarjackings, PlayerString, ClassName, Score, NumMatches, Hours);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Most Carjackings</td>";
    LogContent(HTML);
    HTML = "                   <td class=\""$ClassName$"\" align=\"center\">"$PlayerString$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Score$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$NumMatches$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Hours,1)$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    GetCareerHighsRecord(CareerHighs.MostCarjackings, PlayerString, ClassName, Score, NumMatches, Hours);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Most Road Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\""$ClassName$"\" align=\"center\">"$PlayerString$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Score$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$NumMatches$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Hours,1)$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "               </table>";
    LogContent(HTML);
    HTML = "               <font size=\"1\"><br /></font>";
    LogContent(HTML);
    HTML = "               <table cellpadding=\"1\" cellspacing=\"2\" border=\"0\" width=\"580\" class=\"box\">";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"heading\" colspan=\"5\" align=\"center\">Weapon Specials</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"220\">Category</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Player</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"60\">Score</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"60\">Matches</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"60\">Hours</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    GetCareerHighsRecord(CareerHighs.MostHeadhunter, PlayerString, ClassName, Score, NumMatches, Hours);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Most Headhunter</td>";
    LogContent(HTML);
    HTML = "                   <td class=\""$ClassName$"\" align=\"center\">"$PlayerString$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Score$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$NumMatches$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Hours,1)$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    GetCareerHighsRecord(CareerHighs.MostFlakMonkey, PlayerString, ClassName, Score, NumMatches, Hours);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Most Flak Monkey</td>";
    LogContent(HTML);
    HTML = "                   <td class=\""$ClassName$"\" align=\"center\">"$PlayerString$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Score$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$NumMatches$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Hours,1)$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    GetCareerHighsRecord(CareerHighs.MostComboWhore, PlayerString, ClassName, Score, NumMatches, Hours);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Most Combo Whore</td>";
    LogContent(HTML);
    HTML = "                   <td class=\""$ClassName$"\" align=\"center\">"$PlayerString$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Score$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$NumMatches$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Hours,1)$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    GetCareerHighsRecord(CareerHighs.MostRoadRampage, PlayerString, ClassName, Score, NumMatches, Hours);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Most Road Rampage</td>";
    LogContent(HTML);
    HTML = "                   <td class=\""$ClassName$"\" align=\"center\">"$PlayerString$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Score$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$NumMatches$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Hours,1)$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "               </table>";
    LogContent(HTML);
    HTML = "               <font size=\"1\"><br /></font>";
    LogContent(HTML);
    HTML = "               <table cellpadding=\"1\" cellspacing=\"2\" border=\"0\" width=\"580\" class=\"box\">";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"heading\" colspan=\"5\" align=\"center\">Multi-Kills</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"220\">Category</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Player</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"60\">Score</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"60\">Matches</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"60\">Hours</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    GetCareerHighsRecord(CareerHighs.MostMultikill_1, PlayerString, ClassName, Score, NumMatches, Hours);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Most Double Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\""$ClassName$"\" align=\"center\">"$PlayerString$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Score$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$NumMatches$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Hours,1)$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    GetCareerHighsRecord(CareerHighs.MostMultikill_2, PlayerString, ClassName, Score, NumMatches, Hours);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Most Multi Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\""$ClassName$"\" align=\"center\">"$PlayerString$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Score$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$NumMatches$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Hours,1)$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    GetCareerHighsRecord(CareerHighs.MostMultikill_3, PlayerString, ClassName, Score, NumMatches, Hours);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Most Mega Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\""$ClassName$"\" align=\"center\">"$PlayerString$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Score$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$NumMatches$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Hours,1)$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    GetCareerHighsRecord(CareerHighs.MostMultikill_4, PlayerString, ClassName, Score, NumMatches, Hours);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Most Ultra Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\""$ClassName$"\" align=\"center\">"$PlayerString$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Score$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$NumMatches$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Hours,1)$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    GetCareerHighsRecord(CareerHighs.MostMultikill_5, PlayerString, ClassName, Score, NumMatches, Hours);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Most Monster Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\""$ClassName$"\" align=\"center\">"$PlayerString$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Score$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$NumMatches$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Hours,1)$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    GetCareerHighsRecord(CareerHighs.MostMultikill_6, PlayerString, ClassName, Score, NumMatches, Hours);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Most Ludicrous Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\""$ClassName$"\" align=\"center\">"$PlayerString$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Score$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$NumMatches$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Hours,1)$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    GetCareerHighsRecord(CareerHighs.MostMultikill_7, PlayerString, ClassName, Score, NumMatches, Hours);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Most Holy Shit Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\""$ClassName$"\" align=\"center\">"$PlayerString$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Score$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$NumMatches$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Hours,1)$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "               </table>";
    LogContent(HTML);
    HTML = "               <font size=\"1\"><br /></font>";
    LogContent(HTML);
    HTML = "               <table cellpadding=\"1\" cellspacing=\"2\" border=\"0\" width=\"580\" class=\"box\">";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"heading\" colspan=\"5\" align=\"center\">Killing Sprees</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"220\">Category</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Player</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"60\">Score</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"60\">Matches</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"60\">Hours</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    GetCareerHighsRecord(CareerHighs.MostKillingSpree_1, PlayerString, ClassName, Score, NumMatches, Hours);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Most Killing Sprees</td>";
    LogContent(HTML);
    HTML = "                   <td class=\""$ClassName$"\" align=\"center\">"$PlayerString$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Score$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$NumMatches$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Hours,1)$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    GetCareerHighsRecord(CareerHighs.MostKillingSpree_2, PlayerString, ClassName, Score, NumMatches, Hours);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Most Rampages</td>";
    LogContent(HTML);
    HTML = "                   <td class=\""$ClassName$"\" align=\"center\">"$PlayerString$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Score$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$NumMatches$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Hours,1)$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    GetCareerHighsRecord(CareerHighs.MostKillingSpree_3, PlayerString, ClassName, Score, NumMatches, Hours);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Most Dominating</td>";
    LogContent(HTML);
    HTML = "                   <td class=\""$ClassName$"\" align=\"center\">"$PlayerString$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Score$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$NumMatches$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Hours,1)$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    GetCareerHighsRecord(CareerHighs.MostKillingSpree_4, PlayerString, ClassName, Score, NumMatches, Hours);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Most Unstoppable</td>";
    LogContent(HTML);
    HTML = "                   <td class=\""$ClassName$"\" align=\"center\">"$PlayerString$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Score$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$NumMatches$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Hours,1)$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    GetCareerHighsRecord(CareerHighs.MostKillingSpree_5, PlayerString, ClassName, Score, NumMatches, Hours);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Most Godlike</td>";
    LogContent(HTML);
    HTML = "                   <td class=\""$ClassName$"\" align=\"center\">"$PlayerString$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Score$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$NumMatches$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Hours,1)$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    GetCareerHighsRecord(CareerHighs.MostKillingSpree_6, PlayerString, ClassName, Score, NumMatches, Hours);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Most Wicked Sick</td>";
    LogContent(HTML);
    HTML = "                   <td class=\""$ClassName$"\" align=\"center\">"$PlayerString$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Score$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$NumMatches$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Hours,1)$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "               </table>";
    LogContent(HTML);

    // WEAPON KILLS
    HTML = "               <font size=\"1\"><br /></font>";
    LogContent(HTML);
    HTML = "               <table cellpadding=\"1\" cellspacing=\"2\" border=\"0\" width=\"550\" class=\"box\">";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"heading\" colspan=\"6\" align=\"center\">Most Career Kills with a Weapon</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"180\">Weapon</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Player</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"60\">Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"60\">Matches</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"60\">Hours</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);

    WeaponArray = GetCareerHighWeaponArrayByScore(CareerHighs.MostWeaponKills);
    for(i=0;i<CareerHighs.MostWeaponKills.Length;i++)
    {
        GetCareerHighWeaponRecord(CareerHighs.MostWeaponKills[WeaponArray[i]], PlayerString, ClassName, Score, NumMatches, Hours, WeaponName);
        HTML = "                   <tr>";
        LogContent(HTML);
        HTML = "                     <td class=\"dark\" align=\"center\">"$WeaponName$"</td>";
        LogContent(HTML);
        HTML = "                     <td class=\""$ClassName$"\" align=\"center\">"$PlayerString$"</td>";
        LogContent(HTML);
        HTML = "                     <td class=\"grey\" align=\"center\">"$Score$"</td>";
        LogContent(HTML);
        HTML = "                     <td class=\"grey\" align=\"center\">"$NumMatches$"</td>";
        LogContent(HTML);
        HTML = "                     <td class=\"grey\" align=\"center\">"$FloatToStringRound(Hours,1)$"</td>";
        LogContent(HTML);
        HTML = "                   </tr>";
        LogContent(HTML);
    }

    HTML = "               </table>";
    LogContent(HTML);
}

function GlobalsPlayerPage(int Player)
{
    local string HTML;
    local int i;
    local float Eff, SPH, TTL;
    local array<int> PointerArray;

    HTML = "               <table cellpadding=\"1\" cellspacing=\"2\" border=\"0\" width=\"710\" class=\"box\">";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"heading\" align=\"center\" colspan=\"15\">Career Summary for "$Players[Player].PlayerName$" ["$Players[Player].PlayerID$"]</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Game Type</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Score</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">F</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">K</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">D</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">S</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">TK</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">TD</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Eff</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Avg SPH</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Avg TTL</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Wins</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Losses</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Matches</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Hours</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);

    for(i=0;i<Players[Player].GameTypes.Length;i++)
    {
        if(Players[Player].GameTypes[i].Kills + Players[Player].GameTypes[i].Deaths + Players[Player].GameTypes[i].Suicides == 0)
            Eff = 0.0;
        else
            Eff = 1.f * Players[Player].GameTypes[i].Kills / (Players[Player].GameTypes[i].Kills + Players[Player].GameTypes[i].Deaths + Players[Player].GameTypes[i].Suicides) * 100;

        SPH = Players[Player].GameTypes[i].Score / (Players[Player].GameTypes[i].Time / 3600);
        TTL = Players[Player].GameTypes[i].Time / (Players[Player].GameTypes[i].Deaths + Players[Player].GameTypes[i].Suicides + 1);

        HTML = "                 <tr>";
        LogContent(HTML);
        HTML = "                   <td class=\"dark\" align=\"center\">"$Players[Player].GameTypes[i].GameType$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].GameTypes[i].Score$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].GameTypes[i].Kills - Players[Player].GameTypes[i].Suicides$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].GameTypes[i].Kills$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].GameTypes[i].Deaths$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].GameTypes[i].Suicides$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].GameTypes[i].TeamKills$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].GameTypes[i].TeamDeaths$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Eff,1)$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(SPH,1)$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(TTL,1)$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].GameTypes[i].TotalWins$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].GameTypes[i].TotalLosses$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].GameTypes[i].NumMatches$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Players[Player].GameTypes[i].Time/3600,1)$"</td>";
        LogContent(HTML);
        HTML = "                 </tr>";
        LogContent(HTML);
    }
    if (Players[Player].Kills + Players[Player].Deaths + Players[Player].Suicides == 0)
        Eff = 0.0;
    else
        Eff = Players[Player].Kills / (Players[Player].Kills + Players[Player].Deaths + Players[Player].Suicides);

    SPH = Players[Player].Score / (Players[Player].Time / 3600);
    TTL = Players[Player].Time / (Players[Player].Deaths + Players[Player].Suicides + 1);

    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Totals</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"darkgrey\" align=\"center\">"$Players[Player].Score$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"darkgrey\" align=\"center\">"$Players[Player].Kills - Players[Player].Suicides$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"darkgrey\" align=\"center\">"$Players[Player].Kills$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"darkgrey\" align=\"center\">"$Players[Player].Deaths$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"darkgrey\" align=\"center\">"$Players[Player].Suicides$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"darkgrey\" align=\"center\">"$Players[Player].TeamKills$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"darkgrey\" align=\"center\">"$Players[Player].TeamDeaths$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"darkgrey\" align=\"center\">"$FloatToStringRound(Eff,1)$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"darkgrey\" align=\"center\">"$FloatToStringRound(SPH,1)$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"darkgrey\" align=\"center\">"$FloatToStringRound(TTL,1)$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"darkgrey\" align=\"center\">"$Players[Player].TotalWins$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"darkgrey\" align=\"center\">"$Players[Player].TotalLosses$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"darkgrey\" align=\"center\">"$Players[Player].NumMatches$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"darkgrey\" align=\"center\">"$FloatToStringRound(Players[Player].Time/3600,1)$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "               </table>";
    LogContent(HTML);
    // !GAMETYPE TOTALS


    HTML = "               <br>";
    LogContent(HTML);
    HTML = "               <table cellpadding=\"1\" cellspacing=\"2\" border=\"0\">";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"heading\" colspan=\"8\" align=\"center\">Special Events</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"95\">Category</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"45\">Value</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"100\">Category</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"45\">Value</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"95\">Category</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"45\">Value</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"100\">Category</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"45\">Value</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">First Blood</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].FirstBloods$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Head Shots</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].Headshots$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Roadkills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].Roadkills$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Carjackings</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].Carjackings$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Double Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].multikill_1$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Multi Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].multikill_2$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Mega Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].multikill_3$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Ultra Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].multikill_4$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Monster Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].multikill_5$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Ludicrous Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].multikill_6$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Holy Shit Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].multikill_7$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Failed Transloc</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].failedtransloc$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Headhunter</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].HeadHunter$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Flak Monkey</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].FlakMonkey$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Combo Whore</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].ComboWhore$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Road Rampage</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].RoadRampage$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "               </table>";
    LogContent(HTML);

    // WEAPONS
    HTML = "               <br>";
    LogContent(HTML);
    HTML = "               <table cellpadding=\"1\" cellspacing=\"2\" border=\"0\" width=\"595\">";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"heading\" colspan=\"8\" align=\"center\">Weapon Specific Totals</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Weapon</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"55\">Frags</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"55\">Primary Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"70\">Secondary Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"55\">Deaths From</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"55\">Deaths Holding</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"55\">Suicides</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"55\">Eff.</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);

    PointerArray = GetGlobalPlayerWeaponArrayByFrags(Player, false);
    for(i=0;i<PointerArray.Length;i++)
    {
        if(Players[Player].Weapons[PointerArray[i]].PrimaryKills + Players[Player].Weapons[PointerArray[i]].SecondaryKills + Players[Player].Weapons[PointerArray[i]].Roadkills + Players[Player].Weapons[PointerArray[i]].DeathsHolding == 0)
            Eff = 0.0;
        else
            Eff = 1.f * (Players[Player].Weapons[PointerArray[i]].PrimaryKills + Players[Player].Weapons[PointerArray[i]].SecondaryKills + Players[Player].Weapons[PointerArray[i]].Roadkills) / (Players[Player].Weapons[PointerArray[i]].PrimaryKills + Players[Player].Weapons[PointerArray[i]].SecondaryKills + Players[Player].Weapons[PointerArray[i]].Roadkills + Players[Player].Weapons[PointerArray[i]].DeathsHolding) * 100;


        HTML = "                 <tr>";
        LogContent(HTML);
        HTML = "                   <td class=\"dark\" align=\"center\">"$Players[Player].Weapons[PointerArray[i]].WeaponName$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].Weapons[PointerArray[i]].PrimaryKills + Players[Player].Weapons[PointerArray[i]].SecondaryKills + Players[Player].Weapons[PointerArray[i]].Roadkills$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].Weapons[PointerArray[i]].PrimaryKills$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].Weapons[PointerArray[i]].SecondaryKills$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].Weapons[PointerArray[i]].DeathsBy$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].Weapons[PointerArray[i]].DeathsHolding$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].Weapons[PointerArray[i]].Suicides$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Eff,1)$"%</td>";
        LogContent(HTML);
        HTML = "                 </tr>";
        LogContent(HTML);
    }
    HTML = "               </table>";
    LogContent(HTML);
    // !WEAPONS



    // VEHICLES
    HTML = "               <br>";
    LogContent(HTML);
    HTML = "               <table cellpadding=\"1\" cellspacing=\"2\" border=\"0\" width=\"670\">";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"heading\" colspan=\"9\" align=\"center\">Vehicle and Turret Specific Totals</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Vehicle/Turret</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"55\">Frags</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"55\">Primary Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"60\">Secondary Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"55\">Road Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"55\">Deaths From</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"55\">Deaths In</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"55\">Suicides</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"55\">Eff.</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);

    PointerArray = GetGlobalPlayerWeaponArrayByFrags(Player, true);
    for(i=0;i<PointerArray.Length;i++)
    {
        if(Players[Player].Weapons[PointerArray[i]].PrimaryKills + Players[Player].Weapons[PointerArray[i]].SecondaryKills + Players[Player].Weapons[PointerArray[i]].Roadkills + Players[Player].Weapons[PointerArray[i]].DeathsHolding == 0)
            Eff = 0.0;
        else
            Eff = 1.f * (Players[Player].Weapons[PointerArray[i]].PrimaryKills + Players[Player].Weapons[PointerArray[i]].SecondaryKills + Players[Player].Weapons[PointerArray[i]].Roadkills) / (Players[Player].Weapons[PointerArray[i]].PrimaryKills + Players[Player].Weapons[PointerArray[i]].SecondaryKills + Players[Player].Weapons[PointerArray[i]].Roadkills + Players[Player].Weapons[PointerArray[i]].DeathsHolding) * 100;

        HTML = "                 <tr>";
        LogContent(HTML);
        HTML = "                   <td class=\"dark\" align=\"center\">"$Players[Player].Weapons[PointerArray[i]].WeaponName$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].Weapons[PointerArray[i]].PrimaryKills + Players[Player].Weapons[PointerArray[i]].SecondaryKills + Players[Player].Weapons[PointerArray[i]].Roadkills$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].Weapons[PointerArray[i]].PrimaryKills$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].Weapons[PointerArray[i]].SecondaryKills$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].Weapons[PointerArray[i]].Roadkills$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].Weapons[PointerArray[i]].DeathsBy$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].Weapons[PointerArray[i]].DeathsHolding$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].Weapons[PointerArray[i]].Suicides$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Eff,1)$"%</td>";
        LogContent(HTML);
        HTML = "                 </tr>";
        LogContent(HTML);
    }
    HTML = "               </table>";
    LogContent(HTML);
    // !VEHICLES


    // KILLING SPREES
    HTML = "               <br>";
    LogContent(HTML);
    HTML = "               <table cellpadding=\"1\" cellspacing=\"2\" border=\"0\" width=\"390\">";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"medheading\" align=\"center\" colspan=\"4\">Killing Sprees by Type</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"110\">Spree Type</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"85\"># of Sprees</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"115\">Total Time (min)</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"80\">Total Kills</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Killing Spree</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].Sprees.NumSprees_1$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Players[Player].Sprees.Time_1,1)$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].Sprees.TotalKills_1$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Rampage</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].Sprees.NumSprees_2$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Players[Player].Sprees.Time_2,1)$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].Sprees.TotalKills_2$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Dominating</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].Sprees.NumSprees_3$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Players[Player].Sprees.Time_3,1)$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].Sprees.TotalKills_3$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Unstoppable</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].Sprees.NumSprees_4$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Players[Player].Sprees.Time_4,1)$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].Sprees.TotalKills_4$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Godlike</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].Sprees.NumSprees_5$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Players[Player].Sprees.Time_5,1)$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].Sprees.TotalKills_5$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Wicked Sick</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].Sprees.NumSprees_6$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Players[Player].Sprees.Time_6,1)$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Players[Player].Sprees.TotalKills_6$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "               </table>";
    LogContent(HTML);
    // !KILLING SPREES
}

function MatchHighsPage()
{
    local string HTML;
    local int i;
    local string PlayerString, ClassName, WeaponName, MatchDateString, MapName;
    local int Score;
    local float Time;
    local array<int> WeaponArray;

    HTML = "               <table cellpadding=\"1\" cellspacing=\"2\" border=\"0\" class=\"box\">";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"heading\" align=\"center\" colspan=\"7\">Totals Logged</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"60\">Frags</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"60\">Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"60\">Deaths</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"60\">Suicides</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"55\">Matches</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"85\">Game Hours</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"85\">Player Hours</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.TotalStats.Kills - Totals.TotalStats.Suicides$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.TotalStats.Kills$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.TotalStats.Deaths$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.TotalStats.Suicides$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.TotalStats.NumMatches$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Totals.TotalStats.Time/3600,1)$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Totals.TotalStats.PlayerTime/3600,1)$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "               </table>";
    LogContent(HTML);
    HTML = "               <font size=\"1\"><br /></font>";
    LogContent(HTML);
    HTML = "               <table cellpadding=\"1\" cellspacing=\"2\" border=\"0\" class=\"box\">";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"heading\" colspan=\"4\" align=\"center\">Total Matches Played by Type</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"165\">Game (Type)</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"60\">Number</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"85\">Game Hours</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"85\">Player Hours</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);

    for(i=0;i<Totals.GameTypes.Length;i++)
    {
        HTML = "                 <tr>";
        LogContent(HTML);
        HTML = "                   <td class=\"dark\" align=\"center\">"$Totals.GameTypes[i].GameType$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Totals.GameTypes[i].NumMatches$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Totals.GameTypes[i].Time/3600,1)$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Totals.GameTypes[i].PlayerTime/3600,1)$"</td>";
        LogContent(HTML);
        HTML = "                 </tr>";
        LogContent(HTML);
    }

    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Totals</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"darkgrey\" align=\"center\">"$Totals.TotalStats.NumMatches$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"darkgrey\" align=\"center\">"$FloatToStringRound(Totals.TotalStats.Time/3600,1)$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"darkgrey\" align=\"center\">"$FloatToStringRound(Totals.TotalStats.PlayerTime/3600,1)$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "               </table>";

    // GENERAL MATCH HIGHS
    HTML = "               <font size=\"1\"><br /></font>";
    LogContent(HTML);
    HTML = "               <table cellpadding=\"1\" cellspacing=\"2\" border=\"0\" width=\"710\" class=\"box\">";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"heading\" colspan=\"6\" align=\"center\">Highs - From a Single Match</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Category</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Player</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Score</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Time</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Map</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Date</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);

    GetMatchHighsRecord(MatchHighs.MostFrags,PlayerString,ClassName,Score,Time,MapName,MatchDateString);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Most Frags</td>";
    LogContent(HTML);
    HTML = "                   <td class=\""$ClassName$"\" align=\"center\">"$PlayerString$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Score$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Time,1)$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$MapName$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$MatchDateString$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);

    GetMatchHighsRecord(MatchHighs.MostKills,PlayerString,ClassName,Score,Time,MapName,MatchDateString);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Most Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\""$ClassName$"\" align=\"center\">"$PlayerString$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Score$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Time,1)$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$MapName$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$MatchDateString$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);

    GetMatchHighsRecord(MatchHighs.MostDeaths,PlayerString,ClassName,Score,Time,MapName,MatchDateString);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Most Deaths</td>";
    LogContent(HTML);
    HTML = "                   <td class=\""$ClassName$"\" align=\"center\">"$PlayerString$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Score$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Time,1)$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$MapName$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$MatchDateString$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);

    GetMatchHighsRecord(MatchHighs.MostSuicides,PlayerString,ClassName,Score,Time,MapName,MatchDateString);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Most Suicides</td>";
    LogContent(HTML);
    HTML = "                   <td class=\""$ClassName$"\" align=\"center\">"$PlayerString$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$Score$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Time,1)$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$MapName$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$MatchDateString$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "               </table>";
    LogContent(HTML);
    // !GENERAL MATCH HIGHS

    // MOST KILLS WITH A WEAPON
    HTML = "               <font size=\"1\"><br /></font>";
    LogContent(HTML);
    HTML = "               <table cellpadding=\"1\" cellspacing=\"2\" border=\"0\" width=\"710\" class=\"box\">";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"heading\" colspan=\"6\" align=\"center\">Most Kills with a Weapon - From a Single Match</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Weapon</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Player</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Time</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Map</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Date</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);

    WeaponArray = GetMatchHighWeaponArrayByScore(MatchHighs.MostWeaponKills);
    for(i=0;i<WeaponArray.Length;i++)
    {
        GetMatchHighWeaponRecord(MatchHighs.MostWeaponKills[WeaponArray[i]],WeaponName,PlayerString,ClassName,Score,Time,MapName,MatchDateString);
        HTML = "                 <tr>";
        LogContent(HTML);
        HTML = "                   <td class=\"dark\" align=\"center\">"$WeaponName$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\""$ClassName$"\" align=\"center\">"$PlayerString$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Score$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Time,1)$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$MapName$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$MatchDateString$"</td>";
        LogContent(HTML);
        HTML = "                 </tr>";
        LogContent(HTML);
    }

    HTML = "               </table>";
    LogContent(HTML);
    HTML = "                   ";
    LogContent(HTML);
    // !MOST KILLS WITH A WEAPON
}

function GlobalsHelpPage()
{
    local string HTML;

    HTML = "               <font size=\"1\"><br /></font>";
    LogContent(HTML);
    HTML = "               <table cellpadding=\"1\" cellspacing=\"2\" border=\"0\" width=\"300\" class=\"box\">";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"heading\" colspan=\"2\" align=\"center\">UT Stats Legend</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"medheading\" align=\"center\" width=\"75\">Abbr.</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"medheading\">Description</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">K</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\">Kills</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">S</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\">Suicides</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">F</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\">Frags</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">D</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\">Deaths</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">TK</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\">Team Kills</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">TD</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\">Team Deaths</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">DM</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\">Deathmatch</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">TDM</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\">Team Deathmatch</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">CTF</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\">Capture the Flag</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">DD</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\">Double Domination</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">BR</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\">Bombing Run</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">AS</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\">Assault</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">ONS</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\">Onslaught</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">LMS</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\">Last Man Standing</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">IN</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\">Invasion</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">MU</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\">Mutant</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">VCTF</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\">Vehicle CTF</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">FPH</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\">Frags per Hour</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">SPH</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\">Score per Hour</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">TTL</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\">Time to Live</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">[d]</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\">Time in days</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">[h]</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\">Time in hours</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">[m],[min]</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\">Time in minutes</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">[s],[sec]</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\">Time in seconds</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "               </table>";
    LogContent(HTML);
    HTML = "               ";
    LogContent(HTML);
}

function GlobalsPlayersIndexPage()
{
    local int i;
    local string HTML;
    local array<int> PlayerArray;
    local float FPH, SPH, Eff;

    HTML = "               <table cellpadding=\"1\" cellspacing=\"2\" border=\"0\" width=\"670\" class=\"box\">";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"heading\" colspan=\"12\" align=\"center\">Unreal Tournament Player Stats</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">#</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Player</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Frags</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Score</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Deaths</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Suicides</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Eff.</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">FPH</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">SPH</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Matches</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Hours</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);

    PlayerArray = GetGlobalPlayerArrayByFrags();
    for(i=0;i<PlayerArray.Length;i++)
    {
        if(Players[PlayerArray[i]].Kills + Players[PlayerArray[i]].Deaths + Players[PlayerArray[i]].Suicides == 0)
            Eff = 0.0;
        else
            Eff = 1.f * Players[PlayerArray[i]].Kills / (Players[PlayerArray[i]].Kills + Players[PlayerArray[i]].Deaths + Players[PlayerArray[i]].Suicides) * 100;

        SPH = Players[PlayerArray[i]].Score / (Players[PlayerArray[i]].Time / 3600);
        FPH = (Players[PlayerArray[i]].Kills - Players[PlayerArray[i]].Suicides) / (Players[PlayerArray[i]].Time / 3600);

        HTML = "                 <tr>";
        LogContent(HTML);
        HTML = "                   <td class=\"dark\" align=\"center\">"$i+1$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"dark\" align=\"center\">"$GetGlobalPlayerNameLinkString(PlayerArray[i], true)$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Players[PlayerArray[i]].Kills-Players[PlayerArray[i]].Suicides$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Players[PlayerArray[i]].Score$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Players[PlayerArray[i]].Kills$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Players[PlayerArray[i]].Deaths$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Players[PlayerArray[i]].Suicides$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Eff,1)$"%</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(FPH,1)$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(SPH,1)$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$Players[PlayerArray[i]].NumMatches$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Players[PlayerArray[i]].Time / 3600,1)$"</td>";
        LogContent(HTML);
        HTML = "                 </tr>";
        LogContent(HTML);
    }

    HTML = "               </table>";
    LogContent(HTML);
}

function PlayerPage(int Player)
{
    local string HTML;
    local string MatchLimit;
    local int i, j;
    local array<int> WeaponArray, KillsArray;
    local float eff;
    local int NumKills;
    local int NumDeaths;

    // HEADER TEXT
    HTML = "               <table cellpadding=\"1\" cellspacing=\"2\" border=\"0\" width=\"720\">";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"heading\" align=\"center\">Individual Match Stats for"@PlayerInfo[Player].PlayerName$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "               </table>";
    LogContent(HTML);
    // !HEADER TEXT


    // MATCH/PLAYER INFORMATION
    HTML = "               <br>";
    LogContent(HTML);
    HTML = "               <table cellpadding=\"1\" cellspacing=\"2\" border=\"0\" width=\"650\" class=\"box\">";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"heading\" colspan=\"4\" align=\"center\">Match/Player Information</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\" width=\"80\">Match Date</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\" width=\"220\">"$MatchInfo.DateTime$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\" width=\"90\">Server</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$MatchInfo.ServerName$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Match Type</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$MatchInfo.GameType$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Admin Name</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$MatchInfo.AdminName$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Map Name</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$MatchInfo.MapName$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Admin Email</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$MatchInfo.AdminEmail$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Difficulty</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$GetDifficultyName(MatchInfo.GameDifficulty)$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Game Speed</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$MatchInfo.GameSpeed$"%</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);

        if (MatchInfo.GoalScore == 0 && MatchInfo.TimeLimit == 0)
            MatchLimit = "No limit";
        else if (MatchInfo.GoalScore == 0 && MatchInfo.TimeLimit != 0)
            MatchLimit = MatchInfo.GoalScore@"Score";
        else if (MatchInfo.GoalScore != 0 && MatchInfo.TimeLimit == 0)
            MatchLimit = MatchInfo.TimeLimit@"Minutes";
        else
            MatchLimit = MatchInfo.GoalScore@"Score"@"/"@MatchInfo.TimeLimit@"Minutes";

    HTML = "                   <td class=\"dark\" align=\"center\">Match Limit</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$MatchLimit$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">No. Players</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo.Length$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    /*
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Mutators</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\" colspan=\"3\">TODO</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    */

/*
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Netspeed</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">10000</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Avg. Ping</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">24 ms</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
*/

    HTML = "               </table>";
    LogContent(HTML);
    // !MATCH/PLAYER INFORMATION


    // MATCH SUMMARY
    HTML = "               <br>";
    LogContent(HTML);
    HTML = "               <table cellpadding=\"0\" cellspacing=\"2\" border=\"0\" width=\"600\">";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"heading\" colspan=\"15\" align=\"center\">Match Summary</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" ROWSPAN=\"2\" width=\"40\">Rank</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" ROWSPAN=\"2\" width=\"40\">Frags</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" ROWSPAN=\"2\" width=\"40\">Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" ROWSPAN=\"2\" width=\"50\">Deaths</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" ROWSPAN=\"2\" width=\"60\">Suicides</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" ROWSPAN=\"2\" width=\"70\">Efficiency</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" ROWSPAN=\"2\" width=\"50\">Avg. FPH</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" ROWSPAN=\"2\" width=\"50\">Avg. TTL</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" ROWSPAN=\"2\" width=\"45\">Time</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" colspan=\"6\">Sprees</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">K</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">R</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">D</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">U</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">G</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">W</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[Player].Rank$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[Player].Kills-PlayerInfo[Player].Suicides$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[Player].Kills$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[Player].Deaths$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[Player].Suicides$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[Player].Eff$"%</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[Player].SPH$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[Player].TTL$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[Player].Time$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$GetPlayerNumberSprees(Player,1)$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$GetPlayerNumberSprees(Player,2)$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$GetPlayerNumberSprees(Player,3)$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$GetPlayerNumberSprees(Player,4)$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$GetPlayerNumberSprees(Player,5)$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$GetPlayerNumberSprees(Player,6)$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "               </table>";
    LogContent(HTML);
    // !MATCH SUMMARY


    // SPECIAL EVENTS
    HTML = "               <br>";
    LogContent(HTML);
    HTML = "               <table cellpadding=\"1\" cellspacing=\"2\" border=\"0\">";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"heading\" colspan=\"8\" align=\"center\">Special Events</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"95\">Category</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"45\">Value</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"100\">Category</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"45\">Value</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"95\">Category</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"45\">Value</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"100\">Category</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"45\">Value</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">First Blood</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$YesOrNo(bFirstBlood && MatchInfo.FirstBloodID == Player)$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Head Shots</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[Player].Headshots$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Roadkills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[Player].Roadkills$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Carjackings</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[Player].Carjackings$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Double Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[Player].multikill_1$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Multi Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[Player].multikill_2$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Mega Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[Player].multikill_3$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Ultra Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[Player].multikill_4$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Monster Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[Player].multikill_5$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Ludicrous Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[Player].multikill_6$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Holy Shit Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[Player].multikill_7$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Failed Transloc</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[Player].failedtransloc$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Headhunter</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$YesOrNo(PlayerInfo[Player].Headhunter==1)$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Flak Monkey</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$YesOrNo(PlayerInfo[Player].FlakMonkey==1)$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Combo Whore</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$YesOrNo(PlayerInfo[Player].ComboWhore==1)$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Road Rampage</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$YesOrNo(PlayerInfo[Player].RoadRampage==1)$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "               </table>";
    LogContent(HTML);
    // !SPECIAL EVENTS


    // WEAPON SPECIFIC INFORMATION
    HTML = "               <br>";
    LogContent(HTML);
    HTML = "               <table cellpadding=\"1\" cellspacing=\"2\" border=\"0\" width=\"595\">";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"heading\" colspan=\"8\" align=\"center\">Weapon Specific Information</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Weapon</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"55\">Frags</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"55\">Primary Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"70\">Secondary Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"55\">Deaths From</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"55\">Deaths Holding</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"55\">Suicides</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"55\">Eff.</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);


    WeaponArray = GetIndividualWeaponArrayByFrags(Player, false);

    for(i=0;i<WeaponArray.length;i++)
    {
        if (PlayerInfo[Player].Weapons[WeaponArray[i]].PrimaryKills + PlayerInfo[Player].Weapons[WeaponArray[i]].SecondaryKills + PlayerInfo[Player].Weapons[WeaponArray[i]].DeathsHolding + PlayerInfo[Player].Weapons[WeaponArray[i]].Suicides == 0)
            Eff = 0.0;
        else
            Eff = 1.f * (PlayerInfo[Player].Weapons[WeaponArray[i]].PrimaryKills + PlayerInfo[Player].Weapons[WeaponArray[i]].SecondaryKills) / (PlayerInfo[Player].Weapons[WeaponArray[i]].PrimaryKills + PlayerInfo[Player].Weapons[WeaponArray[i]].SecondaryKills + PlayerInfo[Player].Weapons[WeaponArray[i]].DeathsHolding + PlayerInfo[Player].Weapons[WeaponArray[i]].Suicides) * 100;

        HTML = "                 <tr>";
        LogContent(HTML);
        HTML = "                   <td class=\"dark\" align=\"center\">"$PlayerInfo[Player].Weapons[WeaponArray[i]].WeaponName$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[Player].Weapons[WeaponArray[i]].PrimaryKills+PlayerInfo[Player].Weapons[WeaponArray[i]].SecondaryKills-PlayerInfo[Player].Weapons[WeaponArray[i]].Suicides$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[Player].Weapons[WeaponArray[i]].PrimaryKills$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[Player].Weapons[WeaponArray[i]].SecondaryKills$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[Player].Weapons[WeaponArray[i]].DeathsBy$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[Player].Weapons[WeaponArray[i]].DeathsHolding$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[Player].Weapons[WeaponArray[i]].Suicides$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Eff,1)$"%</td>";
        LogContent(HTML);
        HTML = "                 </tr>";
        LogContent(HTML);
    }

    HTML = "               </table>";
    LogContent(HTML);
    // !WEAPON SPECIFIC INFORMATION

    // VEHICLE INFORMATION
    HTML = "               <br>";
    LogContent(HTML);
    HTML = "               <table cellpadding=\"1\" cellspacing=\"2\" border=\"0\" width=\"660\">";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"heading\" colspan=\"9\" align=\"center\">Vehicle and Turret Specific Information</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Vehicle/Turret</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"55\">Frags</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"55\">Primary Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"70\">Secondary Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"55\">Road Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"55\">Deaths From</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"55\">Deaths In</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"55\">Suicides</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"55\">Eff.</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);

    WeaponArray = GetIndividualWeaponArrayByFrags(Player, true);

    for(i=0;i<WeaponArray.Length;i++)
    {
        if (PlayerInfo[Player].Weapons[WeaponArray[i]].PrimaryKills + PlayerInfo[Player].Weapons[WeaponArray[i]].SecondaryKills + PlayerInfo[Player].Weapons[WeaponArray[i]].Roadkills + PlayerInfo[Player].Weapons[WeaponArray[i]].DeathsHolding + PlayerInfo[Player].Weapons[WeaponArray[i]].Suicides == 0)
            Eff = 0.0;
        else
            Eff = 1.f * (PlayerInfo[Player].Weapons[WeaponArray[i]].PrimaryKills + PlayerInfo[Player].Weapons[WeaponArray[i]].SecondaryKills + PlayerInfo[Player].Weapons[WeaponArray[i]].Roadkills) / (PlayerInfo[Player].Weapons[WeaponArray[i]].PrimaryKills + PlayerInfo[Player].Weapons[WeaponArray[i]].SecondaryKills + PlayerInfo[Player].Weapons[WeaponArray[i]].Roadkills + PlayerInfo[Player].Weapons[WeaponArray[i]].DeathsHolding + PlayerInfo[Player].Weapons[WeaponArray[i]].Suicides) * 100;

        HTML = "                 <tr>";
        LogContent(HTML);
        HTML = "                   <td class=\"dark\" align=\"center\">"$PlayerInfo[Player].Weapons[WeaponArray[i]].WeaponName$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[Player].Weapons[WeaponArray[i]].PrimaryKills + PlayerInfo[Player].Weapons[WeaponArray[i]].SecondaryKills + PlayerInfo[Player].Weapons[WeaponArray[i]].Roadkills - PlayerInfo[Player].Weapons[WeaponArray[i]].Suicides$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[Player].Weapons[WeaponArray[i]].PrimaryKills$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[Player].Weapons[WeaponArray[i]].SecondaryKills$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[Player].Weapons[WeaponArray[i]].Roadkills$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[Player].Weapons[WeaponArray[i]].DeathsBy$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[Player].Weapons[WeaponArray[i]].DeathsHolding$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[Player].Weapons[WeaponArray[i]].Suicides$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Eff,1)$"%</td>";
        LogContent(HTML);
        HTML = "                 </tr>";
        LogContent(HTML);
    }

    HTML = "               </table>";
    LogContent(HTML);
    // !VEHICLE INFORMATION


    // PLAYER SPECIFIC KILLS
    HTML = "               <br>";
    LogContent(HTML);
    HTML = "               <table cellpadding=\"1\" cellspacing=\"2\" border=\"0\" width=\"580\">";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"heading\" colspan=\"8\" align=\"center\">Player Specific Kills and Deaths</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Opponent</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"40\">Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"45\">Deaths</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"65\">Efficiency</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Opponent</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"40\">Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"45\">Deaths</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"65\">Efficiency</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);

    KillsArray = GetKilledPlayersByNumKills(Player);
    for(i=0;i<KillsArray.Length;i+=2)
    {
        HTML = "                 <tr>";
        LogContent(HTML);

        for(j=i;j<i+2;j++)
        {
            if(j<KillsArray.Length)
            {
                NumKills = GetNumKills(Player,KillsArray[j]);
                NumDeaths = GetNumKills(KillsArray[j],Player);

                if(NumKills + NumDeaths == 0)
                    Eff = 0.0;
                else
                    Eff = 1.f * NumKills / (NumKills + NumDeaths) * 100;

                HTML = "                   <td class=\""$GetNameColor(j)$"\" align=\"center\">"$GetNameLinkString(j)$"</td>";
                LogContent(HTML);
                HTML = "                   <td class=\"grey\" align=\"center\">"$NumKills$"</td>";
                LogContent(HTML);
                HTML = "                   <td class=\"grey\" align=\"center\">"$NumDeaths$"</td>";
                LogContent(HTML);
                HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(Eff,1)$"%</td>";
                LogContent(HTML);
            } else {
                HTML = "                   <td class=\"dark\" align=\"center\">&nbsp;</td>";
                LogContent(HTML);
                HTML = "                   <td class=\"grey\" align=\"center\">&nbsp;</td>";
                LogContent(HTML);
                HTML = "                   <td class=\"grey\" align=\"center\">&nbsp;</td>";
                LogContent(HTML);
                HTML = "                   <td class=\"grey\" align=\"center\">&nbsp;</td>";
                LogContent(HTML);
            }
        }
        HTML = "                 </tr>";
        LogContent(HTML);
    }
    HTML = "               </table>";
    LogContent(HTML);
    // !PLAYER SPECIFIC KILLS

    // KILLING SPREES
    HTML = "               <br>";
    LogContent(HTML);
    HTML = "               <table cellpadding=\"1\" cellspacing=\"2\" border=\"0\" width=\"620\">";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"heading\" colspan=\"5\" align=\"center\">Killing Sprees</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"90\">Spree Type</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"45\">Start Time</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"55\">Time In Spree</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\" width=\"80\">Kills During Spree</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Reason Spree Stopped</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);

    for(i=0;i<PlayerInfo[Player].Sprees.Length;i++)
    {

        HTML = "                 <tr>";
        LogContent(HTML);
        HTML = "                   <td class=\"dark\" align=\"center\">"$GetSpreeName(PlayerInfo[Player].Sprees[i].SpreeLevel)$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(PlayerInfo[Player].Sprees[i].TimeSpreeStarted / 60,1)$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(PlayerInfo[Player].Sprees[i].TimeInSpree,1)$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[Player].Sprees[i].KillsInSpree$"</td>";
        LogContent(HTML);
        HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[Player].Sprees[i].SpreeEndReason$"</td>";
        LogContent(HTML);
        HTML = "                 </tr>";
        LogContent(HTML);
    }

    HTML = "               </table>";
    LogContent(HTML);
    // !KILLING SPREES
}

function MainPage()
{
    local string HTML;
    local int i, j;
    local array<PlayerTeamRecord> TeamArray;
    local array<int> PlayerArray, WeaponArray, SpreeArray;
    local int SpreePlayer, SpreeID;
    local int numkills;
    local bool bAsterisk;
    local string MatchLimit;
    local float Eff;
    local int TeamPointer;

    PlayerArray = GetPlayerArrayByScore();

    for(i=0;i<PlayerArray.Length;i++)
        PlayerInfo[PlayerArray[i]].Rank = i+1;

    // HEADER TEXT
    HTML = "               <table cellpadding=\"1\" cellspacing=\"2\" border=\"0\" width=\"720\">";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"heading\" align=\"center\">Match Stats for"@MatchInfo.ServerName@":"@MatchInfo.MapName$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "               </table>";
    LogContent(HTML);
    // !HEADER TEXT

    // TOTALS BOX
    HTML = "               <br>";
    LogContent(HTML);
    HTML = "               <table cellpadding=\"1\" cellspacing=\"2\" border=\"0\" width=\"235\" class=\"box\">";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"heading\" align=\"center\" colspan=\"6\">Totals for This Match</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Team</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Score</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Frags</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Kills</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Deaths</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"smheading\" align=\"center\">Suicides</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$MatchInfo.TeamScore$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$MatchInfo.Score$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$(MatchInfo.Kills-MatchInfo.Suicides)$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$MatchInfo.Kills$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$MatchInfo.Deaths$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$MatchInfo.Suicides$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "               </table>";
    LogContent(HTML);
    // !TOTALS BOX

    // SERVER INFO BOX
    HTML = "               <br>";
    LogContent(HTML);
    HTML = "               <table cellpadding=\"1\" cellspacing=\"2\" border=\"0\" width=\"650\">";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"heading\" colspan=\"4\" align=\"center\">Unreal Tournament Match Stats</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\" width=\"100\">Match Date</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\" width=\"220\">"$MatchInfo.DateTime$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\" width=\"105\">Server</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$MatchInfo.ServerName$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Game Type</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$MatchInfo.GameType$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Admin Name</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$MatchInfo.AdminName$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Map Name</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$MatchInfo.MapName$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Admin Email</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$MatchInfo.AdminEmail$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Difficulty</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$GetDifficultyName(MatchInfo.GameDifficulty)$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Game Speed</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$MatchInfo.GameSpeed$"%</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    HTML = "                 <tr>";
    LogContent(HTML);

        if (MatchInfo.GoalScore == 0 && MatchInfo.TimeLimit == 0)
            MatchLimit = "No limit";
        else if (MatchInfo.GoalScore == 0 && MatchInfo.TimeLimit != 0)
            MatchLimit = MatchInfo.GoalScore@"Score";
        else if (MatchInfo.GoalScore != 0 && MatchInfo.TimeLimit == 0)
            MatchLimit = MatchInfo.TimeLimit@"Minutes";
        else
            MatchLimit = MatchInfo.GoalScore@"Score"@"/"@MatchInfo.TimeLimit@"Minutes";

    HTML = "                   <td class=\"dark\" align=\"center\">Match Limit</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$MatchLimit$"</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">No. Players</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo.Length$"</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    /*
    HTML = "                 <tr>";
    LogContent(HTML);
    HTML = "                   <td class=\"dark\" align=\"center\">Mutators</td>";
    LogContent(HTML);
    HTML = "                   <td class=\"grey\" align=\"center\" colspan=\"3\">TODO</td>";
    LogContent(HTML);
    HTML = "                 </tr>";
    LogContent(HTML);
    */
    HTML = "               </table>";
    LogContent(HTML);
    // !SERVER INFO BOX

    if(MatchInfo.GameTypeID == 2)
    {
        // ********************
        // **CAPTURE THE FLAG**
        // ********************


    }

    if(MatchInfo.bTeamGame)
    {
        // TEAM STATS BOX
        HTML = "               <br>";
        LogContent(HTML);
        HTML = "               <table cellpadding=\"0\" cellspacing=\"2\" border=\"0\" width=\"720\">";
        LogContent(HTML);
        HTML = "                 <tr>";
        LogContent(HTML);
        HTML = "                   <td class=\"heading\" colspan=\"20\" align=\"center\">Game Summary</td>";
        LogContent(HTML);
        HTML = "                 </tr>";
        LogContent(HTML);


        for(j=1;j>=0;j--)
        {
            TeamPointer = GetTeamStatsByID(j);
            if(TeamPointer == -1) continue;

            HTML = "                 <tr>";
            LogContent(HTML);


            HTML = "                   <td class=\"hlheading\" colspan=\"20\" align=\"center\">";
            if(j==0)
                HTML $= "Red Team";
            else if (j==1)
                HTML $= "Blue Team";
            HTML $= "</td>";
            LogContent(HTML);


            HTML = "                 </tr>";
            LogContent(HTML);
            HTML = "                 <tr>";
            LogContent(HTML);
            HTML = "                   <td class=\"smheading\" align=\"center\" rowspan=\"2\" width=\"40\">Rank</td>";
            LogContent(HTML);
            HTML = "                   <td class=\"smheading\" align=\"center\" rowspan=\"2\">Player</td>";
            LogContent(HTML);
//            HTML = "                   <td class=\"smheading\" align=\"center\" rowspan=\"2\" width=\"20\"><img src=\"resource/pcolors.gif\" width=\"16\" height=\"16\" border=\"0\" alt=\"Color Bar\"></td>";
//            LogContent(HTML);
            HTML = "                   <td class=\"smheading\" align=\"center\" colspan=\"2\" width=\"90\">Score</td>";
            LogContent(HTML);
            HTML = "                   <td class=\"smheading\" align=\"center\" rowspan=\"2\" width=\"20\">F</td>";
            LogContent(HTML);
            HTML = "                   <td class=\"smheading\" align=\"center\" rowspan=\"2\" width=\"20\">K</td>";
            LogContent(HTML);
            HTML = "                   <td class=\"smheading\" align=\"center\" rowspan=\"2\" width=\"20\">D</td>";
            LogContent(HTML);
            HTML = "                   <td class=\"smheading\" align=\"center\" rowspan=\"2\" width=\"20\">S</td>";
            LogContent(HTML);
            HTML = "                   <td class=\"smheading\" align=\"center\" rowspan=\"2\" width=\"20\">TK</td>";
            LogContent(HTML);
            HTML = "                   <td class=\"smheading\" align=\"center\" rowspan=\"2\" width=\"20\">TD</td>";
            LogContent(HTML);
            HTML = "                   <td class=\"smheading\" align=\"center\" rowspan=\"2\" width=\"55\">Eff.</td>";
            LogContent(HTML);
            HTML = "                   <td class=\"smheading\" align=\"center\" rowspan=\"2\" width=\"50\">Avg. SPH</td>";
            LogContent(HTML);
            HTML = "                   <td class=\"smheading\" align=\"center\" rowspan=\"2\" width=\"50\">Avg. TTL</td>";
            LogContent(HTML);
            HTML = "                   <td class=\"smheading\" align=\"center\" rowspan=\"2\" width=\"40\">Time</td>";
            LogContent(HTML);
            HTML = "                   <td class=\"smheading\" align=\"center\" colspan=\"6\" width=\"100\">Sprees</td>";
            LogContent(HTML);
            HTML = "                 </tr>";
            LogContent(HTML);
            HTML = "                 <tr>";
            LogContent(HTML);
            HTML = "                   <td class=\"smheading\" align=\"center\">Team</td>";
            LogContent(HTML);
            HTML = "                   <td class=\"smheading\" align=\"center\">Player</td>";
            LogContent(HTML);
            HTML = "                   <td class=\"smheading\" align=\"center\">K</td>";
            LogContent(HTML);
            HTML = "                   <td class=\"smheading\" align=\"center\">R</td>";
            LogContent(HTML);
            HTML = "                   <td class=\"smheading\" align=\"center\">D</td>";
            LogContent(HTML);
            HTML = "                   <td class=\"smheading\" align=\"center\">U</td>";
            LogContent(HTML);
            HTML = "                   <td class=\"smheading\" align=\"center\">G</td>";
            LogContent(HTML);
            HTML = "                   <td class=\"smheading\" align=\"center\">W</td>";
            LogContent(HTML);
            HTML = "                 </tr>";
            LogContent(HTML);


            TeamArray = GetTeamArray(j);
            TeamArray = SortTeamArrayByScore(TeamArray);

            for(i=0;i<TeamArray.length;i++)
            {
                HTML = "                 <tr>";
                LogContent(HTML);
                HTML = "                   <td class=\"dark\" align=\"center\">"$PlayerInfo[TeamArray[i].Player].Rank$"</td>";
                LogContent(HTML);

                // If the player did not end the game on this team, then we put an
                // asterisk before the name.
                HTML = "                   <td class=\""$GetNameColor(TeamArray[i].Player)$"\" align=\"center\">";
                if (PlayerInfo[TeamArray[i].Player].TeamID != j)
                {
                    HTML $= "*";
                    bAsterisk = True;
                }
                HTML $= GetNameLinkString(TeamArray[i].Player)$"</td>";
                LogContent(HTML);

//                HTML = "                   <td class=\"grey\" align=\"center\">&nbsp;</td>";
//                LogContent(HTML);
                HTML = "                   <td class=\"grey\" align=\"center\">&nbsp;</td>"; // Team Score
                LogContent(HTML);
                HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[TeamArray[i].Player].ITS[TeamArray[i].Team].Score$"</td>"; // Player Score
                LogContent(HTML);
                HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[TeamArray[i].Player].ITS[TeamArray[i].Team].Kills-PlayerInfo[TeamArray[i].Player].ITS[TeamArray[i].Team].Suicides$"</td>";
                LogContent(HTML);
                HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[TeamArray[i].Player].ITS[TeamArray[i].Team].Kills$"</td>";
                LogContent(HTML);
                HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[TeamArray[i].Player].ITS[TeamArray[i].Team].Deaths$"</td>";
                LogContent(HTML);
                HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[TeamArray[i].Player].ITS[TeamArray[i].Team].Suicides$"</td>";
                LogContent(HTML);
                HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[TeamArray[i].Player].ITS[TeamArray[i].Team].TeamKills$"</td>";
                LogContent(HTML);
                HTML = "                   <td class=\"grey\" align=\"center\">"$PlayerInfo[TeamArray[i].Player].ITS[TeamArray[i].Team].TeamDeaths$"</td>";
                LogContent(HTML);
                HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(PlayerInfo[TeamArray[i].Player].ITS[TeamArray[i].Team].Eff,1)$"%</td>";
                LogContent(HTML);
                HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(PlayerInfo[TeamArray[i].Player].ITS[TeamArray[i].Team].SPH,1)$"</td>";
                LogContent(HTML);
                HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(PlayerInfo[TeamArray[i].Player].ITS[TeamArray[i].Team].TTL,1)$"</td>";
                LogContent(HTML);
                HTML = "                   <td class=\"grey\" align=\"center\">"$FloatToStringRound(PlayerInfo[TeamArray[i].Player].ITS[TeamArray[i].Team].Time/60,1)$"</td>";
                LogContent(HTML);
                HTML = "                   <td class=\"grey\" align=\"center\">"$GetTeamPlayerNumberSprees(TeamArray[i].Player,1,TeamArray[i].Team)$"</td>";
                LogContent(HTML);
                HTML = "                   <td class=\"grey\" align=\"center\">"$GetTeamPlayerNumberSprees(TeamArray[i].Player,2,TeamArray[i].Team)$"</td>";
                LogContent(HTML);
                HTML = "                   <td class=\"grey\" align=\"center\">"$GetTeamPlayerNumberSprees(TeamArray[i].Player,3,TeamArray[i].Team)$"</td>";
                LogContent(HTML);
                HTML = "                   <td class=\"grey\" align=\"center\">"$GetTeamPlayerNumberSprees(TeamArray[i].Player,4,TeamArray[i].Team)$"</td>";
                LogContent(HTML);
                HTML = "                   <td class=\"grey\" align=\"center\">"$GetTeamPlayerNumberSprees(TeamArray[i].Player,5,TeamArray[i].Team)$"</td>";
                LogContent(HTML);
                HTML = "                   <td class=\"grey\" align=\"center\">"$GetTeamPlayerNumberSprees(TeamArray[i].Player,6,TeamArray[i].Team)$"</td>";
                LogContent(HTML);
                HTML = "                 </tr>";
                LogContent(HTML);
            }

            HTML = "                   <tr>";
            LogContent(HTML);
            HTML = "                     <td class=\"dark\" align=\"center\" colspan=\"2\">Totals</td>";
            LogContent(HTML);
//            HTML = "                     <td class=\"darkgrey\" align=\"center\"><img src=\"resource/p1color.gif\" width=\"16\" height=\"16\" border=\"0\" alt=\"Player Color\"></td>";
//            LogContent(HTML);
            HTML = "                     <td class=\"darkgrey\" align=\"center\">"$MatchInfo.Teams[TeamPointer].TeamScore$"</td>";
            LogContent(HTML);
            HTML = "                     <td class=\"darkgrey\" align=\"center\">"$MatchInfo.Teams[TeamPointer].Score$"</td>";
            LogContent(HTML);
            HTML = "                     <td class=\"darkgrey\" align=\"center\">"$MatchInfo.Teams[TeamPointer].Kills-MatchInfo.Teams[TeamPointer].Suicides$"</td>";
            LogContent(HTML);
            HTML = "                     <td class=\"darkgrey\" align=\"center\">"$MatchInfo.Teams[TeamPointer].Kills$"</td>";
            LogContent(HTML);
            HTML = "                     <td class=\"darkgrey\" align=\"center\">"$MatchInfo.Teams[TeamPointer].Deaths$"</td>";
            LogContent(HTML);
            HTML = "                     <td class=\"darkgrey\" align=\"center\">"$MatchInfo.Teams[TeamPointer].Suicides$"</td>";
            LogContent(HTML);
            HTML = "                     <td class=\"darkgrey\" align=\"center\">"$MatchInfo.Teams[TeamPointer].TeamKills$"</td>";
            LogContent(HTML);
            HTML = "                     <td class=\"darkgrey\" align=\"center\">"$MatchInfo.Teams[TeamPointer].TeamDeaths$"</td>";
            LogContent(HTML);
            HTML = "                     <td class=\"darkgrey\" align=\"center\">"$FloatToStringRound(MatchInfo.Teams[TeamPointer].Eff,1)$"</td>";
            LogContent(HTML);
            HTML = "                     <td class=\"darkgrey\" align=\"center\">"$FloatToStringRound(MatchInfo.Teams[TeamPointer].SPH,1)$"</td>";
            LogContent(HTML);
            HTML = "                     <td class=\"darkgrey\" align=\"center\">"$FloatToStringRound(MatchInfo.Teams[TeamPointer].TTL,1)$"</td>";
            LogContent(HTML);
            HTML = "                     <td class=\"darkgrey\" align=\"center\">"$FloatToStringRound(MatchInfo.Teams[TeamPointer].Time/60,1)$"</td>";
            LogContent(HTML);
            HTML = "                     <td class=\"darkgrey\" align=\"center\">"$GetTeamNumberSprees(j,1)$"</td>";
            LogContent(HTML);
            HTML = "                     <td class=\"darkgrey\" align=\"center\">"$GetTeamNumberSprees(j,2)$"</td>";
            LogContent(HTML);
            HTML = "                     <td class=\"darkgrey\" align=\"center\">"$GetTeamNumberSprees(j,3)$"</td>";
            LogContent(HTML);
            HTML = "                     <td class=\"darkgrey\" align=\"center\">"$GetTeamNumberSprees(j,4)$"</td>";
            LogContent(HTML);
            HTML = "                     <td class=\"darkgrey\" align=\"center\">"$GetTeamNumberSprees(j,5)$"</td>";
            LogContent(HTML);
            HTML = "                     <td class=\"darkgrey\" align=\"center\">"$GetTeamNumberSprees(j,6)$"</td>";
            LogContent(HTML);
            HTML = "                   </tr>";
            LogContent(HTML);
        }

        if (bAsterisk)
        {
            HTML = "                 <tr>";
            LogContent(HTML);
            HTML = "                   <td class=\"opnote\" colspan=\"20\">* Player ended game on opposing team.</td>";
            LogContent(HTML);
            HTML = "                 </tr>";
            LogContent(HTML);
        }
        HTML = "               </table>";
        LogContent(HTML);
        // !TEAM STATS BOX

    } // End if teamgame


    // PLAYER SUMMARY BOX
    HTML = "                 <br>";
    LogContent(HTML);
    HTML = "                 <table cellpadding=\"0\" cellspacing=\"2\" border=\"0\" width=\"720\">";
    LogContent(HTML);
    HTML = "                   <tr>";
    LogContent(HTML);
    HTML = "                     <td class=\"heading\" colspan=\"18\" align=\"center\">Player Summary</td>";
    LogContent(HTML);
    HTML = "                   </tr>";
    LogContent(HTML);
    HTML = "                   <tr>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\" rowspan=\"2\">Rank</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\" rowspan=\"2\">Player</td>";
    LogContent(HTML);
//    HTML = "                     <td class=\"smheading\" align=\"center\" rowspan=\"2\" width=\"20\"><img src=\"resource/pcolors.gif\" width=\"16\" height=\"16\" border=\"0\" alt=\"Color Bar\"></td>";
//    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\" rowspan=\"2\">Score</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\" rowspan=\"2\">Frags</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\" rowspan=\"2\">Kills</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\" rowspan=\"2\">Deaths</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\" rowspan=\"2\">Suicides</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\" rowspan=\"2\">Eff.</td>";
    LogContent(HTML);
    HTML = "                     <td width=\"50\" class=\"smheading\" align=\"center\" rowspan=\"2\">Avg. SPH</td>";
    LogContent(HTML);
    HTML = "                     <td width=\"50\" class=\"smheading\" align=\"center\" rowspan=\"2\">Avg. TTL</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\" rowspan=\"2\">Time</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\" colspan=\"6\">Sprees</td>";
    LogContent(HTML);
    HTML = "                   </tr>";
    LogContent(HTML);
    HTML = "                   <tr>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\">K</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\">R</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\">D</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\">U</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\">G</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\">W</td>";
    LogContent(HTML);
    HTML = "                   </tr>";
    LogContent(HTML);

    for(i=0;i<PlayerArray.length;i++)
    {
        HTML = "                   <tr>";
        LogContent(HTML);
        HTML = "                     <td class=\"dark\" align=\"center\">"$PlayerInfo[PlayerArray[i]].Rank$"</td>";
        LogContent(HTML);
        HTML = "                     <td class=\""$GetNameColor(PlayerArray[i])$"\" align=\"center\">"$GetNameLinkString(PlayerArray[i])$"</td>";
        LogContent(HTML);
//        HTML = "                     <td class=\"grey\" align=\"center\" width=\"20\"><img src=\"resource/p1color.gif\" width=\"16\" height=\"16\" border=\"0\" alt=\"Player Color\"></td>";
//        LogContent(HTML);
        HTML = "                     <td class=\"grey\" align=\"center\">"$PlayerInfo[PlayerArray[i]].Score$"</td>";
        LogContent(HTML);
        HTML = "                     <td class=\"grey\" align=\"center\">"$PlayerInfo[PlayerArray[i]].Kills-PlayerInfo[PlayerArray[i]].Suicides$"</td>";
        LogContent(HTML);
        HTML = "                     <td class=\"grey\" align=\"center\">"$PlayerInfo[PlayerArray[i]].Kills$"</td>";
        LogContent(HTML);
        HTML = "                     <td class=\"grey\" align=\"center\">"$PlayerInfo[PlayerArray[i]].Deaths$"</td>";
        LogContent(HTML);
        HTML = "                     <td class=\"grey\" align=\"center\">"$PlayerInfo[PlayerArray[i]].Suicides$"</td>";
        LogContent(HTML);
        HTML = "                     <td class=\"grey\" align=\"center\">"$FloatToStringRound(PlayerInfo[PlayerArray[i]].Eff,1)$"%</td>";
        LogContent(HTML);
        HTML = "                     <td class=\"grey\" align=\"center\">"$FloatToStringRound(PlayerInfo[PlayerArray[i]].SPH,1)$"</td>";
        LogContent(HTML);
        HTML = "                     <td class=\"grey\" align=\"center\">"$FloatToStringRound(PlayerInfo[PlayerArray[i]].TTL,1)$"</td>";
        LogContent(HTML);
        HTML = "                     <td class=\"grey\" align=\"center\">"$FloatToStringRound(PlayerInfo[PlayerArray[i]].Time/60,1)$"</td>";
        LogContent(HTML);
        HTML = "                     <td class=\"grey\" align=\"center\">"$GetPlayerNumberSprees(PlayerArray[i],1)$"</td>";
        LogContent(HTML);
        HTML = "                     <td class=\"grey\" align=\"center\">"$GetPlayerNumberSprees(PlayerArray[i],2)$"</td>";
        LogContent(HTML);
        HTML = "                     <td class=\"grey\" align=\"center\">"$GetPlayerNumberSprees(PlayerArray[i],3)$"</td>";
        LogContent(HTML);
        HTML = "                     <td class=\"grey\" align=\"center\">"$GetPlayerNumberSprees(PlayerArray[i],4)$"</td>";
        LogContent(HTML);
        HTML = "                     <td class=\"grey\" align=\"center\">"$GetPlayerNumberSprees(PlayerArray[i],5)$"</td>";
        LogContent(HTML);
        HTML = "                     <td class=\"grey\" align=\"center\">"$GetPlayerNumberSprees(PlayerArray[i],6)$"</td>";
        LogContent(HTML);
        HTML = "                   </tr>";
        LogContent(HTML);
    }

    HTML = "                   <tr>";
    LogContent(HTML);
    HTML = "                     <td class=\"dark\" colspan=\"2\" align=\"center\">Totals</td>";
    LogContent(HTML);
//    HTML = "                     <td class=\"dark\" align=\"center\" width=\"20\"><img src=\"resource/blankcolor.gif\" width=\"16\" height=\"16\" border=\"0\" alt=\"Blank Color\"></td>";
//    LogContent(HTML);
    HTML = "                     <td class=\"darkgrey\" align=\"center\">"$MatchInfo.Score$"</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"darkgrey\" align=\"center\">"$MatchInfo.Kills-MatchInfo.Suicides$"</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"darkgrey\" align=\"center\">"$MatchInfo.Kills$"</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"darkgrey\" align=\"center\">"$MatchInfo.Deaths$"</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"darkgrey\" align=\"center\">"$MatchInfo.Suicides$"</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"darkgrey\" align=\"center\">"$FloatToStringRound(MatchInfo.AvgEff,1)$"</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"darkgrey\" align=\"center\">"$FloatToStringRound(MatchInfo.AvgSPH,1)$"</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"darkgrey\" align=\"center\">"$FloatToStringRound(MatchInfo.AvgTTL,1)$"</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"darkgrey\" align=\"center\">"$FloatToStringRound(MatchInfo.AvgTime/60,1)$"</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"darkgrey\" align=\"center\">"$GetNumberSprees(1)$"</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"darkgrey\" align=\"center\">"$GetNumberSprees(2)$"</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"darkgrey\" align=\"center\">"$GetNumberSprees(3)$"</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"darkgrey\" align=\"center\">"$GetNumberSprees(4)$"</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"darkgrey\" align=\"center\">"$GetNumberSprees(5)$"</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"darkgrey\" align=\"center\">"$GetNumberSprees(6)$"</td>";
    LogContent(HTML);
    HTML = "                   </tr>";
    LogContent(HTML);
    HTML = "                 </table>";
    LogContent(HTML);
    // !PLAYER SUMMARY BOX


    // SPECIAL EVENTS
    HTML = "                 <br>";
    LogContent(HTML);
    HTML = "                 <table cellpadding=\"1\" cellspacing=\"2\" border=\"0\">";
    LogContent(HTML);
    HTML = "                   <tr>";
    LogContent(HTML);
    HTML = "                     <td class=\"heading\" colspan=\"8\" align=\"center\">Special Events</td>";
    LogContent(HTML);
    HTML = "                   </tr>";
    LogContent(HTML);
    HTML = "                   <tr>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\" width=\"95\">Category</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\" width=\"95\">Value</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\" width=\"100\">Category</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\" width=\"45\">Value</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\" width=\"95\">Category</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\" width=\"45\">Value</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\" width=\"100\">Category</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\" width=\"45\">Value</td>";
    LogContent(HTML);
    HTML = "                   </tr>";
    LogContent(HTML);
    HTML = "                   <tr>";
    LogContent(HTML);
    HTML = "                     <td class=\"dark\" align=\"center\">First Blood</td>";
    LogContent(HTML);
    if (bFirstBlood)
        HTML = "                     <td class=\"grey\" align=\"center\">"$PlayerInfo[MatchInfo.FirstBloodID].PlayerName$"</td>";
    else
        HTML = "                     <td class=\"grey\" align=\"center\">&nbsp</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"dark\" align=\"center\">Head Shots</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"grey\" align=\"center\">"$MatchInfo.Headshots$"</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"dark\" align=\"center\">Roadkills</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"grey\" align=\"center\">"$MatchInfo.Roadkills$"</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"dark\" align=\"center\">Carjackings</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"grey\" align=\"center\">"$MatchInfo.Carjackings$"</td>";
    LogContent(HTML);
    HTML = "                   </tr>";
    LogContent(HTML);
    HTML = "                   <tr>";
    LogContent(HTML);
    HTML = "                     <td class=\"dark\" align=\"center\">Double Kills</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"grey\" align=\"center\">"$MatchInfo.multikill_1$"</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"dark\" align=\"center\">Multi Kills</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"grey\" align=\"center\">"$MatchInfo.multikill_2$"</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"dark\" align=\"center\">Mega Kills</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"grey\" align=\"center\">"$MatchInfo.multikill_3$"</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"dark\" align=\"center\">Ultra Kills</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"grey\" align=\"center\">"$MatchInfo.multikill_4$"</td>";
    LogContent(HTML);
    HTML = "                   </tr>";
    LogContent(HTML);
    HTML = "                   <tr>";
    LogContent(HTML);
    HTML = "                     <td class=\"dark\" align=\"center\">Monster Kills</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"grey\" align=\"center\">"$MatchInfo.multikill_5$"</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"dark\" align=\"center\">Ludicrous Kills</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"grey\" align=\"center\">"$MatchInfo.multikill_6$"</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"dark\" align=\"center\">Holy Shit Kills</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"grey\" align=\"center\">"$MatchInfo.multikill_7$"</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"dark\" align=\"center\">Failed Transloc</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"grey\" align=\"center\">"$MatchInfo.failedtransloc$"</td>";
    LogContent(HTML);
    HTML = "                   </tr>";
    LogContent(HTML);
    HTML = "                   <tr>";
    LogContent(HTML);
    HTML = "                     <td class=\"dark\" align=\"center\">Headhunter</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"grey\" align=\"center\">"$MatchInfo.Headhunter$"</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"dark\" align=\"center\">Flak Monkey</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"grey\" align=\"center\">"$MatchInfo.FlakMonkey$"</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"dark\" align=\"center\">Combo Whore</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"grey\" align=\"center\">"$MatchInfo.ComboWhore$"</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"dark\" align=\"center\">Road Rampage</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"grey\" align=\"center\">"$MatchInfo.RoadRampage$"</td>";
    LogContent(HTML);
    HTML = "                   </tr>";
    LogContent(HTML);
    HTML = "                 </table>";
    LogContent(HTML);
    // !SPECIAL EVENTS




    // PLAYER BY PLAYER KILL STATS
    PlayerArray = GetPlayerArrayByTeamAndScore();

    HTML = "                 <br>";
    LogContent(HTML);
    HTML = "                 <table cellpadding=\"1\" cellspacing=\"2\" border=\"0\" width=\""$245+(PlayerArray.Length*22)$"\">";
    LogContent(HTML);
    HTML = "                   <tr>";
    LogContent(HTML);
    HTML = "                     <td class=\"heading\" align=\"center\" colspan=\""$(PlayerArray.Length + 3)$"\">Kills Match Up</td>";
    LogContent(HTML);
    HTML = "                   </tr>";
    LogContent(HTML);
    HTML = "                   <tr>";
    LogContent(HTML);
    HTML = "                     <td class=\"dark\" align=\"center\" colspan=\"3\" rowspan=\"3\">&nbsp;</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"dark\" align=\"center\" colspan=\""$(PlayerArray.Length)$"\">Victim</td>";
    LogContent(HTML);
    HTML = "                   </tr>";
    LogContent(HTML);
    HTML = "                   <tr>";
    LogContent(HTML);

    for(i=0;i<PlayerArray.Length;i++)
    {
        HTML = "                     <td class=\""$GetNameColor(PlayerArray[i])$"\" align=\"center\">"$GetNameLinkStringVertical(PlayerArray[i])$"</td>";
        LogContent(HTML);
    }

    HTML = "                   </tr>";
    LogContent(HTML);
    HTML = "                   <tr>";
    LogContent(HTML);

    for(i=0;i<PlayerArray.Length;i++)
    {
        HTML = "                     <td class=\"";

        if(MatchInfo.bTeamGame)
        {
            if(PlayerInfo[PlayerArray[i]].TeamID == 0)
                HTML $= "redteam";
            else
                HTML $= "blueteam";
        } else {
            HTML $= "dark";
        }

        HTML $= "\" align=\"center\" width=\"20\">&nbsp;</td>";
        LogContent(HTML);
    }

    HTML = "                   </tr>";
    LogContent(HTML);
    HTML = "                   ";

    for(i=0;i<PlayerArray.Length;i++)
    {
        HTML = "                   <tr>";
        LogContent(HTML);

        if(i==0)
        {
            HTML = "                     <td class=\"dark\" align=\"center\" rowspan=\""$PlayerArray.Length$"\" width=\"20\">"$FormatStringVertical("Killer")$"</td>";
            LogContent(HTML);
        }

        HTML = "                     <td class=\""$GetNameColor(PlayerArray[i])$"\" align=\"center\">"$GetNameLinkString(PlayerArray[i])$"</td>";
        LogContent(HTML);


        HTML = "                     <td class=\"";
        if(MatchInfo.bTeamGame)
        {
            if(PlayerInfo[PlayerArray[i]].TeamID == 0)
                HTML $= "redteam";
            else
                HTML $= "blueteam";
        } else {
            HTML $= "dark";
        }
        HTML $= "\" align=\"center\" width=\"20\">&nbsp;</td>";
        LogContent(HTML);

        for(j=0;j<PlayerArray.length;j++)
        {
            HTML = "                     <td class=\"";
            if(i==j)
                HTML $= "darkgrey";
            else
                HTML $= "grey";
            HTML $= "\" align=\"center\" width=\"20\">";
            NumKills = GetNumKills(PlayerArray[i],PlayerArray[j]);
            if (NumKills == 0)
                HTML $= "&nbsp;";
            else
                HTML $= NumKills;
            HTML $= "</td>";
            LogContent(HTML);
        }

        HTML = "                   </tr>";
        LogContent(HTML);
    }

    HTML = "                 </table>";
    LogContent(HTML);
    // !PLAYER BY PLAYER KILL STATS


    // WEAPON STATS BLOCK
    HTML = "                 <br>";
    LogContent(HTML);
    HTML = "                 <table cellpadding=\"1\" cellspacing=\"2\" border=\"0\" width=\"595\">";
    LogContent(HTML);
    HTML = "                   <tr>";
    LogContent(HTML);
    HTML = "                     <td class=\"heading\" colspan=\"7\" align=\"center\">Weapon/Suicide Specific Information</td>";
    LogContent(HTML);
    HTML = "                   </tr>";
    LogContent(HTML);
    HTML = "                   <tr>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\">Weapon</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\" width=\"55\">Frags</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\" width=\"70\">Primary Kills</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\" width=\"70\">Secondary Kills</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\" width=\"55\">Deaths Holding</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\" width=\"55\">Suicides</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\" width=\"60\">Eff.</td>";
    LogContent(HTML);
    HTML = "                   </tr>";
    LogContent(HTML);

    WeaponArray = GetWeaponArrayByFrags(false);

    for(i=0;i<WeaponArray.Length;i++)
    {
        if (MatchInfo.Weapons[WeaponArray[i]].PrimaryKills + MatchInfo.Weapons[WeaponArray[i]].SecondaryKills + MatchInfo.Weapons[WeaponArray[i]].DeathsHolding + MatchInfo.Weapons[WeaponArray[i]].Suicides == 0)
            Eff = 0.0;
        else
            Eff = 1.f * (MatchInfo.Weapons[WeaponArray[i]].PrimaryKills + MatchInfo.Weapons[WeaponArray[i]].SecondaryKills) / (MatchInfo.Weapons[WeaponArray[i]].PrimaryKills + MatchInfo.Weapons[WeaponArray[i]].SecondaryKills + MatchInfo.Weapons[WeaponArray[i]].DeathsHolding + MatchInfo.Weapons[WeaponArray[i]].Suicides) * 100;

        HTML = "                   <tr>";
        LogContent(HTML);
        HTML = "                     <td class=\"dark\" align=\"center\">"$MatchInfo.Weapons[WeaponArray[i]].WeaponName$"</td>";
        LogContent(HTML);
        HTML = "                     <td class=\"grey\" align=\"center\">"$MatchInfo.Weapons[WeaponArray[i]].PrimaryKills + MatchInfo.Weapons[WeaponArray[i]].SecondaryKills - MatchInfo.Weapons[WeaponArray[i]].Suicides$"</td>";
        LogContent(HTML);
        HTML = "                     <td class=\"grey\" align=\"center\">"$MatchInfo.Weapons[WeaponArray[i]].PrimaryKills$"</td>";
        LogContent(HTML);
        HTML = "                     <td class=\"grey\" align=\"center\">"$MatchInfo.Weapons[WeaponArray[i]].SecondaryKills$"</td>";
        LogContent(HTML);
        HTML = "                     <td class=\"grey\" align=\"center\">"$MatchInfo.Weapons[WeaponArray[i]].DeathsHolding$"</td>";
        LogContent(HTML);
        HTML = "                     <td class=\"grey\" align=\"center\">"$MatchInfo.Weapons[WeaponArray[i]].Suicides$"</td>";
        LogContent(HTML);
        HTML = "                     <td class=\"grey\" align=\"center\">"$FloatToStringRound(Eff,1)$"%</td>";
        LogContent(HTML);
        HTML = "                   </tr>";
        LogContent(HTML);
    }
    HTML = "                 </table>";
    LogContent(HTML);
    // !WEAPON STATS BLOCK


    // VEHICLE STATS BLOCK
    HTML = "                 <br>";
    LogContent(HTML);
    HTML = "                 <table cellpadding=\"1\" cellspacing=\"2\" border=\"0\" width=\"595\">";
    LogContent(HTML);
    HTML = "                   <tr>";
    LogContent(HTML);
    HTML = "                     <td class=\"heading\" colspan=\"8\" align=\"center\">Vehicle and Turret Specific Information</td>";
    LogContent(HTML);
    HTML = "                   </tr>";
    LogContent(HTML);
    HTML = "                   <tr>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\">Vehicle/Turret</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\" width=\"55\">Frags</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\" width=\"70\">Primary Kills</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\" width=\"70\">Secondary Kills</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\" width=\"55\">Road Kills</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\" width=\"55\">Deaths In</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\" width=\"55\">Suicides</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\" width=\"60\">Eff.</td>";
    LogContent(HTML);
    HTML = "                   </tr>";
    LogContent(HTML);

    WeaponArray = GetWeaponArrayByFrags(true);

    for(i=0;i<WeaponArray.Length;i++)
    {
        if (MatchInfo.Weapons[WeaponArray[i]].PrimaryKills + MatchInfo.Weapons[WeaponArray[i]].SecondaryKills + MatchInfo.Weapons[WeaponArray[i]].DeathsHolding + MatchInfo.Weapons[WeaponArray[i]].Suicides == 0)
            Eff = 0.0;
        else
            Eff = 1.f * (MatchInfo.Weapons[WeaponArray[i]].PrimaryKills + MatchInfo.Weapons[WeaponArray[i]].SecondaryKills) / (MatchInfo.Weapons[WeaponArray[i]].PrimaryKills + MatchInfo.Weapons[WeaponArray[i]].SecondaryKills + MatchInfo.Weapons[WeaponArray[i]].DeathsHolding + MatchInfo.Weapons[WeaponArray[i]].Suicides) * 100;

        HTML = "                   <tr>";
        LogContent(HTML);
        HTML = "                     <td class=\"dark\" align=\"center\">"$MatchInfo.Weapons[WeaponArray[i]].WeaponName$"</td>";
        LogContent(HTML);
        HTML = "                     <td class=\"grey\" align=\"center\">"$MatchInfo.Weapons[WeaponArray[i]].PrimaryKills + MatchInfo.Weapons[WeaponArray[i]].SecondaryKills + MatchInfo.Weapons[WeaponArray[i]].Roadkills - MatchInfo.Weapons[WeaponArray[i]].Suicides$"</td>";
        LogContent(HTML);
        HTML = "                     <td class=\"grey\" align=\"center\">"$MatchInfo.Weapons[WeaponArray[i]].PrimaryKills$"</td>";
        LogContent(HTML);
        HTML = "                     <td class=\"grey\" align=\"center\">"$MatchInfo.Weapons[WeaponArray[i]].SecondaryKills$"</td>";
        LogContent(HTML);
        HTML = "                     <td class=\"grey\" align=\"center\">"$MatchInfo.Weapons[WeaponArray[i]].Roadkills$"</td>";
        LogContent(HTML);
        HTML = "                     <td class=\"grey\" align=\"center\">"$MatchInfo.Weapons[WeaponArray[i]].DeathsHolding$"</td>";
        LogContent(HTML);
        HTML = "                     <td class=\"grey\" align=\"center\">"$MatchInfo.Weapons[WeaponArray[i]].Suicides$"</td>";
        LogContent(HTML);
        HTML = "                     <td class=\"grey\" align=\"center\">"$FloatToStringRound(Eff,1)$"%</td>";
        LogContent(HTML);
        HTML = "                   </tr>";
        LogContent(HTML);
    }
    HTML = "                 </table>";
    LogContent(HTML);
    // !VEHICLE STATS BLOCK

    // KILLING SPREES BLOCK
    HTML = "                 <br>";
    LogContent(HTML);
    HTML = "                 <table cellpadding=\"1\" cellspacing=\"2\" border=\"0\" width=\"680\">";
    LogContent(HTML);
    HTML = "                   <tr>";
    LogContent(HTML);
    HTML = "                     <td class=\"heading\" colspan=\"6\" align=\"center\">Killing Sprees</td>";
    LogContent(HTML);
    HTML = "                   </tr>";
    LogContent(HTML);
    HTML = "                   <tr>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\">Player</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\" width=\"90\">Spree Type</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\" width=\"45\">Start Time</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\" width=\"55\">Time In Spree</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\" width=\"80\">Kills During Spree</td>";
    LogContent(HTML);
    HTML = "                     <td class=\"smheading\" align=\"center\">Reason Spree Stopped</td>";
    LogContent(HTML);
    HTML = "                   </tr>";
    LogContent(HTML);

    SpreeArray = GetSpreesByTime();
    for(i=0;i<SpreeArray.Length;i++)
    {
        SpreePlayer = MatchInfo.Sprees[SpreeArray[i]].Player;
        SpreeID = MatchInfo.Sprees[SpreeArray[i]].Spree;

        HTML = "                   <tr>";
        LogContent(HTML);
        HTML = "                     <td class=\""$GetNameColor(SpreePlayer)$"\" align=\"center\">"$GetNameLinkString(SpreePlayer)$"</td>";
        LogContent(HTML);
        HTML = "                     <td class=\"dark\" align=\"center\">"$GetSpreeName(PlayerInfo[SpreePlayer].Sprees[SpreeID].SpreeLevel)$"</td>";
        LogContent(HTML);
        HTML = "                     <td class=\"grey\" align=\"center\">"$FloatToStringRound(PlayerInfo[SpreePlayer].Sprees[SpreeID].TimeSpreeStarted/60,1)$"</td>";
        LogContent(HTML);
        HTML = "                     <td class=\"grey\" align=\"center\">"$FloatToStringRound(PlayerInfo[SpreePlayer].Sprees[SpreeID].TimeInSpree,1)$"</td>";
        LogContent(HTML);
        HTML = "                     <td class=\"grey\" align=\"center\">"$PlayerInfo[SpreePlayer].Sprees[SpreeID].KillsInSpree$"</td>";
        LogContent(HTML);
        HTML = "                     <td class=\"grey\" align=\"center\">"$PlayerInfo[SpreePlayer].Sprees[SpreeID].SpreeEndReason$"</td>";
        LogContent(HTML);
        HTML = "                   </tr>";
        LogContent(HTML);
    }
    HTML = "                 </table>";
    LogContent(HTML);
    // !KILLING SPREES BLOCK

}



// *******************************
// *HTML LOGGING HELPER VARIABLES*
// *******************************

function GetCareerHighsRecord(OLStatsDataHolder.CareerHighRecord CareerHigh,out string PlayerString,out string ClassName,out int Score,out int NumMatches,out float Hours)
{
    local int i;
    local int PlayerPointer;

    PlayerString = "&nbsp;";
    ClassName = "dark";
    Score = 0;
    NumMatches = 0;
    Hours = 0.0;

    if(CareerHigh.Score == 0)
        return;

    PlayerPointer = -1;
    for(i=0;i<Players.Length;i++)
    {
        if(Players[i].PlayerID == CareerHigh.Player)
        {
            PlayerPointer = i;
            break;
        }
    }

    if(PlayerPointer == -1)
        return;

    PlayerString = GetGlobalPlayerNameLinkString(PlayerPointer);
    ClassName = GetGlobalPlayerNameColor(PlayerPointer);
    Score = CareerHigh.Score;
    NumMatches = Players[PlayerPointer].NumMatches;
    Hours = Players[PlayerPointer].Time / 3600;
    return;
}

function GetCareerHighsRecordFloat(OLStatsDataHolder.CareerHighRecordFloat CareerHigh,out string PlayerString,out string ClassName,out float ScoreFloat,out int NumMatches,out float Hours)
{
    local int i;
    local int PlayerPointer;

    PlayerString = "&nbsp;";
    ClassName = "dark";
    ScoreFloat = 0.0;
    NumMatches = 0;
    Hours = 0.0;

    if(CareerHigh.Score == 0)
        return;

    PlayerPointer = -1;
    for(i=0;i<Players.Length;i++)
    {
        if(Players[i].PlayerID == CareerHigh.Player)
        {
            PlayerPointer = i;
            break;
        }
    }

    if(PlayerPointer == -1)
        return;

    PlayerString = GetGlobalPlayerNameLinkString(PlayerPointer);
    ClassName = GetGlobalPlayerNameColor(PlayerPointer);
    ScoreFloat = CareerHigh.Score;
    NumMatches = Players[PlayerPointer].NumMatches;
    Hours = Players[PlayerPointer].Time / 3600;
    return;
}

function GetMatchHighsRecord(OLStatsDataHolder.MatchHighRecord MatchHigh,out string PlayerString,out string ClassName,out int Score,out float Time,out string MapName,out string MatchDateString)
{
    local int i;
    local int PlayerPointer;
    local int MatchPointer;

    PlayerString = "&nbsp;";
    MatchDateString = "&nbsp;";
    MapName = "&nbsp;";
    ClassName = "dark";
    Score = 0;
    Time = 0.0;

    if(MatchHigh.Score == 0)
        return;

    PlayerPointer = -1;
    for(i=0;i<Players.Length;i++)
    {
        if(Players[i].PlayerID == MatchHigh.Player)
        {
            PlayerPointer = i;
            break;
        }
    }

    MatchPointer = -1;
    for(i=0;i<Matches.Length;i++)
    {
        if(Matches[i].MatchID == MatchHigh.MatchID)
        {
            MatchPointer = i;
            break;
        }
    }

    if(PlayerPointer == -1 || MatchPointer == -1)
        return;

    PlayerString = GetGlobalPlayerNameLinkString(PlayerPointer);
    ClassName = GetGlobalPlayerNameColor(PlayerPointer);
    Score = MatchHigh.Score;
    Time = Matches[MatchPointer].MatchTime / 60;
    MapName = Matches[MatchPointer].MapName;
    MatchDateString = GetMatchDateLinkString(MatchPointer);
    return;
}

function array<int> GetCareerHighWeaponArrayByScore(array<OLStatsDataHolder.CareerHighWeaponRecord> Records)
{
    local int i, iscore;
    local int j, jscore;
    local int temp;
    local array<int> WeaponArray;

    for(i=0;i<Records.length;i++)
        WeaponArray[WeaponArray.Length] = i;

    for(i=0;i<WeaponArray.Length-1;i++)
    {
        for(j=i+1;j<WeaponArray.Length;j++)
        {
            iscore = Records[WeaponArray[i]].Score;
            jscore = Records[WeaponArray[j]].Score;
            if (iscore < jscore)
            {
                temp = WeaponArray[j];
                WeaponArray[j] = WeaponArray[i];
                WeaponArray[i] = temp;
            }
        }
    }

    return WeaponArray;
}

function array<int> GetMatchHighWeaponArrayByScore(array<OLStatsDataHolder.MatchHighWeaponRecord> Records)
{
    local int i, iscore;
    local int j, jscore;
    local int temp;
    local array<int> WeaponArray;

    for(i=0;i<Records.length;i++)
        WeaponArray[WeaponArray.Length] = i;

    for(i=0;i<WeaponArray.Length-1;i++)
    {
        for(j=i+1;j<WeaponArray.Length;j++)
        {
            iscore = Records[WeaponArray[i]].Score;
            jscore = Records[WeaponArray[j]].Score;
            if (iscore < jscore)
            {
                temp = WeaponArray[j];
                WeaponArray[j] = WeaponArray[i];
                WeaponArray[i] = temp;
            }
        }
    }

    return WeaponArray;
}

function GetCareerHighWeaponRecord(OLStatsDataHolder.CareerHighWeaponRecord WeaponRecord,out string PlayerString,out string ClassName,out int Score,out int NumMatches,out float Hours,out string WeaponName)
{
    local int i;
    local int PlayerPointer;

    PlayerPointer = -1;
    for(i=0;i<Players.Length;i++)
    {
        if(Players[i].PlayerID == WeaponRecord.Player)
        {
            PlayerPointer = i;
            break;
        }
    }

    if(PlayerPointer == -1)
    {
        PlayerString = "&nbsp;";
        ClassName = "dark";
        Score = 0;
        NumMatches = 0;
        Hours = 0.0;
        return;
    }

    PlayerString = GetGlobalPlayerNameLinkString(PlayerPointer);
    ClassName = GetGlobalPlayerNameColor(PlayerPointer);
    Score = WeaponRecord.Score;
    NumMatches = Players[PlayerPointer].NumMatches;
    Hours = Players[PlayerPointer].Time / 3600;
    WeaponName = WeaponRecord.WeaponName;
    return;
}

function GetMatchHighWeaponRecord(OLStatsDataHolder.MatchHighWeaponRecord WeaponRecord,out string WeaponName,out string PlayerString,out string ClassName,out int Score,out float Time,out string MapName,out string MatchDateString)
{
    local int i;
    local int PlayerPointer, MatchPointer;

    WeaponName = WeaponRecord.WeaponName;

    PlayerPointer = -1;
    for(i=0;i<Players.Length;i++)
    {
        if(Players[i].PlayerID == WeaponRecord.Player)
        {
            PlayerPointer = i;
            break;
        }
    }

    MatchPointer = -1;
    for(i=0;i<Matches.Length;i++)
    {
        if(Matches[i].MatchID == WeaponRecord.MatchID)
        {
            MatchPointer = i;
            break;
        }
    }

    if(PlayerPointer == -1 || MatchPointer == -1)
    {
        PlayerString = "&nbsp;";
        MatchDateString = "&nbsp;";
        MapName = "&nbsp;";
        ClassName = "dark";
        Score = 0;
        Time = 0.0;
        return;
    }

    PlayerString = GetGlobalPlayerNameLinkString(PlayerPointer);
    MatchDateString = GetMatchDateLinkString(MatchPointer);
    ClassName = GetGlobalPlayerNameColor(PlayerPointer);
    Score = WeaponRecord.Score;
    MapName = Matches[MatchPointer].MapName;
    Time = Matches[MatchPointer].MatchTime / 60;
    return;
}

function array<PlayerTeamRecord> GetTeamArray(int TeamID)
{
    local array<PlayerTeamRecord> TeamArray;
    local int i;
    local int j;
    local int k;

    for(i=0;i<PlayerInfo.length;i++)
    {
        for(j=0;j<PlayerInfo[i].ITS.length;j++)
        {
            if(PlayerInfo[i].ITS[j].TeamID == TeamID)
            {
                k = TeamArray.length;
                TeamArray.length = k + 1;
                TeamArray[k].Player = i;
                TeamArray[k].Team = j;
            }
        }
    }

    return TeamArray;
}

function array<PlayerTeamRecord> SortTeamArrayByScore(array<PlayerTeamRecord> TeamArray)
{
    local int i, j;
    local int iscore, jscore;
    local PlayerTeamRecord temp;

    for(i=0;i<TeamArray.Length-1;i++)
    {
        for(j=i+1;j<TeamArray.Length;j++)
        {
            iscore = PlayerInfo[TeamArray[i].Player].ITS[TeamArray[i].Team].Score;
            jscore = PlayerInfo[TeamArray[j].Player].ITS[TeamArray[j].Team].Score;
            if( iscore < jscore )
            {
                temp = TeamArray[j];
                TeamArray[j] = TeamArray[i];
                TeamArray[i] = temp;
            }
        }
    }

    return TeamArray;
}

function array<int> GetGlobalPlayerArrayByFrags()
{
    local int i, j;
    local array<int> PlayerArray;
    local int iscore, jscore;
    local int temp;

    for(i=0;i<Players.length;i++)
    {
        PlayerArray[PlayerArray.length] = i;
    }

    for(i=0;i<Players.Length-1;i++)
    {
        for(j=i+1;j<Players.Length;j++)
        {
            iscore = Players[PlayerArray[i]].Kills - Players[PlayerArray[i]].Suicides;
            jscore = Players[PlayerArray[j]].Kills - Players[PlayerArray[j]].Suicides;
            if( iscore < jscore )
            {
                temp = PlayerArray[j];
                PlayerArray[j] = PlayerArray[i];
                PlayerArray[i] = temp;
            }
        }
    }

    return PlayerArray;
}

function array<int> GetPlayerArrayByScore()
{
    local int i, j;
    local array<int> PlayerArray;
    local int iscore, jscore;
    local int temp;

    for(i=0;i<PlayerInfo.length;i++)
    {
        PlayerArray[PlayerArray.length] = i;
    }

    for(i=0;i<PlayerArray.Length-1;i++)
    {
        for(j=i+1;j<PlayerArray.Length;j++)
        {
            iscore = PlayerInfo[PlayerArray[i]].Score;
            jscore = PlayerInfo[PlayerArray[j]].Score;
            if( iscore < jscore )
            {
                temp = PlayerArray[j];
                PlayerArray[j] = PlayerArray[i];
                PlayerArray[i] = temp;
            }
        }
    }

    return PlayerArray;
}

function array<int> GetPlayerArrayByTeamAndScore()
{
    local int i,j;
    local array<int> PlayerArray;
    local int iteam, jteam, iscore, jscore;
    local int temp;

    for(i=0;i<PlayerInfo.length;i++)
    {
        PlayerArray[PlayerArray.length] = i;
    }

    for(i=0;i<PlayerArray.Length-1;i++)
    {
        for(j=i+1;j<PlayerArray.Length;j++)
        {
            iscore = PlayerInfo[PlayerArray[i]].Score;
            jscore = PlayerInfo[PlayerArray[j]].Score;
            iteam = PlayerInfo[PlayerArray[i]].TeamID;
            jteam = PlayerInfo[PlayerArray[j]].TeamID;
            if( (iteam < jteam) || (iteam == jteam && iscore < jscore) )
            {
                temp = PlayerArray[j];
                PlayerArray[j] = PlayerArray[i];
                PlayerArray[i] = temp;
            }
        }
    }

    return PlayerArray;
}

function array<int> GetWeaponArrayByFrags(optional bool bVehicles)
{
    local int i, j;
    local array<int> WeaponArray;
    local int temp, ifrags, jfrags;

    for(i=0;i<MatchInfo.Weapons.Length;i++)
    {
        if (bVehicles && (MatchInfo.Weapons[i].WeaponType == 1 || MatchInfo.Weapons[i].WeaponType == 2))
            WeaponArray[WeaponArray.Length] = i;
        else if (!bVehicles && (MatchInfo.Weapons[i].WeaponType == 0))
            WeaponArray[WeaponArray.Length] = i;
    }

    for(i=0;i<WeaponArray.Length-1;i++)
    {
        for(j=i+1;j<WeaponArray.Length;j++)
        {
            ifrags = MatchInfo.Weapons[WeaponArray[i]].PrimaryKills + MatchInfo.Weapons[WeaponArray[i]].SecondaryKills + MatchInfo.Weapons[WeaponArray[i]].Roadkills - MatchInfo.Weapons[WeaponArray[i]].Suicides;
            jfrags = MatchInfo.Weapons[WeaponArray[j]].PrimaryKills + MatchInfo.Weapons[WeaponArray[j]].SecondaryKills + MatchInfo.Weapons[WeaponArray[j]].Roadkills - MatchInfo.Weapons[WeaponArray[j]].Suicides;
            if( ifrags < jfrags )
            {
                temp = WeaponArray[j];
                WeaponArray[j] = WeaponArray[i];
                WeaponArray[i] = temp;
            }
        }
    }

    return WeaponArray;
}

function array<int> GetIndividualWeaponArrayByFrags(int Player, optional bool bVehicles)
{
    local int i, j;
    local array<int> WeaponArray;
    local int temp, ifrags, jfrags;

    for(i=0;i<PlayerInfo[Player].Weapons.Length;i++)
    {
        if (bVehicles && (PlayerInfo[Player].Weapons[i].WeaponType == 1 || PlayerInfo[Player].Weapons[i].WeaponType == 2))
            WeaponArray[WeaponArray.Length] = i;
        else if (!bVehicles && (PlayerInfo[Player].Weapons[i].WeaponType == 0))
            WeaponArray[WeaponArray.Length] = i;
    }

    for(i=0;i<WeaponArray.Length-1;i++)
    {
        for(j=i+1;j<WeaponArray.Length;j++)
        {
            ifrags = PlayerInfo[Player].Weapons[WeaponArray[i]].PrimaryKills + PlayerInfo[Player].Weapons[WeaponArray[i]].SecondaryKills + PlayerInfo[Player].Weapons[WeaponArray[i]].Roadkills - PlayerInfo[Player].Weapons[WeaponArray[i]].Suicides;
            jfrags = PlayerInfo[Player].Weapons[WeaponArray[j]].PrimaryKills + PlayerInfo[Player].Weapons[WeaponArray[j]].SecondaryKills + PlayerInfo[Player].Weapons[WeaponArray[j]].Roadkills - PlayerInfo[Player].Weapons[WeaponArray[j]].Suicides;
            if( ifrags < jfrags )
            {
                temp = WeaponArray[j];
                WeaponArray[j] = WeaponArray[i];
                WeaponArray[i] = temp;
            }
        }
    }

    return WeaponArray;
}

function array<int> GetTotalsWeaponArrayByFrags(optional bool bVehicles)
{
    local int i, j;
    local array<int> WeaponArray;
    local int temp, ifrags, jfrags;

    for(i=0;i<Totals.TotalStats.Weapons.Length;i++)
    {
        if (bVehicles && (Totals.TotalStats.Weapons[i].WeaponType == 1 || Totals.TotalStats.Weapons[i].WeaponType == 2))
            WeaponArray[WeaponArray.Length] = i;
        else if (!bVehicles && (Totals.TotalStats.Weapons[i].WeaponType == 0))
            WeaponArray[WeaponArray.Length] = i;
    }

    for(i=0;i<WeaponArray.Length-1;i++)
    {
        for(j=i+1;j<WeaponArray.Length;j++)
        {
            ifrags = Totals.TotalStats.Weapons[WeaponArray[i]].PrimaryKills + Totals.TotalStats.Weapons[WeaponArray[i]].SecondaryKills + Totals.TotalStats.Weapons[WeaponArray[i]].Roadkills - Totals.TotalStats.Weapons[WeaponArray[i]].Suicides;
            jfrags = Totals.TotalStats.Weapons[WeaponArray[j]].PrimaryKills + Totals.TotalStats.Weapons[WeaponArray[j]].SecondaryKills + Totals.TotalStats.Weapons[WeaponArray[j]].Roadkills - Totals.TotalStats.Weapons[WeaponArray[j]].Suicides;
            if( ifrags < jfrags )
            {
                temp = WeaponArray[j];
                WeaponArray[j] = WeaponArray[i];
                WeaponArray[i] = temp;
            }
        }
    }

    return WeaponArray;
}

function array<int> GetGlobalPlayerWeaponArrayByFrags(int Player, optional bool bVehicles)
{
    local int i, j;
    local array<int> WeaponArray;
    local int temp, ifrags, jfrags;

    for(i=0;i<Players[Player].Weapons.Length;i++)
    {
        if (bVehicles && (Players[Player].Weapons[i].WeaponType == 1 || Players[Player].Weapons[i].WeaponType == 2))
            WeaponArray[WeaponArray.Length] = i;
        else if (!bVehicles && (Players[Player].Weapons[i].WeaponType == 0))
            WeaponArray[WeaponArray.Length] = i;
    }

    for(i=0;i<WeaponArray.Length-1;i++)
    {
        for(j=i+1;j<WeaponArray.Length;j++)
        {
            ifrags = Players[Player].Weapons[WeaponArray[i]].PrimaryKills + Players[Player].Weapons[WeaponArray[i]].SecondaryKills + Players[Player].Weapons[WeaponArray[i]].Roadkills - Players[Player].Weapons[WeaponArray[i]].Suicides;
            jfrags = Players[Player].Weapons[WeaponArray[j]].PrimaryKills + Players[Player].Weapons[WeaponArray[j]].SecondaryKills + Players[Player].Weapons[WeaponArray[j]].Roadkills - Players[Player].Weapons[WeaponArray[j]].Suicides;
            if( ifrags < jfrags )
            {
                temp = WeaponArray[j];
                WeaponArray[j] = WeaponArray[i];
                WeaponArray[i] = temp;
            }
        }
    }

    return WeaponArray;
}

function array<int> GetTotalsWeaponArrayBySuicides()
{
    local int i, j;
    local array<int> WeaponArray;
    local int temp, ifrags, jfrags;

    for(i=0;i<Totals.TotalStats.Weapons.Length;i++)
    {
        if (Totals.TotalStats.Weapons[i].Suicides > 0)
            WeaponArray[WeaponArray.Length] = i;
    }

    for(i=0;i<WeaponArray.Length-1;i++)
    {
        for(j=i+1;j<WeaponArray.Length;j++)
        {
            ifrags = Totals.TotalStats.Weapons[WeaponArray[i]].Suicides;
            jfrags = Totals.TotalStats.Weapons[WeaponArray[j]].Suicides;
            if( ifrags < jfrags )
            {
                temp = WeaponArray[j];
                WeaponArray[j] = WeaponArray[i];
                WeaponArray[i] = temp;
            }
        }
    }

    return WeaponArray;
}

// ******************
// *STRING FUNCTIONS*
// ******************

function string GetDateTimeString()
{
    local string out;
    out = class'OLLocalGameStats'.default.DateTimeFormat;
    return FormatDateTimeString(out);
}

function string GetDateString()
{
    local string out;
    out = class'OLLocalGameStats'.default.DateFormat;
    return FormatDateTimeString(out);
}

function string FormatDateTimeString(string out)
{
    local string ampm;
    local string ampmcap;
    local int hourampm;


    if(Level.Hour >= 12)
    {
        ampm = "pm";
        ampmcap = "PM";
    } else {
        ampm = "am";
        ampmcap = "AM";
    }

    if(Level.Hour == 0)
        hourampm = 12;
    else if (Level.Hour < 13)
        hourampm = Level.Hour;
    else
        hourampm = Level.Hour - 12;

    ReplaceText(out, "%Y", Right("0000"$string(Level.Year), 4));
    ReplaceText(out, "%M", Right("00"$string(Level.Month), 2));
    ReplaceText(out, "%F", GetMonthName(Level.Month));
    ReplaceText(out, "%f", GetShortMonthName(Level.Month));
    ReplaceText(out, "%D", Right("00"$string(Level.Day), 2));
    ReplaceText(out, "%H", Right("00"$string(Level.Hour), 2));
    ReplaceText(out, "%h", Right("00"$string(hourampm), 2));
    ReplaceText(out, "%G", string(Level.Hour));
    ReplaceText(out, "%g", string(hourampm));
    ReplaceText(out, "%I", Right("00"$string(Level.Minute), 2));
    ReplaceText(out, "%W", Right("0"$string(Level.DayOfWeek), 1));
    ReplaceText(out, "%E", GetDayOfWeekName(Level.DayOfWeek));
    ReplaceText(out, "%e", GetShortDayOfWeekName(Level.DayOfWeek));
    ReplaceText(out, "%S", Right("00"$string(Level.Second), 2));
    ReplaceText(out, "%A", ampmcap);
    ReplaceText(out, "%a", ampm);

    return out;
}

function string GetSpreeName(int SpreeLevel)
{
    switch(SpreeLevel)
    {
        case 1:
            return "Killing Spree";
            break;
        case 2:
            return "Rampage";
            break;
        case 3:
            return "Dominating";
            break;
        case 4:
            return "Unstoppable";
            break;
        case 5:
            return "Godlike!";
            break;
        case 6:
        default:
            return "Wicked Sick!";
            break;
    }
}

function string GetDifficultyName(int Difficulty)
{
    switch(Difficulty)
    {
        case 0:
            return "Novice";
        case 1:
            return "Average";
        case 2:
            return "Experienced";
        case 3:
            return "Skilled";
        case 4:
            return "Adept";
        case 5:
            return "Masterful";
        case 6:
            return "Inhuman";
        case 7:
        default:
            return "Godlike";
    }
}

function string GetDayOfWeekName(int DayOfWeek)
{
    switch(DayOfWeek)
    {
        case 1:
            return "Monday";
        case 2:
            return "Tuesday";
        case 3:
            return "Wednesday";
        case 4:
            return "Thursday";
        case 5:
            return "Friday";
        case 6:
            return "Saturday";
        case 7:
            return "Sunday";
    }
}

function string GetShortDayOfWeekName(int DayOfWeek)
{
    switch(DayOfWeek)
    {
        case 0:
            return "Sun";
        case 1:
            return "Mon";
        case 2:
            return "Tue";
        case 3:
            return "Wed";
        case 4:
            return "Thu";
        case 5:
            return "Fri";
        case 6:
            return "Sat";
    }
}

function string GetMonthName(int Month)
{
    switch(Month)
    {
        case 1:
            return "January";
        case 2:
            return "February";
        case 3:
            return "March";
        case 4:
            return "April";
        case 5:
            return "May";
        case 6:
            return "June";
        case 7:
            return "July";
        case 8:
            return "August";
        case 9:
            return "September";
        case 10:
            return "October";
        case 11:
            return "November";
        case 12:
            return "December";
    }
}

function string GetShortMonthName(int Month)
{
    switch(Month)
    {
        case 1:
            return "Jan";
        case 2:
            return "Feb";
        case 3:
            return "Mar";
        case 4:
            return "Apr";
        case 5:
            return "May";
        case 6:
            return "Jun";
        case 7:
            return "Jul";
        case 8:
            return "Aug";
        case 9:
            return "Sep";
        case 10:
            return "Oct";
        case 11:
            return "Nov";
        case 12:
            return "Dec";
    }
}

function string GetMatchDateLinkString(int Match)
{
    return "<a class=\"grey\" href=\""$Matches[Match].FileName$"\">"$Matches[Match].Date$"</a>";
}

function string YesOrNo(bool bBool)
{
    if (bBool)
        return "Yes";
    else
        return "No";
}

function string FormatStringVertical(string TheString)
{
    local int i;
    local string out, br;

    out = "";
    br = "";

    for(i=0;i<len(TheString);i++)
    {
        out $= br $ mid(TheString,i,1);
        br = "<BR>";
    }

    return out;
}

function string GetGlobalPlayerNameColor(int player)
{
    if(Players[Player].bBot)
        return "darkbot";
    else
        return "darkhuman";
}

function string GetGlobalPlayerNameLinkString(int player, optional bool bUseID)
{
    local string out;

    out = "<a class=\""$GetGlobalPlayerNameColor(player)$"\" href=\"OLStatsPlayer"$player$".html\">"$Players[player].PlayerName;
    if (bUseID)
        out $=" ["$Players[player].PlayerID$"]";
    out $= "</a>";

    return out;
}

function string GetNameColor(int player)
{
    if(PlayerInfo[Player].bBot)
        return "darkbot";
    else
        return "darkhuman";
}

function string GetNameLinkString(int player)
{
    local string out;

    out = "<a class=\""$GetNameColor(player)$"\" href=\"?func=PlayerStats&id="$player$"\">"$PlayerInfo[player].PlayerName$"</a>";

    return out;
}

function string GetNameLinkStringVertical(int player)
{
    local string out;

    out = "<a class=\""$GetNameColor(player)$"\" href=\"?func=PlayerStats&id="$player$"\">"$FormatStringVertical(PlayerInfo[player].PlayerName)$"</a>";

    return out;
}

// *******************
// *GENERAL FUNCTIONS*
// *******************

// Log a string to the current open log file, but
// first replace all instances of " with &quot;
function LogContent(string data)
{
    ReplaceChar(data,"\"","&quot;");
    Logf(data);
}

// Log a string to the current open log file
function Logf(string data)
{
    if(TempLog != none)
        TempLog.logf(data);
}

/**
    replace part of a string
*/
static function ReplaceChar(out string instring, string from, string to)
{
    local int i;
    local string src;
    src = instring;
    instring = "";
    i = InStr(src, from);
    while (i > -1)
    {
        instring = instring$Left(src, i)$to;
        src = Mid(src, i+Len(from));
        i = InStr(src, from);
    }
    instring = instring$src;
}

DefaultProperties
{
    LastMatchID = -1
    LastPlayerID = -1
}
